/* baobab-chart.c generated by valac 0.56.18, the Vala compiler
 * generated from baobab-chart.vala, do not modify */

/* -*- tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/* Baobab - disk usage analyzer
 *
 * Copyright (C) 2006, 2007, 2008  Igalia
 * Copyright (C) 2013  Stefano Facchini <stefano.facchini@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor,
 * Boston, MA  02110-1301  USA
 *
 * Authors of the original code:
 *   Felipe Erias <femorandeira@igalia.com>
 *   Pablo Santamaria <psantamaria@igalia.com>
 *   Jacobo Aragunde <jaragunde@igalia.com>
 *   Eduardo Lima <elima@igalia.com>
 *   Mario Sanchez <msanchez@igalia.com>
 *   Miguel Gomez <magomez@igalia.com>
 *   Henrique Ferreiro <hferreiro@igalia.com>
 *   Alejandro Pinheiro <apinheiro@igalia.com>
 *   Carlos Sanmartin <csanmartin@igalia.com>
 *   Alejandro Garcia <alex@igalia.com>
 */

#include "baobab.h"
#include <glib-object.h>
#include <gobject/gvaluecollector.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>

#define BAOBAB_CHART_NUM_COLORS 6
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _BaobabParamSpecChartItem BaobabParamSpecChartItem;
enum  {
	BAOBAB_CHART_0_PROPERTY,
	BAOBAB_CHART_LOCATION_PROPERTY,
	BAOBAB_CHART_MAX_DEPTH_PROPERTY,
	BAOBAB_CHART_MODEL_PROPERTY,
	BAOBAB_CHART_TREE_ROOT_PROPERTY,
	BAOBAB_CHART_HIGHLIGHTED_ITEM_PROPERTY,
	BAOBAB_CHART_NUM_PROPERTIES
};
static GParamSpec* baobab_chart_properties[BAOBAB_CHART_NUM_PROPERTIES];
#define _baobab_location_unref0(var) ((var == NULL) ? NULL : (var = (baobab_location_unref (var), NULL)))
#define _baobab_chart_item_unref0(var) ((var == NULL) ? NULL : (var = (baobab_chart_item_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	BAOBAB_CHART_ITEM_ACTIVATED_SIGNAL,
	BAOBAB_CHART_NUM_SIGNALS
};
static guint baobab_chart_signals[BAOBAB_CHART_NUM_SIGNALS] = {0};

struct _BaobabParamSpecChartItem {
	GParamSpec parent_instance;
};

struct _BaobabChartPrivate {
	gboolean model_changed;
	GtkPopoverMenu* context_menu;
	GtkEventControllerScroll* scroll_controller;
	GtkEventControllerMotion* motion_controller;
	GtkGestureClick* primary_click_gesture;
	GtkGestureClick* secondary_click_gesture;
	GtkGestureClick* middle_click_gesture;
	GdkRGBA chart_colors[BAOBAB_CHART_NUM_COLORS];
	GList* items;
	BaobabLocation* location_;
	guint max_depth_;
	GtkTreeListModel* model_;
	BaobabScannerResults* root_;
	BaobabChartItem* highlighted_item_;
	GSimpleActionGroup* action_group;
};

static gpointer baobab_chart_item_parent_class = NULL;
static gint BaobabChart_private_offset;
static gpointer baobab_chart_parent_class = NULL;

static void baobab_chart_item_finalize (BaobabChartItem * obj);
static GType baobab_chart_item_get_type_once (void);
static void _baobab_chart_open_file_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self);
static void _baobab_chart_copy_path_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self);
static void _baobab_chart_trash_file_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self);
static void _baobab_chart_move_up_root_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self);
static void _baobab_chart_zoom_in_gsimple_action_activate_callback (GSimpleAction* action,
                                                             GVariant* parameter,
                                                             gpointer self);
static void _baobab_chart_zoom_out_gsimple_action_activate_callback (GSimpleAction* action,
                                                              GVariant* parameter,
                                                              gpointer self);
static void _baobab_chart_item_unref0_ (gpointer var);
static inline void _g_list_free__baobab_chart_item_unref0_ (GList* self);
static void baobab_chart_real_post_draw (BaobabChart* self,
                                  cairo_t* cr);
static void baobab_chart_real_draw_item (BaobabChart* self,
                                  cairo_t* cr,
                                  BaobabChartItem* item,
                                  gboolean highlighted);
static void baobab_chart_real_calculate_item_geometry (BaobabChart* self,
                                                BaobabChartItem* item);
static gboolean baobab_chart_real_is_point_over_item (BaobabChart* self,
                                               BaobabChartItem* item,
                                               gdouble x,
                                               gdouble y);
static void baobab_chart_real_get_item_rectangle (BaobabChart* self,
                                           BaobabChartItem* item);
static gboolean baobab_chart_real_can_zoom_in (BaobabChart* self);
static gboolean baobab_chart_real_can_zoom_out (BaobabChart* self);
static BaobabChartItem* baobab_chart_real_create_new_chartitem (BaobabChart* self);
static void baobab_chart_real_size_allocate (GtkWidget* base,
                                      gint width,
                                      gint height,
                                      gint baseline);
static gboolean baobab_chart_highlight_item_at_point (BaobabChart* self,
                                               gdouble x,
                                               gdouble y);
static void baobab_chart_motion_cb (BaobabChart* self,
                             gdouble x,
                             gdouble y);
static void baobab_chart_enter_cb (BaobabChart* self,
                            gdouble x,
                            gdouble y);
static GList* baobab_chart_add_item (BaobabChart* self,
                              guint depth,
                              gdouble rel_start,
                              gdouble rel_size,
                              BaobabScannerResults* results);
static void baobab_chart_get_items (BaobabChart* self,
                             BaobabScannerResults* root_path);
static gint _____lambda14_ (BaobabChart* self,
                     BaobabScannerResults* a,
                     BaobabScannerResults* b);
static gint ______lambda14__gcompare_data_func (gconstpointer a,
                                         gconstpointer b,
                                         gpointer self);
static void baobab_chart_draw_chart (BaobabChart* self,
                              cairo_t* cr);
static void baobab_chart_update_draw (BaobabChart* self);
static void baobab_chart_items_changed (BaobabChart* self,
                                 guint position,
                                 guint removed,
                                 guint added);
static void baobab_chart_draw_func (BaobabChart* self,
                             GtkDrawingArea* da,
                             cairo_t* cr,
                             gint width,
                             gint height);
static void baobab_chart_interpolate_colors (BaobabChart* self,
                                      GdkRGBA* colora,
                                      GdkRGBA* colorb,
                                      gfloat percentage,
                                      GdkRGBA* result);
static gboolean baobab_chart_scroll_cb (BaobabChart* self,
                                 gdouble dx,
                                 gdouble dy);
static void baobab_chart_build_context_menu (BaobabChart* self);
static void baobab_chart_show_popover_at (BaobabChart* self,
                                   gint x,
                                   gint y);
static void baobab_chart_connect_model_signals (BaobabChart* self,
                                         GtkTreeListModel* m);
static void _baobab_chart_items_changed_g_list_model_items_changed (GListModel* _sender,
                                                             guint position,
                                                             guint removed,
                                                             guint added,
                                                             gpointer self);
static void baobab_chart_disconnect_model_signals (BaobabChart* self,
                                            GtkTreeListModel* m);
static gboolean baobab_chart_real_query_tooltip (GtkWidget* base,
                                          gint x,
                                          gint y,
                                          gboolean keyboard_tooltip,
                                          GtkTooltip* tooltip);
static GObject * baobab_chart_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static gboolean _baobab_chart_scroll_cb_gtk_event_controller_scroll_scroll (GtkEventControllerScroll* _sender,
                                                                     gdouble dx,
                                                                     gdouble dy,
                                                                     gpointer self);
static void _baobab_chart_motion_cb_gtk_event_controller_motion_motion (GtkEventControllerMotion* _sender,
                                                                 gdouble x,
                                                                 gdouble y,
                                                                 gpointer self);
static void _baobab_chart_enter_cb_gtk_event_controller_motion_enter (GtkEventControllerMotion* _sender,
                                                               gdouble x,
                                                               gdouble y,
                                                               gpointer self);
static void _baobab_chart___lambda15_ (BaobabChart* self,
                                gint _,
                                gdouble x,
                                gdouble y);
static void __baobab_chart___lambda15__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                           gint n_press,
                                                           gdouble x,
                                                           gdouble y,
                                                           gpointer self);
static void _baobab_chart___lambda16_ (BaobabChart* self,
                                gint _,
                                gdouble x,
                                gdouble y);
static void __baobab_chart___lambda16__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                           gint n_press,
                                                           gdouble x,
                                                           gdouble y,
                                                           gpointer self);
static void _baobab_chart___lambda17_ (BaobabChart* self,
                                gint _,
                                gdouble x,
                                gdouble y);
static void __baobab_chart___lambda17__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                           gint n_press,
                                                           gdouble x,
                                                           gdouble y,
                                                           gpointer self);
static void _baobab_chart_draw_func_gtk_drawing_area_draw_func (GtkDrawingArea* drawing_area,
                                                         cairo_t* cr,
                                                         gint width,
                                                         gint height,
                                                         gpointer self);
static void baobab_chart_finalize (GObject * obj);
static GType baobab_chart_get_type_once (void);
static void _vala_baobab_chart_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_baobab_chart_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);

static const GActionEntry BAOBAB_CHART_action_entries[6] = {{"open-file", _baobab_chart_open_file_gsimple_action_activate_callback}, {"copy-path", _baobab_chart_copy_path_gsimple_action_activate_callback}, {"trash-file", _baobab_chart_trash_file_gsimple_action_activate_callback}, {"move-up", _baobab_chart_move_up_root_gsimple_action_activate_callback}, {"zoom-in", _baobab_chart_zoom_in_gsimple_action_activate_callback}, {"zoom-out", _baobab_chart_zoom_out_gsimple_action_activate_callback}};

BaobabChartItem*
baobab_chart_item_construct (GType object_type)
{
	BaobabChartItem* self = NULL;
#line 37 "../src/baobab-chart.vala"
	self = (BaobabChartItem*) g_type_create_instance (object_type);
#line 37 "../src/baobab-chart.vala"
	return self;
#line 280 "baobab-chart.c"
}

static void
baobab_value_chart_item_init (GValue* value)
{
#line 37 "../src/baobab-chart.vala"
	value->data[0].v_pointer = NULL;
#line 288 "baobab-chart.c"
}

static void
baobab_value_chart_item_free_value (GValue* value)
{
#line 37 "../src/baobab-chart.vala"
	if (value->data[0].v_pointer) {
#line 37 "../src/baobab-chart.vala"
		baobab_chart_item_unref (value->data[0].v_pointer);
#line 298 "baobab-chart.c"
	}
}

static void
baobab_value_chart_item_copy_value (const GValue* src_value,
                                    GValue* dest_value)
{
#line 37 "../src/baobab-chart.vala"
	if (src_value->data[0].v_pointer) {
#line 37 "../src/baobab-chart.vala"
		dest_value->data[0].v_pointer = baobab_chart_item_ref (src_value->data[0].v_pointer);
#line 310 "baobab-chart.c"
	} else {
#line 37 "../src/baobab-chart.vala"
		dest_value->data[0].v_pointer = NULL;
#line 314 "baobab-chart.c"
	}
}

static gpointer
baobab_value_chart_item_peek_pointer (const GValue* value)
{
#line 37 "../src/baobab-chart.vala"
	return value->data[0].v_pointer;
#line 323 "baobab-chart.c"
}

static gchar*
baobab_value_chart_item_collect_value (GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
#line 37 "../src/baobab-chart.vala"
	if (collect_values[0].v_pointer) {
#line 334 "baobab-chart.c"
		BaobabChartItem * object;
		object = collect_values[0].v_pointer;
#line 37 "../src/baobab-chart.vala"
		if (object->parent_instance.g_class == NULL) {
#line 37 "../src/baobab-chart.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 341 "baobab-chart.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 37 "../src/baobab-chart.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 345 "baobab-chart.c"
		}
#line 37 "../src/baobab-chart.vala"
		value->data[0].v_pointer = baobab_chart_item_ref (object);
#line 349 "baobab-chart.c"
	} else {
#line 37 "../src/baobab-chart.vala"
		value->data[0].v_pointer = NULL;
#line 353 "baobab-chart.c"
	}
#line 37 "../src/baobab-chart.vala"
	return NULL;
#line 357 "baobab-chart.c"
}

static gchar*
baobab_value_chart_item_lcopy_value (const GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
	BaobabChartItem ** object_p;
	object_p = collect_values[0].v_pointer;
#line 37 "../src/baobab-chart.vala"
	if (!object_p) {
#line 37 "../src/baobab-chart.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 372 "baobab-chart.c"
	}
#line 37 "../src/baobab-chart.vala"
	if (!value->data[0].v_pointer) {
#line 37 "../src/baobab-chart.vala"
		*object_p = NULL;
#line 378 "baobab-chart.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 37 "../src/baobab-chart.vala"
		*object_p = value->data[0].v_pointer;
#line 382 "baobab-chart.c"
	} else {
#line 37 "../src/baobab-chart.vala"
		*object_p = baobab_chart_item_ref (value->data[0].v_pointer);
#line 386 "baobab-chart.c"
	}
#line 37 "../src/baobab-chart.vala"
	return NULL;
#line 390 "baobab-chart.c"
}

GParamSpec*
baobab_param_spec_chart_item (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags)
{
	BaobabParamSpecChartItem* spec;
#line 37 "../src/baobab-chart.vala"
	g_return_val_if_fail (g_type_is_a (object_type, BAOBAB_TYPE_CHART_ITEM), NULL);
#line 37 "../src/baobab-chart.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 37 "../src/baobab-chart.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 37 "../src/baobab-chart.vala"
	return G_PARAM_SPEC (spec);
#line 409 "baobab-chart.c"
}

gpointer
baobab_value_get_chart_item (const GValue* value)
{
#line 37 "../src/baobab-chart.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BAOBAB_TYPE_CHART_ITEM), NULL);
#line 37 "../src/baobab-chart.vala"
	return value->data[0].v_pointer;
#line 419 "baobab-chart.c"
}

void
baobab_value_set_chart_item (GValue* value,
                             gpointer v_object)
{
	BaobabChartItem * old;
#line 37 "../src/baobab-chart.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BAOBAB_TYPE_CHART_ITEM));
#line 37 "../src/baobab-chart.vala"
	old = value->data[0].v_pointer;
#line 37 "../src/baobab-chart.vala"
	if (v_object) {
#line 37 "../src/baobab-chart.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, BAOBAB_TYPE_CHART_ITEM));
#line 37 "../src/baobab-chart.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 37 "../src/baobab-chart.vala"
		value->data[0].v_pointer = v_object;
#line 37 "../src/baobab-chart.vala"
		baobab_chart_item_ref (value->data[0].v_pointer);
#line 441 "baobab-chart.c"
	} else {
#line 37 "../src/baobab-chart.vala"
		value->data[0].v_pointer = NULL;
#line 445 "baobab-chart.c"
	}
#line 37 "../src/baobab-chart.vala"
	if (old) {
#line 37 "../src/baobab-chart.vala"
		baobab_chart_item_unref (old);
#line 451 "baobab-chart.c"
	}
}

void
baobab_value_take_chart_item (GValue* value,
                              gpointer v_object)
{
	BaobabChartItem * old;
#line 37 "../src/baobab-chart.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BAOBAB_TYPE_CHART_ITEM));
#line 37 "../src/baobab-chart.vala"
	old = value->data[0].v_pointer;
#line 37 "../src/baobab-chart.vala"
	if (v_object) {
#line 37 "../src/baobab-chart.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, BAOBAB_TYPE_CHART_ITEM));
#line 37 "../src/baobab-chart.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 37 "../src/baobab-chart.vala"
		value->data[0].v_pointer = v_object;
#line 472 "baobab-chart.c"
	} else {
#line 37 "../src/baobab-chart.vala"
		value->data[0].v_pointer = NULL;
#line 476 "baobab-chart.c"
	}
#line 37 "../src/baobab-chart.vala"
	if (old) {
#line 37 "../src/baobab-chart.vala"
		baobab_chart_item_unref (old);
#line 482 "baobab-chart.c"
	}
}

static void
baobab_chart_item_class_init (BaobabChartItemClass * klass,
                              gpointer klass_data)
{
#line 37 "../src/baobab-chart.vala"
	baobab_chart_item_parent_class = g_type_class_peek_parent (klass);
#line 37 "../src/baobab-chart.vala"
	((BaobabChartItemClass *) klass)->finalize = baobab_chart_item_finalize;
#line 494 "baobab-chart.c"
}

static void
baobab_chart_item_instance_init (BaobabChartItem * self,
                                 gpointer klass)
{
#line 37 "../src/baobab-chart.vala"
	self->ref_count = 1;
#line 503 "baobab-chart.c"
}

static void
baobab_chart_item_finalize (BaobabChartItem * obj)
{
	BaobabChartItem * self;
#line 37 "../src/baobab-chart.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BAOBAB_TYPE_CHART_ITEM, BaobabChartItem);
#line 37 "../src/baobab-chart.vala"
	g_signal_handlers_destroy (self);
#line 41 "../src/baobab-chart.vala"
	_g_object_unref0 (self->results);
#line 516 "baobab-chart.c"
}

static GType
baobab_chart_item_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { baobab_value_chart_item_init, baobab_value_chart_item_free_value, baobab_value_chart_item_copy_value, baobab_value_chart_item_peek_pointer, "p", baobab_value_chart_item_collect_value, "p", baobab_value_chart_item_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (BaobabChartItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) baobab_chart_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BaobabChartItem), 0, (GInstanceInitFunc) baobab_chart_item_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType baobab_chart_item_type_id;
	baobab_chart_item_type_id = g_type_register_fundamental (g_type_fundamental_next (), "BaobabChartItem", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	return baobab_chart_item_type_id;
}

GType
baobab_chart_item_get_type (void)
{
	static volatile gsize baobab_chart_item_type_id__once = 0;
	if (g_once_init_enter (&baobab_chart_item_type_id__once)) {
		GType baobab_chart_item_type_id;
		baobab_chart_item_type_id = baobab_chart_item_get_type_once ();
		g_once_init_leave (&baobab_chart_item_type_id__once, baobab_chart_item_type_id);
	}
	return baobab_chart_item_type_id__once;
}

gpointer
baobab_chart_item_ref (gpointer instance)
{
	BaobabChartItem * self;
	self = instance;
#line 37 "../src/baobab-chart.vala"
	g_atomic_int_inc (&self->ref_count);
#line 37 "../src/baobab-chart.vala"
	return instance;
#line 551 "baobab-chart.c"
}

void
baobab_chart_item_unref (gpointer instance)
{
	BaobabChartItem * self;
	self = instance;
#line 37 "../src/baobab-chart.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 37 "../src/baobab-chart.vala"
		BAOBAB_CHART_ITEM_GET_CLASS (self)->finalize (self);
#line 37 "../src/baobab-chart.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 565 "baobab-chart.c"
	}
}

static inline gpointer
baobab_chart_get_instance_private (BaobabChart* self)
{
	return G_STRUCT_MEMBER_P (self, BaobabChart_private_offset);
}

static void
_baobab_chart_open_file_gsimple_action_activate_callback (GSimpleAction* action,
                                                          GVariant* parameter,
                                                          gpointer self)
{
#line 195 "../src/baobab-chart.vala"
	baobab_chart_open_file ((BaobabChart*) self);
#line 582 "baobab-chart.c"
}

static void
_baobab_chart_copy_path_gsimple_action_activate_callback (GSimpleAction* action,
                                                          GVariant* parameter,
                                                          gpointer self)
{
#line 195 "../src/baobab-chart.vala"
	baobab_chart_copy_path ((BaobabChart*) self);
#line 592 "baobab-chart.c"
}

static void
_baobab_chart_trash_file_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self)
{
#line 195 "../src/baobab-chart.vala"
	baobab_chart_trash_file ((BaobabChart*) self);
#line 602 "baobab-chart.c"
}

static void
_baobab_chart_move_up_root_gsimple_action_activate_callback (GSimpleAction* action,
                                                             GVariant* parameter,
                                                             gpointer self)
{
#line 195 "../src/baobab-chart.vala"
	baobab_chart_move_up_root ((BaobabChart*) self);
#line 612 "baobab-chart.c"
}

static void
_baobab_chart_zoom_in_gsimple_action_activate_callback (GSimpleAction* action,
                                                        GVariant* parameter,
                                                        gpointer self)
{
#line 195 "../src/baobab-chart.vala"
	baobab_chart_zoom_in ((BaobabChart*) self);
#line 622 "baobab-chart.c"
}

static void
_baobab_chart_zoom_out_gsimple_action_activate_callback (GSimpleAction* action,
                                                         GVariant* parameter,
                                                         gpointer self)
{
#line 195 "../src/baobab-chart.vala"
	baobab_chart_zoom_out ((BaobabChart*) self);
#line 632 "baobab-chart.c"
}

static void
_baobab_chart_item_unref0_ (gpointer var)
{
#line 69 "../src/baobab-chart.vala"
	(var == NULL) ? NULL : (var = (baobab_chart_item_unref (var), NULL));
#line 640 "baobab-chart.c"
}

static inline void
_g_list_free__baobab_chart_item_unref0_ (GList* self)
{
#line 69 "../src/baobab-chart.vala"
	g_list_free_full (self, (GDestroyNotify) _baobab_chart_item_unref0_);
#line 648 "baobab-chart.c"
}

static void
baobab_chart_real_post_draw (BaobabChart* self,
                             cairo_t* cr)
{
#line 178 "../src/baobab-chart.vala"
	g_return_if_fail (cr != NULL);
#line 657 "baobab-chart.c"
}

void
baobab_chart_post_draw (BaobabChart* self,
                        cairo_t* cr)
{
	BaobabChartClass* _klass_;
#line 178 "../src/baobab-chart.vala"
	g_return_if_fail (self != NULL);
#line 178 "../src/baobab-chart.vala"
	_klass_ = BAOBAB_CHART_GET_CLASS (self);
#line 178 "../src/baobab-chart.vala"
	if (_klass_->post_draw) {
#line 178 "../src/baobab-chart.vala"
		_klass_->post_draw (self, cr);
#line 673 "baobab-chart.c"
	}
}

static void
baobab_chart_real_draw_item (BaobabChart* self,
                             cairo_t* cr,
                             BaobabChartItem* item,
                             gboolean highlighted)
{
#line 181 "../src/baobab-chart.vala"
	g_critical ("Type `%s' does not implement abstract method `baobab_chart_draw_item'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 181 "../src/baobab-chart.vala"
	return;
#line 687 "baobab-chart.c"
}

void
baobab_chart_draw_item (BaobabChart* self,
                        cairo_t* cr,
                        BaobabChartItem* item,
                        gboolean highlighted)
{
	BaobabChartClass* _klass_;
#line 181 "../src/baobab-chart.vala"
	g_return_if_fail (self != NULL);
#line 181 "../src/baobab-chart.vala"
	_klass_ = BAOBAB_CHART_GET_CLASS (self);
#line 181 "../src/baobab-chart.vala"
	if (_klass_->draw_item) {
#line 181 "../src/baobab-chart.vala"
		_klass_->draw_item (self, cr, item, highlighted);
#line 705 "baobab-chart.c"
	}
}

static void
baobab_chart_real_calculate_item_geometry (BaobabChart* self,
                                           BaobabChartItem* item)
{
#line 182 "../src/baobab-chart.vala"
	g_critical ("Type `%s' does not implement abstract method `baobab_chart_calculate_item_geometry'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 182 "../src/baobab-chart.vala"
	return;
#line 717 "baobab-chart.c"
}

void
baobab_chart_calculate_item_geometry (BaobabChart* self,
                                      BaobabChartItem* item)
{
	BaobabChartClass* _klass_;
#line 182 "../src/baobab-chart.vala"
	g_return_if_fail (self != NULL);
#line 182 "../src/baobab-chart.vala"
	_klass_ = BAOBAB_CHART_GET_CLASS (self);
#line 182 "../src/baobab-chart.vala"
	if (_klass_->calculate_item_geometry) {
#line 182 "../src/baobab-chart.vala"
		_klass_->calculate_item_geometry (self, item);
#line 733 "baobab-chart.c"
	}
}

static gboolean
baobab_chart_real_is_point_over_item (BaobabChart* self,
                                      BaobabChartItem* item,
                                      gdouble x,
                                      gdouble y)
{
	gboolean _tmp0_ = FALSE;
#line 184 "../src/baobab-chart.vala"
	g_critical ("Type `%s' does not implement abstract method `baobab_chart_is_point_over_item'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 184 "../src/baobab-chart.vala"
	return _tmp0_;
#line 748 "baobab-chart.c"
}

gboolean
baobab_chart_is_point_over_item (BaobabChart* self,
                                 BaobabChartItem* item,
                                 gdouble x,
                                 gdouble y)
{
	BaobabChartClass* _klass_;
#line 184 "../src/baobab-chart.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 184 "../src/baobab-chart.vala"
	_klass_ = BAOBAB_CHART_GET_CLASS (self);
#line 184 "../src/baobab-chart.vala"
	if (_klass_->is_point_over_item) {
#line 184 "../src/baobab-chart.vala"
		return _klass_->is_point_over_item (self, item, x, y);
#line 766 "baobab-chart.c"
	}
#line 184 "../src/baobab-chart.vala"
	return FALSE;
#line 770 "baobab-chart.c"
}

static void
baobab_chart_real_get_item_rectangle (BaobabChart* self,
                                      BaobabChartItem* item)
{
#line 186 "../src/baobab-chart.vala"
	g_critical ("Type `%s' does not implement abstract method `baobab_chart_get_item_rectangle'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 186 "../src/baobab-chart.vala"
	return;
#line 781 "baobab-chart.c"
}

void
baobab_chart_get_item_rectangle (BaobabChart* self,
                                 BaobabChartItem* item)
{
	BaobabChartClass* _klass_;
#line 186 "../src/baobab-chart.vala"
	g_return_if_fail (self != NULL);
#line 186 "../src/baobab-chart.vala"
	_klass_ = BAOBAB_CHART_GET_CLASS (self);
#line 186 "../src/baobab-chart.vala"
	if (_klass_->get_item_rectangle) {
#line 186 "../src/baobab-chart.vala"
		_klass_->get_item_rectangle (self, item);
#line 797 "baobab-chart.c"
	}
}

static gboolean
baobab_chart_real_can_zoom_in (BaobabChart* self)
{
	gboolean _tmp0_ = FALSE;
#line 188 "../src/baobab-chart.vala"
	g_critical ("Type `%s' does not implement abstract method `baobab_chart_can_zoom_in'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 188 "../src/baobab-chart.vala"
	return _tmp0_;
#line 809 "baobab-chart.c"
}

gboolean
baobab_chart_can_zoom_in (BaobabChart* self)
{
	BaobabChartClass* _klass_;
#line 188 "../src/baobab-chart.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 188 "../src/baobab-chart.vala"
	_klass_ = BAOBAB_CHART_GET_CLASS (self);
#line 188 "../src/baobab-chart.vala"
	if (_klass_->can_zoom_in) {
#line 188 "../src/baobab-chart.vala"
		return _klass_->can_zoom_in (self);
#line 824 "baobab-chart.c"
	}
#line 188 "../src/baobab-chart.vala"
	return FALSE;
#line 828 "baobab-chart.c"
}

static gboolean
baobab_chart_real_can_zoom_out (BaobabChart* self)
{
	gboolean _tmp0_ = FALSE;
#line 189 "../src/baobab-chart.vala"
	g_critical ("Type `%s' does not implement abstract method `baobab_chart_can_zoom_out'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 189 "../src/baobab-chart.vala"
	return _tmp0_;
#line 839 "baobab-chart.c"
}

gboolean
baobab_chart_can_zoom_out (BaobabChart* self)
{
	BaobabChartClass* _klass_;
#line 189 "../src/baobab-chart.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 189 "../src/baobab-chart.vala"
	_klass_ = BAOBAB_CHART_GET_CLASS (self);
#line 189 "../src/baobab-chart.vala"
	if (_klass_->can_zoom_out) {
#line 189 "../src/baobab-chart.vala"
		return _klass_->can_zoom_out (self);
#line 854 "baobab-chart.c"
	}
#line 189 "../src/baobab-chart.vala"
	return FALSE;
#line 858 "baobab-chart.c"
}

static BaobabChartItem*
baobab_chart_real_create_new_chartitem (BaobabChart* self)
{
#line 191 "../src/baobab-chart.vala"
	g_critical ("Type `%s' does not implement abstract method `baobab_chart_create_new_chartitem'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 191 "../src/baobab-chart.vala"
	return NULL;
#line 868 "baobab-chart.c"
}

BaobabChartItem*
baobab_chart_create_new_chartitem (BaobabChart* self)
{
	BaobabChartClass* _klass_;
#line 191 "../src/baobab-chart.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 191 "../src/baobab-chart.vala"
	_klass_ = BAOBAB_CHART_GET_CLASS (self);
#line 191 "../src/baobab-chart.vala"
	if (_klass_->create_new_chartitem) {
#line 191 "../src/baobab-chart.vala"
		return _klass_->create_new_chartitem (self);
#line 883 "baobab-chart.c"
	}
#line 191 "../src/baobab-chart.vala"
	return NULL;
#line 887 "baobab-chart.c"
}

static gpointer
_baobab_chart_item_ref0 (gpointer self)
{
#line 259 "../src/baobab-chart.vala"
	return self ? baobab_chart_item_ref (self) : NULL;
#line 895 "baobab-chart.c"
}

static void
baobab_chart_real_size_allocate (GtkWidget* base,
                                 gint width,
                                 gint height,
                                 gint baseline)
{
	BaobabChart * self;
	GList* _tmp0_;
#line 257 "../src/baobab-chart.vala"
	self = (BaobabChart*) base;
#line 258 "../src/baobab-chart.vala"
	GTK_WIDGET_CLASS (baobab_chart_parent_class)->size_allocate ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_drawing_area_get_type (), GtkDrawingArea), width, height, baseline);
#line 259 "../src/baobab-chart.vala"
	_tmp0_ = self->priv->items;
#line 912 "baobab-chart.c"
	{
		GList* item_collection = NULL;
		GList* item_it = NULL;
#line 259 "../src/baobab-chart.vala"
		item_collection = _tmp0_;
#line 259 "../src/baobab-chart.vala"
		for (item_it = item_collection; item_it != NULL; item_it = item_it->next) {
#line 920 "baobab-chart.c"
			BaobabChartItem* _tmp1_;
			BaobabChartItem* item = NULL;
#line 259 "../src/baobab-chart.vala"
			_tmp1_ = _baobab_chart_item_ref0 ((BaobabChartItem*) item_it->data);
#line 259 "../src/baobab-chart.vala"
			item = _tmp1_;
#line 927 "baobab-chart.c"
			{
				BaobabChartItem* _tmp2_;
				BaobabChartItem* _tmp3_;
				BaobabChartItem* _tmp4_;
#line 260 "../src/baobab-chart.vala"
				_tmp2_ = item;
#line 260 "../src/baobab-chart.vala"
				_tmp2_->has_visible_children = FALSE;
#line 261 "../src/baobab-chart.vala"
				_tmp3_ = item;
#line 261 "../src/baobab-chart.vala"
				_tmp3_->visible = FALSE;
#line 262 "../src/baobab-chart.vala"
				_tmp4_ = item;
#line 262 "../src/baobab-chart.vala"
				baobab_chart_calculate_item_geometry (self, _tmp4_);
#line 259 "../src/baobab-chart.vala"
				_baobab_chart_item_unref0 (item);
#line 946 "baobab-chart.c"
			}
		}
	}
}

static gboolean
baobab_chart_highlight_item_at_point (BaobabChart* self,
                                      gdouble x,
                                      gdouble y)
{
	gboolean result;
#line 266 "../src/baobab-chart.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 960 "baobab-chart.c"
	{
		GList* node = NULL;
		GList* _tmp0_;
		GList* _tmp1_;
#line 267 "../src/baobab-chart.vala"
		_tmp0_ = self->priv->items;
#line 267 "../src/baobab-chart.vala"
		_tmp1_ = g_list_last (_tmp0_);
#line 267 "../src/baobab-chart.vala"
		node = _tmp1_;
#line 971 "baobab-chart.c"
		{
			gboolean _tmp2_ = FALSE;
#line 267 "../src/baobab-chart.vala"
			_tmp2_ = TRUE;
#line 267 "../src/baobab-chart.vala"
			while (TRUE) {
#line 978 "baobab-chart.c"
				GList* _tmp5_;
				BaobabChartItem* item = NULL;
				GList* _tmp6_;
				gconstpointer _tmp7_;
				BaobabChartItem* _tmp8_;
				gboolean _tmp9_ = FALSE;
				BaobabChartItem* _tmp10_;
#line 267 "../src/baobab-chart.vala"
				if (!_tmp2_) {
#line 988 "baobab-chart.c"
					GList* _tmp3_;
					GList* _tmp4_;
#line 267 "../src/baobab-chart.vala"
					_tmp3_ = node;
#line 267 "../src/baobab-chart.vala"
					_tmp4_ = _tmp3_->prev;
#line 267 "../src/baobab-chart.vala"
					node = _tmp4_;
#line 997 "baobab-chart.c"
				}
#line 267 "../src/baobab-chart.vala"
				_tmp2_ = FALSE;
#line 267 "../src/baobab-chart.vala"
				_tmp5_ = node;
#line 267 "../src/baobab-chart.vala"
				if (!(_tmp5_ != NULL)) {
#line 267 "../src/baobab-chart.vala"
					break;
#line 1007 "baobab-chart.c"
				}
#line 268 "../src/baobab-chart.vala"
				_tmp6_ = node;
#line 268 "../src/baobab-chart.vala"
				_tmp7_ = _tmp6_->data;
#line 268 "../src/baobab-chart.vala"
				_tmp8_ = _baobab_chart_item_ref0 ((BaobabChartItem*) _tmp7_);
#line 268 "../src/baobab-chart.vala"
				item = _tmp8_;
#line 269 "../src/baobab-chart.vala"
				_tmp10_ = item;
#line 269 "../src/baobab-chart.vala"
				if (_tmp10_->visible) {
#line 1021 "baobab-chart.c"
					BaobabChartItem* _tmp11_;
#line 269 "../src/baobab-chart.vala"
					_tmp11_ = item;
#line 269 "../src/baobab-chart.vala"
					_tmp9_ = baobab_chart_is_point_over_item (self, _tmp11_, x, y);
#line 1027 "baobab-chart.c"
				} else {
#line 269 "../src/baobab-chart.vala"
					_tmp9_ = FALSE;
#line 1031 "baobab-chart.c"
				}
#line 269 "../src/baobab-chart.vala"
				if (_tmp9_) {
#line 1035 "baobab-chart.c"
					BaobabChartItem* _tmp12_;
#line 270 "../src/baobab-chart.vala"
					_tmp12_ = item;
#line 270 "../src/baobab-chart.vala"
					baobab_chart_set_highlighted_item (self, _tmp12_);
#line 271 "../src/baobab-chart.vala"
					result = TRUE;
#line 271 "../src/baobab-chart.vala"
					_baobab_chart_item_unref0 (item);
#line 271 "../src/baobab-chart.vala"
					return result;
#line 1047 "baobab-chart.c"
				}
#line 267 "../src/baobab-chart.vala"
				_baobab_chart_item_unref0 (item);
#line 1051 "baobab-chart.c"
			}
		}
	}
#line 275 "../src/baobab-chart.vala"
	baobab_chart_set_highlighted_item (self, NULL);
#line 276 "../src/baobab-chart.vala"
	result = FALSE;
#line 276 "../src/baobab-chart.vala"
	return result;
#line 1061 "baobab-chart.c"
}

static void
baobab_chart_motion_cb (BaobabChart* self,
                        gdouble x,
                        gdouble y)
{
#line 279 "../src/baobab-chart.vala"
	g_return_if_fail (self != NULL);
#line 280 "../src/baobab-chart.vala"
	gtk_widget_set_has_tooltip ((GtkWidget*) self, baobab_chart_highlight_item_at_point (self, x, y));
#line 1073 "baobab-chart.c"
}

static void
baobab_chart_enter_cb (BaobabChart* self,
                       gdouble x,
                       gdouble y)
{
	GtkPopoverMenu* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 283 "../src/baobab-chart.vala"
	g_return_if_fail (self != NULL);
#line 284 "../src/baobab-chart.vala"
	_tmp0_ = self->priv->context_menu;
#line 284 "../src/baobab-chart.vala"
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
#line 284 "../src/baobab-chart.vala"
	_tmp2_ = _tmp1_;
#line 284 "../src/baobab-chart.vala"
	if (!_tmp2_) {
#line 285 "../src/baobab-chart.vala"
		gtk_widget_set_has_tooltip ((GtkWidget*) self, baobab_chart_highlight_item_at_point (self, x, y));
#line 1096 "baobab-chart.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 296 "../src/baobab-chart.vala"
	return self ? g_object_ref (self) : NULL;
#line 1105 "baobab-chart.c"
}

static GList*
baobab_chart_add_item (BaobabChart* self,
                       guint depth,
                       gdouble rel_start,
                       gdouble rel_size,
                       BaobabScannerResults* results)
{
	BaobabChartItem* item = NULL;
	BaobabChartItem* _tmp0_;
	BaobabScannerResults* _tmp1_;
	BaobabChartItem* _tmp2_;
	GList* ret = NULL;
	GList* _tmp3_;
	GList* result;
#line 289 "../src/baobab-chart.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 289 "../src/baobab-chart.vala"
	g_return_val_if_fail (results != NULL, NULL);
#line 290 "../src/baobab-chart.vala"
	_tmp0_ = baobab_chart_create_new_chartitem (self);
#line 290 "../src/baobab-chart.vala"
	item = _tmp0_;
#line 291 "../src/baobab-chart.vala"
	item->depth = depth;
#line 292 "../src/baobab-chart.vala"
	item->rel_start = rel_start;
#line 293 "../src/baobab-chart.vala"
	item->rel_size = rel_size;
#line 294 "../src/baobab-chart.vala"
	item->visible = FALSE;
#line 295 "../src/baobab-chart.vala"
	item->has_visible_children = FALSE;
#line 296 "../src/baobab-chart.vala"
	_tmp1_ = _g_object_ref0 (results);
#line 296 "../src/baobab-chart.vala"
	_g_object_unref0 (item->results);
#line 296 "../src/baobab-chart.vala"
	item->results = _tmp1_;
#line 297 "../src/baobab-chart.vala"
	item->parent = NULL;
#line 299 "../src/baobab-chart.vala"
	_tmp2_ = _baobab_chart_item_ref0 (item);
#line 299 "../src/baobab-chart.vala"
	self->priv->items = g_list_prepend (self->priv->items, _tmp2_);
#line 301 "../src/baobab-chart.vala"
	_tmp3_ = self->priv->items;
#line 301 "../src/baobab-chart.vala"
	ret = _tmp3_;
#line 302 "../src/baobab-chart.vala"
	result = ret;
#line 302 "../src/baobab-chart.vala"
	_baobab_chart_item_unref0 (item);
#line 302 "../src/baobab-chart.vala"
	return result;
#line 1162 "baobab-chart.c"
}

static gint
_____lambda14_ (BaobabChart* self,
                BaobabScannerResults* a,
                BaobabScannerResults* b)
{
	gint _tmp0_ = 0;
	guint64 _tmp1_;
	guint64 _tmp2_;
	guint64 _tmp3_;
	guint64 _tmp4_;
	gint result;
#line 327 "../src/baobab-chart.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 327 "../src/baobab-chart.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 328 "../src/baobab-chart.vala"
	_tmp1_ = baobab_scanner_results_get_size (a);
#line 328 "../src/baobab-chart.vala"
	_tmp2_ = _tmp1_;
#line 328 "../src/baobab-chart.vala"
	_tmp3_ = baobab_scanner_results_get_size (b);
#line 328 "../src/baobab-chart.vala"
	_tmp4_ = _tmp3_;
#line 328 "../src/baobab-chart.vala"
	if (_tmp2_ < _tmp4_) {
#line 328 "../src/baobab-chart.vala"
		_tmp0_ = 1;
#line 1192 "baobab-chart.c"
	} else {
		gint _tmp5_ = 0;
		guint64 _tmp6_;
		guint64 _tmp7_;
		guint64 _tmp8_;
		guint64 _tmp9_;
#line 329 "../src/baobab-chart.vala"
		_tmp6_ = baobab_scanner_results_get_size (a);
#line 329 "../src/baobab-chart.vala"
		_tmp7_ = _tmp6_;
#line 329 "../src/baobab-chart.vala"
		_tmp8_ = baobab_scanner_results_get_size (b);
#line 329 "../src/baobab-chart.vala"
		_tmp9_ = _tmp8_;
#line 329 "../src/baobab-chart.vala"
		if (_tmp7_ > _tmp9_) {
#line 329 "../src/baobab-chart.vala"
			_tmp5_ = -1;
#line 1211 "baobab-chart.c"
		} else {
#line 330 "../src/baobab-chart.vala"
			_tmp5_ = 0;
#line 1215 "baobab-chart.c"
		}
#line 329 "../src/baobab-chart.vala"
		_tmp0_ = _tmp5_;
#line 1219 "baobab-chart.c"
	}
#line 328 "../src/baobab-chart.vala"
	result = _tmp0_;
#line 328 "../src/baobab-chart.vala"
	return result;
#line 1225 "baobab-chart.c"
}

static gint
______lambda14__gcompare_data_func (gconstpointer a,
                                    gconstpointer b,
                                    gpointer self)
{
	gint result;
	result = _____lambda14_ ((BaobabChart*) self, (BaobabScannerResults*) a, (BaobabScannerResults*) b);
#line 327 "../src/baobab-chart.vala"
	return result;
#line 1237 "baobab-chart.c"
}

static void
baobab_chart_get_items (BaobabChart* self,
                        BaobabScannerResults* root_path)
{
	GList* node = NULL;
	GList* _tmp0_;
#line 305 "../src/baobab-chart.vala"
	g_return_if_fail (self != NULL);
#line 306 "../src/baobab-chart.vala"
	(self->priv->items == NULL) ? NULL : (self->priv->items = (_g_list_free__baobab_chart_item_unref0_ (self->priv->items), NULL));
#line 306 "../src/baobab-chart.vala"
	self->priv->items = NULL;
#line 308 "../src/baobab-chart.vala"
	if (root_path == NULL) {
#line 309 "../src/baobab-chart.vala"
		self->priv->model_changed = FALSE;
#line 310 "../src/baobab-chart.vala"
		return;
#line 1258 "baobab-chart.c"
	}
#line 313 "../src/baobab-chart.vala"
	_tmp0_ = baobab_chart_add_item (self, (guint) 0, (gdouble) 0, (gdouble) 100, root_path);
#line 313 "../src/baobab-chart.vala"
	node = _tmp0_;
#line 1264 "baobab-chart.c"
	{
		gboolean _tmp1_ = FALSE;
#line 315 "../src/baobab-chart.vala"
		_tmp1_ = TRUE;
#line 315 "../src/baobab-chart.vala"
		while (TRUE) {
#line 1271 "baobab-chart.c"
			BaobabChartItem* item = NULL;
			GList* _tmp3_;
			gconstpointer _tmp4_;
			BaobabChartItem* _tmp5_;
			BaobabChartItem* _tmp6_;
			BaobabChartItem* _tmp7_;
			gboolean _tmp10_ = FALSE;
			BaobabChartItem* _tmp11_;
			BaobabScannerResults* _tmp12_;
			gboolean _tmp13_;
			gboolean _tmp14_;
			GList* _tmp50_;
			GList* _tmp51_;
#line 315 "../src/baobab-chart.vala"
			if (!_tmp1_) {
#line 1287 "baobab-chart.c"
				GList* _tmp2_;
#line 344 "../src/baobab-chart.vala"
				_tmp2_ = node;
#line 344 "../src/baobab-chart.vala"
				if (!(_tmp2_ != NULL)) {
#line 344 "../src/baobab-chart.vala"
					break;
#line 1295 "baobab-chart.c"
				}
			}
#line 315 "../src/baobab-chart.vala"
			_tmp1_ = FALSE;
#line 316 "../src/baobab-chart.vala"
			_tmp3_ = node;
#line 316 "../src/baobab-chart.vala"
			_tmp4_ = _tmp3_->data;
#line 316 "../src/baobab-chart.vala"
			_tmp5_ = _baobab_chart_item_ref0 ((BaobabChartItem*) _tmp4_);
#line 316 "../src/baobab-chart.vala"
			item = _tmp5_;
#line 318 "../src/baobab-chart.vala"
			_tmp6_ = item;
#line 318 "../src/baobab-chart.vala"
			baobab_chart_calculate_item_geometry (self, _tmp6_);
#line 320 "../src/baobab-chart.vala"
			_tmp7_ = item;
#line 320 "../src/baobab-chart.vala"
			if (!_tmp7_->visible) {
#line 1316 "baobab-chart.c"
				GList* _tmp8_;
				GList* _tmp9_;
#line 321 "../src/baobab-chart.vala"
				_tmp8_ = node;
#line 321 "../src/baobab-chart.vala"
				_tmp9_ = _tmp8_->prev;
#line 321 "../src/baobab-chart.vala"
				node = _tmp9_;
#line 322 "../src/baobab-chart.vala"
				_baobab_chart_item_unref0 (item);
#line 322 "../src/baobab-chart.vala"
				continue;
#line 1329 "baobab-chart.c"
			}
#line 325 "../src/baobab-chart.vala"
			_tmp11_ = item;
#line 325 "../src/baobab-chart.vala"
			_tmp12_ = _tmp11_->results;
#line 325 "../src/baobab-chart.vala"
			_tmp13_ = baobab_scanner_results_get_is_empty (_tmp12_);
#line 325 "../src/baobab-chart.vala"
			_tmp14_ = _tmp13_;
#line 325 "../src/baobab-chart.vala"
			if (!_tmp14_) {
#line 1341 "baobab-chart.c"
				BaobabChartItem* _tmp15_;
				guint _tmp16_;
				guint _tmp17_;
#line 325 "../src/baobab-chart.vala"
				_tmp15_ = item;
#line 325 "../src/baobab-chart.vala"
				_tmp16_ = baobab_chart_get_max_depth (self);
#line 325 "../src/baobab-chart.vala"
				_tmp17_ = _tmp16_;
#line 325 "../src/baobab-chart.vala"
				_tmp10_ = _tmp15_->depth < (_tmp17_ + 1);
#line 1353 "baobab-chart.c"
			} else {
#line 325 "../src/baobab-chart.vala"
				_tmp10_ = FALSE;
#line 1357 "baobab-chart.c"
			}
#line 325 "../src/baobab-chart.vala"
			if (_tmp10_) {
#line 1361 "baobab-chart.c"
				gdouble rel_start = 0.0;
				GCompareDataFunc reverse_size_cmp = NULL;
				gpointer reverse_size_cmp_target;
				GDestroyNotify reverse_size_cmp_target_destroy_notify;
				GtkCustomSorter* sorter = NULL;
				GCompareDataFunc _tmp18_;
				gpointer _tmp18__target;
				GtkCustomSorter* _tmp19_;
				GtkSortListModel* sorted = NULL;
				BaobabChartItem* _tmp20_;
				BaobabScannerResults* _tmp21_;
				GListStore* _tmp22_;
				GListStore* _tmp23_;
				GListModel* _tmp24_;
				GtkCustomSorter* _tmp25_;
				GtkSorter* _tmp26_;
				GtkSortListModel* _tmp27_;
#line 326 "../src/baobab-chart.vala"
				rel_start = (gdouble) 0;
#line 327 "../src/baobab-chart.vala"
				reverse_size_cmp = ______lambda14__gcompare_data_func;
#line 327 "../src/baobab-chart.vala"
				reverse_size_cmp_target = g_object_ref (self);
#line 327 "../src/baobab-chart.vala"
				reverse_size_cmp_target_destroy_notify = g_object_unref;
#line 332 "../src/baobab-chart.vala"
				_tmp18_ = reverse_size_cmp;
#line 332 "../src/baobab-chart.vala"
				_tmp18__target = reverse_size_cmp_target;
#line 332 "../src/baobab-chart.vala"
				_tmp19_ = gtk_custom_sorter_new (_tmp18_, _tmp18__target, NULL);
#line 332 "../src/baobab-chart.vala"
				sorter = _tmp19_;
#line 333 "../src/baobab-chart.vala"
				_tmp20_ = item;
#line 333 "../src/baobab-chart.vala"
				_tmp21_ = _tmp20_->results;
#line 333 "../src/baobab-chart.vala"
				_tmp22_ = baobab_scanner_results_get_children_list_store (_tmp21_);
#line 333 "../src/baobab-chart.vala"
				_tmp23_ = _tmp22_;
#line 333 "../src/baobab-chart.vala"
				_tmp24_ = _g_object_ref0 ((GListModel*) _tmp23_);
#line 333 "../src/baobab-chart.vala"
				_tmp25_ = sorter;
#line 333 "../src/baobab-chart.vala"
				_tmp26_ = _g_object_ref0 ((GtkSorter*) _tmp25_);
#line 333 "../src/baobab-chart.vala"
				_tmp27_ = gtk_sort_list_model_new (_tmp24_, _tmp26_);
#line 333 "../src/baobab-chart.vala"
				sorted = _tmp27_;
#line 1413 "baobab-chart.c"
				{
					gint i = 0;
#line 334 "../src/baobab-chart.vala"
					i = 0;
#line 1418 "baobab-chart.c"
					{
						gboolean _tmp28_ = FALSE;
#line 334 "../src/baobab-chart.vala"
						_tmp28_ = TRUE;
#line 334 "../src/baobab-chart.vala"
						while (TRUE) {
#line 1425 "baobab-chart.c"
							GtkSortListModel* _tmp30_;
							guint _tmp31_;
							guint _tmp32_;
							BaobabScannerResults* child_iter = NULL;
							GtkSortListModel* _tmp33_;
							GObject* _tmp34_;
							BaobabScannerResults* _tmp35_;
							GList* child_node = NULL;
							BaobabChartItem* _tmp36_;
							BaobabScannerResults* _tmp37_;
							gdouble _tmp38_;
							gdouble _tmp39_;
							BaobabScannerResults* _tmp40_;
							GList* _tmp41_;
							BaobabChartItem* child = NULL;
							GList* _tmp42_;
							gconstpointer _tmp43_;
							BaobabChartItem* _tmp44_;
							BaobabChartItem* _tmp45_;
							GList* _tmp46_;
							BaobabScannerResults* _tmp47_;
							gdouble _tmp48_;
							gdouble _tmp49_;
#line 334 "../src/baobab-chart.vala"
							if (!_tmp28_) {
#line 1451 "baobab-chart.c"
								gint _tmp29_;
#line 334 "../src/baobab-chart.vala"
								_tmp29_ = i;
#line 334 "../src/baobab-chart.vala"
								i = _tmp29_ + 1;
#line 1457 "baobab-chart.c"
							}
#line 334 "../src/baobab-chart.vala"
							_tmp28_ = FALSE;
#line 334 "../src/baobab-chart.vala"
							_tmp30_ = sorted;
#line 334 "../src/baobab-chart.vala"
							g_object_get (_tmp30_, "n-items", &_tmp31_, NULL);
#line 334 "../src/baobab-chart.vala"
							_tmp32_ = _tmp31_;
#line 334 "../src/baobab-chart.vala"
							if (!(((guint) i) < _tmp32_)) {
#line 334 "../src/baobab-chart.vala"
								break;
#line 1471 "baobab-chart.c"
							}
#line 335 "../src/baobab-chart.vala"
							_tmp33_ = sorted;
#line 335 "../src/baobab-chart.vala"
							_tmp34_ = g_list_model_get_object ((GListModel*) _tmp33_, (guint) i);
#line 335 "../src/baobab-chart.vala"
							_tmp35_ = BAOBAB_SCANNER_IS_RESULTS (_tmp34_) ? ((BaobabScannerResults*) _tmp34_) : NULL;
#line 335 "../src/baobab-chart.vala"
							if (_tmp35_ == NULL) {
#line 335 "../src/baobab-chart.vala"
								_g_object_unref0 (_tmp34_);
#line 1483 "baobab-chart.c"
							}
#line 335 "../src/baobab-chart.vala"
							child_iter = _tmp35_;
#line 336 "../src/baobab-chart.vala"
							_tmp36_ = item;
#line 336 "../src/baobab-chart.vala"
							_tmp37_ = child_iter;
#line 336 "../src/baobab-chart.vala"
							_tmp38_ = baobab_scanner_results_get_percent (_tmp37_);
#line 336 "../src/baobab-chart.vala"
							_tmp39_ = _tmp38_;
#line 336 "../src/baobab-chart.vala"
							_tmp40_ = child_iter;
#line 336 "../src/baobab-chart.vala"
							_tmp41_ = baobab_chart_add_item (self, _tmp36_->depth + 1, rel_start, _tmp39_, _tmp40_);
#line 336 "../src/baobab-chart.vala"
							child_node = _tmp41_;
#line 337 "../src/baobab-chart.vala"
							_tmp42_ = child_node;
#line 337 "../src/baobab-chart.vala"
							_tmp43_ = _tmp42_->data;
#line 337 "../src/baobab-chart.vala"
							_tmp44_ = _baobab_chart_item_ref0 ((BaobabChartItem*) _tmp43_);
#line 337 "../src/baobab-chart.vala"
							child = _tmp44_;
#line 338 "../src/baobab-chart.vala"
							_tmp45_ = child;
#line 338 "../src/baobab-chart.vala"
							_tmp46_ = node;
#line 338 "../src/baobab-chart.vala"
							_tmp45_->parent = _tmp46_;
#line 339 "../src/baobab-chart.vala"
							_tmp47_ = child_iter;
#line 339 "../src/baobab-chart.vala"
							_tmp48_ = baobab_scanner_results_get_percent (_tmp47_);
#line 339 "../src/baobab-chart.vala"
							_tmp49_ = _tmp48_;
#line 339 "../src/baobab-chart.vala"
							rel_start += _tmp49_;
#line 334 "../src/baobab-chart.vala"
							_baobab_chart_item_unref0 (child);
#line 334 "../src/baobab-chart.vala"
							_g_object_unref0 (child_iter);
#line 1527 "baobab-chart.c"
						}
					}
				}
#line 325 "../src/baobab-chart.vala"
				_g_object_unref0 (sorted);
#line 325 "../src/baobab-chart.vala"
				_g_object_unref0 (sorter);
#line 325 "../src/baobab-chart.vala"
				(reverse_size_cmp_target_destroy_notify == NULL) ? NULL : (reverse_size_cmp_target_destroy_notify (reverse_size_cmp_target), NULL);
#line 325 "../src/baobab-chart.vala"
				reverse_size_cmp = NULL;
#line 325 "../src/baobab-chart.vala"
				reverse_size_cmp_target = NULL;
#line 325 "../src/baobab-chart.vala"
				reverse_size_cmp_target_destroy_notify = NULL;
#line 1543 "baobab-chart.c"
			}
#line 343 "../src/baobab-chart.vala"
			_tmp50_ = node;
#line 343 "../src/baobab-chart.vala"
			_tmp51_ = _tmp50_->prev;
#line 343 "../src/baobab-chart.vala"
			node = _tmp51_;
#line 315 "../src/baobab-chart.vala"
			_baobab_chart_item_unref0 (item);
#line 1553 "baobab-chart.c"
		}
	}
#line 346 "../src/baobab-chart.vala"
	self->priv->items = g_list_reverse (self->priv->items);
#line 348 "../src/baobab-chart.vala"
	self->priv->model_changed = FALSE;
#line 1560 "baobab-chart.c"
}

static void
baobab_chart_draw_chart (BaobabChart* self,
                         cairo_t* cr)
{
	GList* _tmp0_;
#line 351 "../src/baobab-chart.vala"
	g_return_if_fail (self != NULL);
#line 351 "../src/baobab-chart.vala"
	g_return_if_fail (cr != NULL);
#line 352 "../src/baobab-chart.vala"
	cairo_save (cr);
#line 354 "../src/baobab-chart.vala"
	_tmp0_ = self->priv->items;
#line 1576 "baobab-chart.c"
	{
		GList* item_collection = NULL;
		GList* item_it = NULL;
#line 354 "../src/baobab-chart.vala"
		item_collection = _tmp0_;
#line 354 "../src/baobab-chart.vala"
		for (item_it = item_collection; item_it != NULL; item_it = item_it->next) {
#line 1584 "baobab-chart.c"
			BaobabChartItem* _tmp1_;
			BaobabChartItem* item = NULL;
#line 354 "../src/baobab-chart.vala"
			_tmp1_ = _baobab_chart_item_ref0 ((BaobabChartItem*) item_it->data);
#line 354 "../src/baobab-chart.vala"
			item = _tmp1_;
#line 1591 "baobab-chart.c"
			{
				gboolean _tmp2_ = FALSE;
				BaobabChartItem* _tmp3_;
#line 355 "../src/baobab-chart.vala"
				_tmp3_ = item;
#line 355 "../src/baobab-chart.vala"
				if (_tmp3_->visible) {
#line 1599 "baobab-chart.c"
					BaobabChartItem* _tmp4_;
					guint _tmp5_;
					guint _tmp6_;
#line 355 "../src/baobab-chart.vala"
					_tmp4_ = item;
#line 355 "../src/baobab-chart.vala"
					_tmp5_ = baobab_chart_get_max_depth (self);
#line 355 "../src/baobab-chart.vala"
					_tmp6_ = _tmp5_;
#line 355 "../src/baobab-chart.vala"
					_tmp2_ = _tmp4_->depth <= _tmp6_;
#line 1611 "baobab-chart.c"
				} else {
#line 355 "../src/baobab-chart.vala"
					_tmp2_ = FALSE;
#line 1615 "baobab-chart.c"
				}
#line 355 "../src/baobab-chart.vala"
				if (_tmp2_) {
#line 1619 "baobab-chart.c"
					gboolean highlighted = FALSE;
					BaobabChartItem* _tmp7_;
					BaobabChartItem* _tmp8_;
					BaobabChartItem* _tmp9_;
					BaobabChartItem* _tmp10_;
#line 356 "../src/baobab-chart.vala"
					_tmp7_ = item;
#line 356 "../src/baobab-chart.vala"
					_tmp8_ = baobab_chart_get_highlighted_item (self);
#line 356 "../src/baobab-chart.vala"
					_tmp9_ = _tmp8_;
#line 356 "../src/baobab-chart.vala"
					highlighted = _tmp7_ == _tmp9_;
#line 357 "../src/baobab-chart.vala"
					_tmp10_ = item;
#line 357 "../src/baobab-chart.vala"
					baobab_chart_draw_item (self, cr, _tmp10_, highlighted);
#line 1637 "baobab-chart.c"
				}
#line 354 "../src/baobab-chart.vala"
				_baobab_chart_item_unref0 (item);
#line 1641 "baobab-chart.c"
			}
		}
	}
#line 361 "../src/baobab-chart.vala"
	cairo_restore (cr);
#line 363 "../src/baobab-chart.vala"
	baobab_chart_post_draw (self, cr);
#line 1649 "baobab-chart.c"
}

static void
baobab_chart_update_draw (BaobabChart* self)
{
#line 366 "../src/baobab-chart.vala"
	g_return_if_fail (self != NULL);
#line 367 "../src/baobab-chart.vala"
	if (!gtk_widget_get_realized ((GtkWidget*) self)) {
#line 368 "../src/baobab-chart.vala"
		return;
#line 1661 "baobab-chart.c"
	}
#line 371 "../src/baobab-chart.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 1665 "baobab-chart.c"
}

static void
baobab_chart_items_changed (BaobabChart* self,
                            guint position,
                            guint removed,
                            guint added)
{
#line 374 "../src/baobab-chart.vala"
	g_return_if_fail (self != NULL);
#line 375 "../src/baobab-chart.vala"
	self->priv->model_changed = TRUE;
#line 376 "../src/baobab-chart.vala"
	baobab_chart_update_draw (self);
#line 1680 "baobab-chart.c"
}

static void
baobab_chart_draw_func (BaobabChart* self,
                        GtkDrawingArea* da,
                        cairo_t* cr,
                        gint width,
                        gint height)
{
	GtkTreeListModel* _tmp0_;
	GtkTreeListModel* _tmp1_;
#line 379 "../src/baobab-chart.vala"
	g_return_if_fail (self != NULL);
#line 379 "../src/baobab-chart.vala"
	g_return_if_fail (da != NULL);
#line 379 "../src/baobab-chart.vala"
	g_return_if_fail (cr != NULL);
#line 380 "../src/baobab-chart.vala"
	_tmp0_ = baobab_chart_get_model (self);
#line 380 "../src/baobab-chart.vala"
	_tmp1_ = _tmp0_;
#line 380 "../src/baobab-chart.vala"
	if (_tmp1_ != NULL) {
#line 1704 "baobab-chart.c"
		gboolean _tmp2_ = FALSE;
#line 381 "../src/baobab-chart.vala"
		if (self->priv->model_changed) {
#line 381 "../src/baobab-chart.vala"
			_tmp2_ = TRUE;
#line 1710 "baobab-chart.c"
		} else {
			GList* _tmp3_;
#line 381 "../src/baobab-chart.vala"
			_tmp3_ = self->priv->items;
#line 381 "../src/baobab-chart.vala"
			_tmp2_ = _tmp3_ == NULL;
#line 1717 "baobab-chart.c"
		}
#line 381 "../src/baobab-chart.vala"
		if (_tmp2_) {
#line 1721 "baobab-chart.c"
			BaobabScannerResults* _tmp4_;
			BaobabScannerResults* _tmp5_;
			BaobabScannerResults* _tmp6_;
#line 382 "../src/baobab-chart.vala"
			_tmp4_ = baobab_chart_get_tree_root (self);
#line 382 "../src/baobab-chart.vala"
			_tmp5_ = _tmp4_;
#line 382 "../src/baobab-chart.vala"
			_tmp6_ = _tmp5_;
#line 382 "../src/baobab-chart.vala"
			baobab_chart_get_items (self, _tmp6_);
#line 382 "../src/baobab-chart.vala"
			_g_object_unref0 (_tmp6_);
#line 1735 "baobab-chart.c"
		} else {
			BaobabScannerResults* current_path = NULL;
			GList* _tmp7_;
			gconstpointer _tmp8_;
			BaobabScannerResults* _tmp9_;
			BaobabScannerResults* _tmp10_;
			BaobabScannerResults* _tmp11_;
			BaobabScannerResults* _tmp12_;
			BaobabScannerResults* _tmp13_;
			BaobabScannerResults* _tmp14_;
			gboolean _tmp15_;
#line 384 "../src/baobab-chart.vala"
			_tmp7_ = self->priv->items;
#line 384 "../src/baobab-chart.vala"
			_tmp8_ = _tmp7_->data;
#line 384 "../src/baobab-chart.vala"
			_tmp9_ = ((BaobabChartItem*) _tmp8_)->results;
#line 384 "../src/baobab-chart.vala"
			_tmp10_ = _g_object_ref0 (_tmp9_);
#line 384 "../src/baobab-chart.vala"
			current_path = _tmp10_;
#line 385 "../src/baobab-chart.vala"
			_tmp11_ = baobab_chart_get_tree_root (self);
#line 385 "../src/baobab-chart.vala"
			_tmp12_ = _tmp11_;
#line 385 "../src/baobab-chart.vala"
			_tmp13_ = _tmp12_;
#line 385 "../src/baobab-chart.vala"
			_tmp14_ = current_path;
#line 385 "../src/baobab-chart.vala"
			_tmp15_ = _tmp13_ != _tmp14_;
#line 385 "../src/baobab-chart.vala"
			_g_object_unref0 (_tmp13_);
#line 385 "../src/baobab-chart.vala"
			if (_tmp15_) {
#line 1771 "baobab-chart.c"
				BaobabScannerResults* _tmp16_;
				BaobabScannerResults* _tmp17_;
				BaobabScannerResults* _tmp18_;
#line 386 "../src/baobab-chart.vala"
				_tmp16_ = baobab_chart_get_tree_root (self);
#line 386 "../src/baobab-chart.vala"
				_tmp17_ = _tmp16_;
#line 386 "../src/baobab-chart.vala"
				_tmp18_ = _tmp17_;
#line 386 "../src/baobab-chart.vala"
				baobab_chart_get_items (self, _tmp18_);
#line 386 "../src/baobab-chart.vala"
				_g_object_unref0 (_tmp18_);
#line 1785 "baobab-chart.c"
			}
#line 381 "../src/baobab-chart.vala"
			_g_object_unref0 (current_path);
#line 1789 "baobab-chart.c"
		}
#line 390 "../src/baobab-chart.vala"
		baobab_chart_draw_chart (self, cr);
#line 1793 "baobab-chart.c"
	}
}

static void
baobab_chart_interpolate_colors (BaobabChart* self,
                                 GdkRGBA* colora,
                                 GdkRGBA* colorb,
                                 gfloat percentage,
                                 GdkRGBA* result)
{
	GdkRGBA color = {0};
	gfloat diff = 0.0F;
	GdkRGBA _tmp0_;
	GdkRGBA _tmp1_;
	GdkRGBA _tmp2_;
	GdkRGBA _tmp3_;
	GdkRGBA _tmp4_;
	GdkRGBA _tmp5_;
	GdkRGBA _tmp6_;
	GdkRGBA _tmp7_;
	GdkRGBA _tmp8_;
#line 394 "../src/baobab-chart.vala"
	g_return_if_fail (self != NULL);
#line 394 "../src/baobab-chart.vala"
	g_return_if_fail (colora != NULL);
#line 394 "../src/baobab-chart.vala"
	g_return_if_fail (colorb != NULL);
#line 395 "../src/baobab-chart.vala"
	memset (&color, 0, sizeof (GdkRGBA));
#line 399 "../src/baobab-chart.vala"
	_tmp0_ = *colora;
#line 399 "../src/baobab-chart.vala"
	_tmp1_ = *colorb;
#line 399 "../src/baobab-chart.vala"
	diff = _tmp0_.red - _tmp1_.red;
#line 400 "../src/baobab-chart.vala"
	_tmp2_ = *colora;
#line 400 "../src/baobab-chart.vala"
	color.red = _tmp2_.red - (diff * percentage);
#line 401 "../src/baobab-chart.vala"
	_tmp3_ = *colora;
#line 401 "../src/baobab-chart.vala"
	_tmp4_ = *colorb;
#line 401 "../src/baobab-chart.vala"
	diff = _tmp3_.green - _tmp4_.green;
#line 402 "../src/baobab-chart.vala"
	_tmp5_ = *colora;
#line 402 "../src/baobab-chart.vala"
	color.green = _tmp5_.green - (diff * percentage);
#line 403 "../src/baobab-chart.vala"
	_tmp6_ = *colora;
#line 403 "../src/baobab-chart.vala"
	_tmp7_ = *colorb;
#line 403 "../src/baobab-chart.vala"
	diff = _tmp6_.blue - _tmp7_.blue;
#line 404 "../src/baobab-chart.vala"
	_tmp8_ = *colora;
#line 404 "../src/baobab-chart.vala"
	color.blue = _tmp8_.blue - (diff * percentage);
#line 406 "../src/baobab-chart.vala"
	color.alpha = (gfloat) 1.0;
#line 408 "../src/baobab-chart.vala"
	*result = color;
#line 408 "../src/baobab-chart.vala"
	return;
#line 1859 "baobab-chart.c"
}

void
baobab_chart_get_item_color (BaobabChart* self,
                             gdouble rel_position,
                             guint depth,
                             gboolean highlighted,
                             GdkRGBA* result)
{
	GdkRGBA color = {0};
	gfloat intensity = 0.0F;
#line 411 "../src/baobab-chart.vala"
	g_return_if_fail (self != NULL);
#line 412 "../src/baobab-chart.vala"
	memset (&color, 0, sizeof (GdkRGBA));
#line 414 "../src/baobab-chart.vala"
	intensity = (gfloat) (1 - (((depth - 1) * 0.3) / BAOBAB_CHART_MAX_DEPTH));
#line 416 "../src/baobab-chart.vala"
	if (depth == ((guint) 0)) {
#line 417 "../src/baobab-chart.vala"
		gdk_rgba_parse (&color, "#d3d6d1");
#line 1881 "baobab-chart.c"
	} else {
		GdkRGBA color_a = {0};
		GdkRGBA color_b = {0};
		gint color_number = 0;
		gint next_color_number = 0;
		GdkRGBA _tmp0_;
		GdkRGBA _tmp1_;
		GdkRGBA _tmp2_;
		GdkRGBA _tmp3_;
		GdkRGBA _tmp4_ = {0};
#line 419 "../src/baobab-chart.vala"
		memset (&color_a, 0, sizeof (GdkRGBA));
#line 420 "../src/baobab-chart.vala"
		memset (&color_b, 0, sizeof (GdkRGBA));
#line 422 "../src/baobab-chart.vala"
		color_number = (gint) (rel_position / (100.0 / 3));
#line 423 "../src/baobab-chart.vala"
		next_color_number = (color_number + 1) % BAOBAB_CHART_NUM_COLORS;
#line 425 "../src/baobab-chart.vala"
		_tmp0_ = self->priv->chart_colors[color_number];
#line 425 "../src/baobab-chart.vala"
		color_a = _tmp0_;
#line 426 "../src/baobab-chart.vala"
		_tmp1_ = self->priv->chart_colors[next_color_number];
#line 426 "../src/baobab-chart.vala"
		color_b = _tmp1_;
#line 428 "../src/baobab-chart.vala"
		_tmp2_ = color_a;
#line 428 "../src/baobab-chart.vala"
		_tmp3_ = color_b;
#line 428 "../src/baobab-chart.vala"
		baobab_chart_interpolate_colors (self, &_tmp2_, &_tmp3_, ((gfloat) (rel_position - ((color_number * 100) / 3))) / (100 / 3), &_tmp4_);
#line 428 "../src/baobab-chart.vala"
		color = _tmp4_;
#line 430 "../src/baobab-chart.vala"
		color.red = color.red * intensity;
#line 431 "../src/baobab-chart.vala"
		color.green = color.green * intensity;
#line 432 "../src/baobab-chart.vala"
		color.blue = color.blue * intensity;
#line 1922 "baobab-chart.c"
	}
#line 435 "../src/baobab-chart.vala"
	if (highlighted) {
#line 436 "../src/baobab-chart.vala"
		if (depth == ((guint) 0)) {
#line 437 "../src/baobab-chart.vala"
			gdk_rgba_parse (&color, "#e0e2dd");
#line 1930 "baobab-chart.c"
		} else {
			gfloat maximum = 0.0F;
			GdkRGBA _tmp5_;
			GdkRGBA _tmp6_;
			GdkRGBA _tmp7_;
#line 439 "../src/baobab-chart.vala"
			_tmp5_ = color;
#line 439 "../src/baobab-chart.vala"
			_tmp6_ = color;
#line 439 "../src/baobab-chart.vala"
			_tmp7_ = color;
#line 439 "../src/baobab-chart.vala"
			maximum = MAX (_tmp5_.red, MAX (_tmp6_.green, _tmp7_.blue));
#line 440 "../src/baobab-chart.vala"
			color.red = color.red / maximum;
#line 441 "../src/baobab-chart.vala"
			color.green = color.green / maximum;
#line 442 "../src/baobab-chart.vala"
			color.blue = color.blue / maximum;
#line 1950 "baobab-chart.c"
		}
	}
#line 446 "../src/baobab-chart.vala"
	*result = color;
#line 446 "../src/baobab-chart.vala"
	return;
#line 1957 "baobab-chart.c"
}

static gboolean
baobab_chart_scroll_cb (BaobabChart* self,
                        gdouble dx,
                        gdouble dy)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 449 "../src/baobab-chart.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 451 "../src/baobab-chart.vala"
	if (dx > 0.0) {
#line 451 "../src/baobab-chart.vala"
		_tmp0_ = TRUE;
#line 1973 "baobab-chart.c"
	} else {
#line 451 "../src/baobab-chart.vala"
		_tmp0_ = dy < 0.0;
#line 1977 "baobab-chart.c"
	}
#line 451 "../src/baobab-chart.vala"
	if (_tmp0_) {
#line 452 "../src/baobab-chart.vala"
		baobab_chart_zoom_out (self);
#line 453 "../src/baobab-chart.vala"
		result = TRUE;
#line 453 "../src/baobab-chart.vala"
		return result;
#line 1987 "baobab-chart.c"
	} else {
		gboolean _tmp1_ = FALSE;
#line 455 "../src/baobab-chart.vala"
		if (dx < 0.0) {
#line 455 "../src/baobab-chart.vala"
			_tmp1_ = TRUE;
#line 1994 "baobab-chart.c"
		} else {
#line 455 "../src/baobab-chart.vala"
			_tmp1_ = dy > 0.0;
#line 1998 "baobab-chart.c"
		}
#line 455 "../src/baobab-chart.vala"
		if (_tmp1_) {
#line 456 "../src/baobab-chart.vala"
			baobab_chart_zoom_in (self);
#line 457 "../src/baobab-chart.vala"
			result = TRUE;
#line 457 "../src/baobab-chart.vala"
			return result;
#line 2008 "baobab-chart.c"
		}
	}
#line 460 "../src/baobab-chart.vala"
	result = FALSE;
#line 460 "../src/baobab-chart.vala"
	return result;
#line 2015 "baobab-chart.c"
}

void
baobab_chart_open_file (BaobabChart* self)
{
	GtkRoot* _tmp0_;
	BaobabChartItem* _tmp1_;
	BaobabChartItem* _tmp2_;
	BaobabScannerResults* _tmp3_;
#line 463 "../src/baobab-chart.vala"
	g_return_if_fail (self != NULL);
#line 464 "../src/baobab-chart.vala"
	_tmp0_ = gtk_widget_get_root ((GtkWidget*) self);
#line 464 "../src/baobab-chart.vala"
	_tmp1_ = baobab_chart_get_highlighted_item (self);
#line 464 "../src/baobab-chart.vala"
	_tmp2_ = _tmp1_;
#line 464 "../src/baobab-chart.vala"
	_tmp3_ = _tmp2_->results;
#line 464 "../src/baobab-chart.vala"
	baobab_window_open_item (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, BAOBAB_TYPE_WINDOW, BaobabWindow), _tmp3_);
#line 2037 "baobab-chart.c"
}

void
baobab_chart_copy_path (BaobabChart* self)
{
	GtkRoot* _tmp0_;
	BaobabChartItem* _tmp1_;
	BaobabChartItem* _tmp2_;
	BaobabScannerResults* _tmp3_;
#line 467 "../src/baobab-chart.vala"
	g_return_if_fail (self != NULL);
#line 468 "../src/baobab-chart.vala"
	_tmp0_ = gtk_widget_get_root ((GtkWidget*) self);
#line 468 "../src/baobab-chart.vala"
	_tmp1_ = baobab_chart_get_highlighted_item (self);
#line 468 "../src/baobab-chart.vala"
	_tmp2_ = _tmp1_;
#line 468 "../src/baobab-chart.vala"
	_tmp3_ = _tmp2_->results;
#line 468 "../src/baobab-chart.vala"
	baobab_window_copy_path (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, BAOBAB_TYPE_WINDOW, BaobabWindow), _tmp3_);
#line 2059 "baobab-chart.c"
}

void
baobab_chart_trash_file (BaobabChart* self)
{
	GtkRoot* _tmp0_;
	BaobabChartItem* _tmp1_;
	BaobabChartItem* _tmp2_;
	BaobabScannerResults* _tmp3_;
#line 471 "../src/baobab-chart.vala"
	g_return_if_fail (self != NULL);
#line 472 "../src/baobab-chart.vala"
	_tmp0_ = gtk_widget_get_root ((GtkWidget*) self);
#line 472 "../src/baobab-chart.vala"
	_tmp1_ = baobab_chart_get_highlighted_item (self);
#line 472 "../src/baobab-chart.vala"
	_tmp2_ = _tmp1_;
#line 472 "../src/baobab-chart.vala"
	_tmp3_ = _tmp2_->results;
#line 472 "../src/baobab-chart.vala"
	baobab_window_trash_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, BAOBAB_TYPE_WINDOW, BaobabWindow), _tmp3_);
#line 2081 "baobab-chart.c"
}

gboolean
baobab_chart_can_move_up_root (BaobabChart* self)
{
	BaobabScannerResults* _tmp0_;
	BaobabScannerResults* _tmp1_;
	BaobabScannerResults* _tmp2_;
	BaobabScannerResults* _tmp3_;
	BaobabScannerResults* _tmp4_;
	gboolean _tmp5_;
	gboolean result;
#line 475 "../src/baobab-chart.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 476 "../src/baobab-chart.vala"
	_tmp0_ = baobab_chart_get_tree_root (self);
#line 476 "../src/baobab-chart.vala"
	_tmp1_ = _tmp0_;
#line 476 "../src/baobab-chart.vala"
	_tmp2_ = _tmp1_;
#line 476 "../src/baobab-chart.vala"
	_tmp3_ = baobab_scanner_results_get_parent (_tmp2_);
#line 476 "../src/baobab-chart.vala"
	_tmp4_ = _tmp3_;
#line 476 "../src/baobab-chart.vala"
	_tmp5_ = _tmp4_ != NULL;
#line 476 "../src/baobab-chart.vala"
	_g_object_unref0 (_tmp2_);
#line 476 "../src/baobab-chart.vala"
	result = _tmp5_;
#line 476 "../src/baobab-chart.vala"
	return result;
#line 2114 "baobab-chart.c"
}

void
baobab_chart_move_up_root (BaobabChart* self)
{
	BaobabScannerResults* _tmp0_;
	BaobabScannerResults* _tmp1_;
	BaobabScannerResults* _tmp2_;
	BaobabScannerResults* _tmp3_;
	BaobabScannerResults* _tmp4_;
	gboolean _tmp5_;
#line 479 "../src/baobab-chart.vala"
	g_return_if_fail (self != NULL);
#line 480 "../src/baobab-chart.vala"
	_tmp0_ = baobab_chart_get_tree_root (self);
#line 480 "../src/baobab-chart.vala"
	_tmp1_ = _tmp0_;
#line 480 "../src/baobab-chart.vala"
	_tmp2_ = _tmp1_;
#line 480 "../src/baobab-chart.vala"
	_tmp3_ = baobab_scanner_results_get_parent (_tmp2_);
#line 480 "../src/baobab-chart.vala"
	_tmp4_ = _tmp3_;
#line 480 "../src/baobab-chart.vala"
	_tmp5_ = _tmp4_ != NULL;
#line 480 "../src/baobab-chart.vala"
	_g_object_unref0 (_tmp2_);
#line 480 "../src/baobab-chart.vala"
	if (_tmp5_) {
#line 2144 "baobab-chart.c"
		BaobabScannerResults* _tmp6_;
		BaobabScannerResults* _tmp7_;
		BaobabScannerResults* _tmp8_;
		BaobabScannerResults* _tmp9_;
		BaobabScannerResults* _tmp10_;
		BaobabScannerResults* _tmp11_;
		BaobabScannerResults* _tmp12_;
		BaobabScannerResults* _tmp13_;
#line 481 "../src/baobab-chart.vala"
		_tmp6_ = baobab_chart_get_tree_root (self);
#line 481 "../src/baobab-chart.vala"
		_tmp7_ = _tmp6_;
#line 481 "../src/baobab-chart.vala"
		_tmp8_ = _tmp7_;
#line 481 "../src/baobab-chart.vala"
		_tmp9_ = baobab_scanner_results_get_parent (_tmp8_);
#line 481 "../src/baobab-chart.vala"
		_tmp10_ = _tmp9_;
#line 481 "../src/baobab-chart.vala"
		baobab_chart_set_tree_root (self, _tmp10_);
#line 481 "../src/baobab-chart.vala"
		_g_object_unref0 (_tmp8_);
#line 482 "../src/baobab-chart.vala"
		_tmp11_ = baobab_chart_get_tree_root (self);
#line 482 "../src/baobab-chart.vala"
		_tmp12_ = _tmp11_;
#line 482 "../src/baobab-chart.vala"
		_tmp13_ = _tmp12_;
#line 482 "../src/baobab-chart.vala"
		g_signal_emit (self, baobab_chart_signals[BAOBAB_CHART_ITEM_ACTIVATED_SIGNAL], 0, _tmp13_);
#line 482 "../src/baobab-chart.vala"
		_g_object_unref0 (_tmp13_);
#line 2177 "baobab-chart.c"
	}
}

void
baobab_chart_zoom_in (BaobabChart* self)
{
#line 486 "../src/baobab-chart.vala"
	g_return_if_fail (self != NULL);
#line 487 "../src/baobab-chart.vala"
	if (baobab_chart_can_zoom_in (self)) {
#line 2188 "baobab-chart.c"
		guint _tmp0_;
		guint _tmp1_;
#line 488 "../src/baobab-chart.vala"
		_tmp0_ = baobab_chart_get_max_depth (self);
#line 488 "../src/baobab-chart.vala"
		_tmp1_ = _tmp0_;
#line 488 "../src/baobab-chart.vala"
		baobab_chart_set_max_depth (self, _tmp1_ - 1);
#line 2197 "baobab-chart.c"
	}
}

void
baobab_chart_zoom_out (BaobabChart* self)
{
#line 492 "../src/baobab-chart.vala"
	g_return_if_fail (self != NULL);
#line 493 "../src/baobab-chart.vala"
	if (baobab_chart_can_zoom_out (self)) {
#line 2208 "baobab-chart.c"
		guint _tmp0_;
		guint _tmp1_;
#line 494 "../src/baobab-chart.vala"
		_tmp0_ = baobab_chart_get_max_depth (self);
#line 494 "../src/baobab-chart.vala"
		_tmp1_ = _tmp0_;
#line 494 "../src/baobab-chart.vala"
		baobab_chart_set_max_depth (self, _tmp1_ + 1);
#line 2217 "baobab-chart.c"
	}
}

static void
baobab_chart_build_context_menu (BaobabChart* self)
{
	GMenu* menu_model = NULL;
	BaobabApplication* _tmp0_;
	BaobabApplication* _tmp1_;
	GMenu* _tmp2_;
	GMenu* _tmp3_;
	GMenu* _tmp4_;
	GtkPopoverMenu* _tmp5_;
	GtkPopoverMenu* _tmp6_;
	GtkPopoverMenu* _tmp7_;
#line 498 "../src/baobab-chart.vala"
	g_return_if_fail (self != NULL);
#line 499 "../src/baobab-chart.vala"
	_tmp0_ = baobab_application_get_default ();
#line 499 "../src/baobab-chart.vala"
	_tmp1_ = _tmp0_;
#line 499 "../src/baobab-chart.vala"
	_tmp2_ = gtk_application_get_menu_by_id ((GtkApplication*) _tmp1_, "chartmenu");
#line 499 "../src/baobab-chart.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 499 "../src/baobab-chart.vala"
	_tmp4_ = _tmp3_;
#line 499 "../src/baobab-chart.vala"
	_g_object_unref0 (_tmp1_);
#line 499 "../src/baobab-chart.vala"
	menu_model = _tmp4_;
#line 500 "../src/baobab-chart.vala"
	_tmp5_ = (GtkPopoverMenu*) gtk_popover_menu_new_from_model ((GMenuModel*) menu_model);
#line 500 "../src/baobab-chart.vala"
	g_object_ref_sink (_tmp5_);
#line 500 "../src/baobab-chart.vala"
	_g_object_unref0 (self->priv->context_menu);
#line 500 "../src/baobab-chart.vala"
	self->priv->context_menu = _tmp5_;
#line 501 "../src/baobab-chart.vala"
	_tmp6_ = self->priv->context_menu;
#line 501 "../src/baobab-chart.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp6_, (GtkWidget*) self);
#line 502 "../src/baobab-chart.vala"
	_tmp7_ = self->priv->context_menu;
#line 502 "../src/baobab-chart.vala"
	gtk_popover_set_position ((GtkPopover*) _tmp7_, GTK_POS_BOTTOM);
#line 498 "../src/baobab-chart.vala"
	_g_object_unref0 (menu_model);
#line 2267 "baobab-chart.c"
}

static void
baobab_chart_show_popover_at (BaobabChart* self,
                              gint x,
                              gint y)
{
	gboolean enable = FALSE;
	BaobabChartItem* _tmp0_;
	BaobabChartItem* _tmp1_;
	GSimpleAction* action = NULL;
	GSimpleActionGroup* _tmp2_;
	GAction* _tmp3_;
	GSimpleAction* _tmp4_;
	GSimpleAction* _tmp5_;
	GSimpleActionGroup* _tmp6_;
	GAction* _tmp7_;
	GSimpleAction* _tmp8_;
	GSimpleAction* _tmp9_;
	GSimpleActionGroup* _tmp10_;
	GAction* _tmp11_;
	GSimpleAction* _tmp12_;
	GSimpleAction* _tmp13_;
	GSimpleActionGroup* _tmp14_;
	GAction* _tmp15_;
	GSimpleAction* _tmp16_;
	GSimpleAction* _tmp17_;
	GSimpleActionGroup* _tmp18_;
	GAction* _tmp19_;
	GSimpleAction* _tmp20_;
	GSimpleAction* _tmp21_;
	GSimpleActionGroup* _tmp22_;
	GAction* _tmp23_;
	GSimpleAction* _tmp24_;
	GSimpleAction* _tmp25_;
	GdkRectangle rect = {0};
	GdkRectangle _tmp26_ = {0};
	GtkPopoverMenu* _tmp27_;
	GdkRectangle _tmp28_;
	GtkPopoverMenu* _tmp29_;
#line 505 "../src/baobab-chart.vala"
	g_return_if_fail (self != NULL);
#line 506 "../src/baobab-chart.vala"
	_tmp0_ = baobab_chart_get_highlighted_item (self);
#line 506 "../src/baobab-chart.vala"
	_tmp1_ = _tmp0_;
#line 506 "../src/baobab-chart.vala"
	enable = _tmp1_ != NULL;
#line 507 "../src/baobab-chart.vala"
	_tmp2_ = self->priv->action_group;
#line 507 "../src/baobab-chart.vala"
	_tmp3_ = g_action_map_lookup_action ((GActionMap*) _tmp2_, "open-file");
#line 507 "../src/baobab-chart.vala"
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp3_) : NULL);
#line 507 "../src/baobab-chart.vala"
	action = _tmp4_;
#line 508 "../src/baobab-chart.vala"
	_tmp5_ = action;
#line 508 "../src/baobab-chart.vala"
	g_simple_action_set_enabled (_tmp5_, enable);
#line 509 "../src/baobab-chart.vala"
	_tmp6_ = self->priv->action_group;
#line 509 "../src/baobab-chart.vala"
	_tmp7_ = g_action_map_lookup_action ((GActionMap*) _tmp6_, "copy-path");
#line 509 "../src/baobab-chart.vala"
	_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp7_) : NULL);
#line 509 "../src/baobab-chart.vala"
	_g_object_unref0 (action);
#line 509 "../src/baobab-chart.vala"
	action = _tmp8_;
#line 510 "../src/baobab-chart.vala"
	_tmp9_ = action;
#line 510 "../src/baobab-chart.vala"
	g_simple_action_set_enabled (_tmp9_, enable);
#line 511 "../src/baobab-chart.vala"
	_tmp10_ = self->priv->action_group;
#line 511 "../src/baobab-chart.vala"
	_tmp11_ = g_action_map_lookup_action ((GActionMap*) _tmp10_, "trash-file");
#line 511 "../src/baobab-chart.vala"
	_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp11_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp11_) : NULL);
#line 511 "../src/baobab-chart.vala"
	_g_object_unref0 (action);
#line 511 "../src/baobab-chart.vala"
	action = _tmp12_;
#line 512 "../src/baobab-chart.vala"
	_tmp13_ = action;
#line 512 "../src/baobab-chart.vala"
	g_simple_action_set_enabled (_tmp13_, enable);
#line 514 "../src/baobab-chart.vala"
	_tmp14_ = self->priv->action_group;
#line 514 "../src/baobab-chart.vala"
	_tmp15_ = g_action_map_lookup_action ((GActionMap*) _tmp14_, "move-up");
#line 514 "../src/baobab-chart.vala"
	_tmp16_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp15_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp15_) : NULL);
#line 514 "../src/baobab-chart.vala"
	_g_object_unref0 (action);
#line 514 "../src/baobab-chart.vala"
	action = _tmp16_;
#line 515 "../src/baobab-chart.vala"
	_tmp17_ = action;
#line 515 "../src/baobab-chart.vala"
	g_simple_action_set_enabled (_tmp17_, baobab_chart_can_move_up_root (self));
#line 517 "../src/baobab-chart.vala"
	_tmp18_ = self->priv->action_group;
#line 517 "../src/baobab-chart.vala"
	_tmp19_ = g_action_map_lookup_action ((GActionMap*) _tmp18_, "zoom-in");
#line 517 "../src/baobab-chart.vala"
	_tmp20_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp19_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp19_) : NULL);
#line 517 "../src/baobab-chart.vala"
	_g_object_unref0 (action);
#line 517 "../src/baobab-chart.vala"
	action = _tmp20_;
#line 518 "../src/baobab-chart.vala"
	_tmp21_ = action;
#line 518 "../src/baobab-chart.vala"
	g_simple_action_set_enabled (_tmp21_, baobab_chart_can_zoom_in (self));
#line 519 "../src/baobab-chart.vala"
	_tmp22_ = self->priv->action_group;
#line 519 "../src/baobab-chart.vala"
	_tmp23_ = g_action_map_lookup_action ((GActionMap*) _tmp22_, "zoom-out");
#line 519 "../src/baobab-chart.vala"
	_tmp24_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp23_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp23_) : NULL);
#line 519 "../src/baobab-chart.vala"
	_g_object_unref0 (action);
#line 519 "../src/baobab-chart.vala"
	action = _tmp24_;
#line 520 "../src/baobab-chart.vala"
	_tmp25_ = action;
#line 520 "../src/baobab-chart.vala"
	g_simple_action_set_enabled (_tmp25_, baobab_chart_can_zoom_out (self));
#line 522 "../src/baobab-chart.vala"
	_tmp26_.x = x;
#line 522 "../src/baobab-chart.vala"
	_tmp26_.y = y;
#line 522 "../src/baobab-chart.vala"
	_tmp26_.width = 0;
#line 522 "../src/baobab-chart.vala"
	_tmp26_.height = 0;
#line 522 "../src/baobab-chart.vala"
	rect = _tmp26_;
#line 523 "../src/baobab-chart.vala"
	_tmp27_ = self->priv->context_menu;
#line 523 "../src/baobab-chart.vala"
	_tmp28_ = rect;
#line 523 "../src/baobab-chart.vala"
	gtk_popover_set_pointing_to ((GtkPopover*) _tmp27_, &_tmp28_);
#line 524 "../src/baobab-chart.vala"
	_tmp29_ = self->priv->context_menu;
#line 524 "../src/baobab-chart.vala"
	gtk_popover_popup ((GtkPopover*) _tmp29_);
#line 505 "../src/baobab-chart.vala"
	_g_object_unref0 (action);
#line 2420 "baobab-chart.c"
}

static void
_baobab_chart_items_changed_g_list_model_items_changed (GListModel* _sender,
                                                        guint position,
                                                        guint removed,
                                                        guint added,
                                                        gpointer self)
{
#line 528 "../src/baobab-chart.vala"
	baobab_chart_items_changed ((BaobabChart*) self, position, removed, added);
#line 2432 "baobab-chart.c"
}

static void
baobab_chart_connect_model_signals (BaobabChart* self,
                                    GtkTreeListModel* m)
{
#line 527 "../src/baobab-chart.vala"
	g_return_if_fail (self != NULL);
#line 527 "../src/baobab-chart.vala"
	g_return_if_fail (m != NULL);
#line 528 "../src/baobab-chart.vala"
	g_signal_connect_object ((GListModel*) m, "items-changed", (GCallback) _baobab_chart_items_changed_g_list_model_items_changed, self, 0);
#line 2445 "baobab-chart.c"
}

static void
baobab_chart_disconnect_model_signals (BaobabChart* self,
                                       GtkTreeListModel* m)
{
	guint _tmp0_;
#line 531 "../src/baobab-chart.vala"
	g_return_if_fail (self != NULL);
#line 531 "../src/baobab-chart.vala"
	g_return_if_fail (m != NULL);
#line 532 "../src/baobab-chart.vala"
	g_signal_parse_name ("items-changed", g_list_model_get_type (), &_tmp0_, NULL, FALSE);
#line 532 "../src/baobab-chart.vala"
	g_signal_handlers_disconnect_matched ((GListModel*) m, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _baobab_chart_items_changed_g_list_model_items_changed, self);
#line 2461 "baobab-chart.c"
}

static gboolean
baobab_chart_real_query_tooltip (GtkWidget* base,
                                 gint x,
                                 gint y,
                                 gboolean keyboard_tooltip,
                                 GtkTooltip* tooltip)
{
	BaobabChart * self;
	BaobabChartItem* _tmp0_;
	BaobabChartItem* _tmp1_;
	BaobabChartItem* _tmp2_;
	BaobabChartItem* _tmp3_;
	GdkRectangle _tmp4_;
	gchar* size = NULL;
	BaobabChartItem* _tmp5_;
	BaobabChartItem* _tmp6_;
	BaobabScannerResults* _tmp7_;
	guint64 _tmp8_;
	guint64 _tmp9_;
	gchar* _tmp10_;
	gchar* markup = NULL;
	BaobabChartItem* _tmp11_;
	BaobabChartItem* _tmp12_;
	BaobabScannerResults* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gboolean result;
#line 535 "../src/baobab-chart.vala"
	self = (BaobabChart*) base;
#line 535 "../src/baobab-chart.vala"
	g_return_val_if_fail (tooltip != NULL, FALSE);
#line 536 "../src/baobab-chart.vala"
	_tmp0_ = baobab_chart_get_highlighted_item (self);
#line 536 "../src/baobab-chart.vala"
	_tmp1_ = _tmp0_;
#line 536 "../src/baobab-chart.vala"
	if (_tmp1_ == NULL) {
#line 537 "../src/baobab-chart.vala"
		result = FALSE;
#line 537 "../src/baobab-chart.vala"
		return result;
#line 2513 "baobab-chart.c"
	}
#line 540 "../src/baobab-chart.vala"
	_tmp2_ = baobab_chart_get_highlighted_item (self);
#line 540 "../src/baobab-chart.vala"
	_tmp3_ = _tmp2_;
#line 540 "../src/baobab-chart.vala"
	_tmp4_ = _tmp3_->rect;
#line 540 "../src/baobab-chart.vala"
	gtk_tooltip_set_tip_area (tooltip, &_tmp4_);
#line 542 "../src/baobab-chart.vala"
	_tmp5_ = baobab_chart_get_highlighted_item (self);
#line 542 "../src/baobab-chart.vala"
	_tmp6_ = _tmp5_;
#line 542 "../src/baobab-chart.vala"
	_tmp7_ = _tmp6_->results;
#line 542 "../src/baobab-chart.vala"
	_tmp8_ = baobab_scanner_results_get_size (_tmp7_);
#line 542 "../src/baobab-chart.vala"
	_tmp9_ = _tmp8_;
#line 542 "../src/baobab-chart.vala"
	_tmp10_ = g_format_size_full (_tmp9_, G_FORMAT_SIZE_DEFAULT);
#line 542 "../src/baobab-chart.vala"
	size = _tmp10_;
#line 543 "../src/baobab-chart.vala"
	_tmp11_ = baobab_chart_get_highlighted_item (self);
#line 543 "../src/baobab-chart.vala"
	_tmp12_ = _tmp11_;
#line 543 "../src/baobab-chart.vala"
	_tmp13_ = _tmp12_->results;
#line 543 "../src/baobab-chart.vala"
	_tmp14_ = baobab_scanner_results_get_display_name (_tmp13_);
#line 543 "../src/baobab-chart.vala"
	_tmp15_ = _tmp14_;
#line 543 "../src/baobab-chart.vala"
	_tmp16_ = g_strconcat (_tmp15_, "\n", NULL);
#line 543 "../src/baobab-chart.vala"
	_tmp17_ = _tmp16_;
#line 543 "../src/baobab-chart.vala"
	_tmp18_ = size;
#line 543 "../src/baobab-chart.vala"
	_tmp19_ = g_strconcat (_tmp17_, _tmp18_, NULL);
#line 543 "../src/baobab-chart.vala"
	_tmp20_ = _tmp19_;
#line 543 "../src/baobab-chart.vala"
	_g_free0 (_tmp17_);
#line 543 "../src/baobab-chart.vala"
	markup = _tmp20_;
#line 544 "../src/baobab-chart.vala"
	_tmp21_ = markup;
#line 544 "../src/baobab-chart.vala"
	_tmp22_ = g_markup_escape_text (_tmp21_, (gssize) -1);
#line 544 "../src/baobab-chart.vala"
	_tmp23_ = _tmp22_;
#line 544 "../src/baobab-chart.vala"
	gtk_tooltip_set_markup (tooltip, _tmp23_);
#line 544 "../src/baobab-chart.vala"
	_g_free0 (_tmp23_);
#line 546 "../src/baobab-chart.vala"
	result = TRUE;
#line 546 "../src/baobab-chart.vala"
	_g_free0 (markup);
#line 546 "../src/baobab-chart.vala"
	_g_free0 (size);
#line 546 "../src/baobab-chart.vala"
	return result;
#line 2579 "baobab-chart.c"
}

BaobabChart*
baobab_chart_construct (GType object_type)
{
	BaobabChart * self = NULL;
#line 49 "../src/baobab-chart.vala"
	self = (BaobabChart*) g_object_new (object_type, NULL);
#line 49 "../src/baobab-chart.vala"
	return self;
#line 2590 "baobab-chart.c"
}

BaobabLocation*
baobab_chart_get_location (BaobabChart* self)
{
	BaobabLocation* result;
	BaobabLocation* _tmp0_;
#line 79 "../src/baobab-chart.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 80 "../src/baobab-chart.vala"
	_tmp0_ = self->priv->location_;
#line 80 "../src/baobab-chart.vala"
	result = _tmp0_;
#line 80 "../src/baobab-chart.vala"
	return result;
#line 2606 "baobab-chart.c"
}

static gpointer
_baobab_location_ref0 (gpointer self)
{
#line 74 "../src/baobab-chart.vala"
	return self ? baobab_location_ref (self) : NULL;
#line 2614 "baobab-chart.c"
}

void
baobab_chart_set_location (BaobabChart* self,
                           BaobabLocation* value)
{
	BaobabLocation* _tmp0_;
	BaobabLocation* _tmp1_;
	BaobabScanner* _tmp2_;
	BaobabScanner* _tmp3_;
	BaobabScannerResults* _tmp4_;
	BaobabScannerResults* _tmp5_;
	GtkTreeListModel* _tmp6_;
	GtkTreeListModel* _tmp7_;
	BaobabLocation* _tmp8_;
	BaobabScanner* _tmp9_;
	BaobabScanner* _tmp10_;
#line 73 "../src/baobab-chart.vala"
	g_return_if_fail (self != NULL);
#line 74 "../src/baobab-chart.vala"
	_tmp0_ = _baobab_location_ref0 (value);
#line 74 "../src/baobab-chart.vala"
	_baobab_location_unref0 (self->priv->location_);
#line 74 "../src/baobab-chart.vala"
	self->priv->location_ = _tmp0_;
#line 75 "../src/baobab-chart.vala"
	_tmp1_ = self->priv->location_;
#line 75 "../src/baobab-chart.vala"
	_tmp2_ = baobab_location_get_scanner (_tmp1_);
#line 75 "../src/baobab-chart.vala"
	_tmp3_ = _tmp2_;
#line 75 "../src/baobab-chart.vala"
	_tmp4_ = baobab_scanner_get_root (_tmp3_);
#line 75 "../src/baobab-chart.vala"
	_tmp5_ = _tmp4_;
#line 75 "../src/baobab-chart.vala"
	_tmp6_ = baobab_scanner_results_create_tree_model (_tmp5_);
#line 75 "../src/baobab-chart.vala"
	_tmp7_ = _tmp6_;
#line 75 "../src/baobab-chart.vala"
	baobab_chart_set_model (self, _tmp7_);
#line 75 "../src/baobab-chart.vala"
	_g_object_unref0 (_tmp7_);
#line 76 "../src/baobab-chart.vala"
	_tmp8_ = self->priv->location_;
#line 76 "../src/baobab-chart.vala"
	_tmp9_ = baobab_location_get_scanner (_tmp8_);
#line 76 "../src/baobab-chart.vala"
	_tmp10_ = _tmp9_;
#line 76 "../src/baobab-chart.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp10_, "max-depth", (GObject*) self, "max-depth", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 73 "../src/baobab-chart.vala"
	g_object_notify_by_pspec ((GObject *) self, baobab_chart_properties[BAOBAB_CHART_LOCATION_PROPERTY]);
#line 2668 "baobab-chart.c"
}

guint
baobab_chart_get_max_depth (BaobabChart* self)
{
	guint result;
#line 95 "../src/baobab-chart.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 96 "../src/baobab-chart.vala"
	result = self->priv->max_depth_;
#line 96 "../src/baobab-chart.vala"
	return result;
#line 2681 "baobab-chart.c"
}

void
baobab_chart_set_max_depth (BaobabChart* self,
                            guint value)
{
	guint m = 0U;
#line 86 "../src/baobab-chart.vala"
	g_return_if_fail (self != NULL);
#line 87 "../src/baobab-chart.vala"
	m = CLAMP (value, BAOBAB_CHART_MIN_DEPTH, BAOBAB_CHART_MAX_DEPTH);
#line 88 "../src/baobab-chart.vala"
	if (self->priv->max_depth_ == m) {
#line 89 "../src/baobab-chart.vala"
		return;
#line 2697 "baobab-chart.c"
	}
#line 91 "../src/baobab-chart.vala"
	self->priv->max_depth_ = m;
#line 92 "../src/baobab-chart.vala"
	self->priv->model_changed = TRUE;
#line 93 "../src/baobab-chart.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 86 "../src/baobab-chart.vala"
	g_object_notify_by_pspec ((GObject *) self, baobab_chart_properties[BAOBAB_CHART_MAX_DEPTH_PROPERTY]);
#line 2707 "baobab-chart.c"
}

GtkTreeListModel*
baobab_chart_get_model (BaobabChart* self)
{
	GtkTreeListModel* result;
	GtkTreeListModel* _tmp0_;
#line 120 "../src/baobab-chart.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 121 "../src/baobab-chart.vala"
	_tmp0_ = self->priv->model_;
#line 121 "../src/baobab-chart.vala"
	result = _tmp0_;
#line 121 "../src/baobab-chart.vala"
	return result;
#line 2723 "baobab-chart.c"
}

void
baobab_chart_set_model (BaobabChart* self,
                        GtkTreeListModel* value)
{
	GtkTreeListModel* _tmp0_;
	GtkTreeListModel* _tmp1_;
	GtkTreeListModel* _tmp3_;
	GtkTreeListModel* _tmp4_;
#line 102 "../src/baobab-chart.vala"
	g_return_if_fail (self != NULL);
#line 103 "../src/baobab-chart.vala"
	_tmp0_ = self->priv->model_;
#line 103 "../src/baobab-chart.vala"
	if (_tmp0_ == value) {
#line 104 "../src/baobab-chart.vala"
		return;
#line 2742 "baobab-chart.c"
	}
#line 107 "../src/baobab-chart.vala"
	_tmp1_ = self->priv->model_;
#line 107 "../src/baobab-chart.vala"
	if (_tmp1_ != NULL) {
#line 2748 "baobab-chart.c"
		GtkTreeListModel* _tmp2_;
#line 108 "../src/baobab-chart.vala"
		_tmp2_ = self->priv->model_;
#line 108 "../src/baobab-chart.vala"
		baobab_chart_disconnect_model_signals (self, _tmp2_);
#line 2754 "baobab-chart.c"
	}
#line 111 "../src/baobab-chart.vala"
	_tmp3_ = _g_object_ref0 (value);
#line 111 "../src/baobab-chart.vala"
	_g_object_unref0 (self->priv->model_);
#line 111 "../src/baobab-chart.vala"
	self->priv->model_ = _tmp3_;
#line 112 "../src/baobab-chart.vala"
	self->priv->model_changed = TRUE;
#line 114 "../src/baobab-chart.vala"
	baobab_chart_set_tree_root (self, NULL);
#line 116 "../src/baobab-chart.vala"
	_tmp4_ = self->priv->model_;
#line 116 "../src/baobab-chart.vala"
	baobab_chart_connect_model_signals (self, _tmp4_);
#line 118 "../src/baobab-chart.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 102 "../src/baobab-chart.vala"
	g_object_notify_by_pspec ((GObject *) self, baobab_chart_properties[BAOBAB_CHART_MODEL_PROPERTY]);
#line 2774 "baobab-chart.c"
}

BaobabScannerResults*
baobab_chart_get_tree_root (BaobabChart* self)
{
	BaobabScannerResults* result;
	BaobabScannerResults* _tmp0_;
	gboolean _tmp3_ = FALSE;
	BaobabLocation* _tmp4_;
	BaobabLocation* _tmp5_;
#line 141 "../src/baobab-chart.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 142 "../src/baobab-chart.vala"
	_tmp0_ = self->priv->root_;
#line 142 "../src/baobab-chart.vala"
	if (_tmp0_ != NULL) {
#line 2791 "baobab-chart.c"
		BaobabScannerResults* _tmp1_;
		BaobabScannerResults* _tmp2_;
#line 143 "../src/baobab-chart.vala"
		_tmp1_ = self->priv->root_;
#line 143 "../src/baobab-chart.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 143 "../src/baobab-chart.vala"
		result = _tmp2_;
#line 143 "../src/baobab-chart.vala"
		return result;
#line 2802 "baobab-chart.c"
	}
#line 147 "../src/baobab-chart.vala"
	_tmp4_ = baobab_chart_get_location (self);
#line 147 "../src/baobab-chart.vala"
	_tmp5_ = _tmp4_;
#line 147 "../src/baobab-chart.vala"
	if (_tmp5_ != NULL) {
#line 2810 "baobab-chart.c"
		BaobabLocation* _tmp6_;
		BaobabScanner* _tmp7_;
		BaobabScanner* _tmp8_;
#line 147 "../src/baobab-chart.vala"
		_tmp6_ = self->priv->location_;
#line 147 "../src/baobab-chart.vala"
		_tmp7_ = baobab_location_get_scanner (_tmp6_);
#line 147 "../src/baobab-chart.vala"
		_tmp8_ = _tmp7_;
#line 147 "../src/baobab-chart.vala"
		_tmp3_ = _tmp8_ != NULL;
#line 2822 "baobab-chart.c"
	} else {
#line 147 "../src/baobab-chart.vala"
		_tmp3_ = FALSE;
#line 2826 "baobab-chart.c"
	}
#line 147 "../src/baobab-chart.vala"
	if (_tmp3_) {
#line 2830 "baobab-chart.c"
		BaobabLocation* _tmp9_;
		BaobabScanner* _tmp10_;
		BaobabScanner* _tmp11_;
		BaobabScannerResults* _tmp12_;
		BaobabScannerResults* _tmp13_;
		BaobabScannerResults* _tmp14_;
#line 148 "../src/baobab-chart.vala"
		_tmp9_ = self->priv->location_;
#line 148 "../src/baobab-chart.vala"
		_tmp10_ = baobab_location_get_scanner (_tmp9_);
#line 148 "../src/baobab-chart.vala"
		_tmp11_ = _tmp10_;
#line 148 "../src/baobab-chart.vala"
		_tmp12_ = baobab_scanner_get_root (_tmp11_);
#line 148 "../src/baobab-chart.vala"
		_tmp13_ = _tmp12_;
#line 148 "../src/baobab-chart.vala"
		_tmp14_ = _g_object_ref0 (_tmp13_);
#line 148 "../src/baobab-chart.vala"
		result = _tmp14_;
#line 148 "../src/baobab-chart.vala"
		return result;
#line 2853 "baobab-chart.c"
	}
#line 151 "../src/baobab-chart.vala"
	result = NULL;
#line 151 "../src/baobab-chart.vala"
	return result;
#line 2859 "baobab-chart.c"
}

void
baobab_chart_set_tree_root (BaobabChart* self,
                            BaobabScannerResults* value)
{
	GtkTreeListModel* _tmp0_;
	GtkTreeListModel* _tmp1_;
	BaobabScannerResults* _tmp2_;
	BaobabScannerResults* _tmp3_;
#line 127 "../src/baobab-chart.vala"
	g_return_if_fail (self != NULL);
#line 128 "../src/baobab-chart.vala"
	_tmp0_ = baobab_chart_get_model (self);
#line 128 "../src/baobab-chart.vala"
	_tmp1_ = _tmp0_;
#line 128 "../src/baobab-chart.vala"
	if (_tmp1_ == NULL) {
#line 129 "../src/baobab-chart.vala"
		return;
#line 2880 "baobab-chart.c"
	}
#line 132 "../src/baobab-chart.vala"
	_tmp2_ = self->priv->root_;
#line 132 "../src/baobab-chart.vala"
	if (_tmp2_ == value) {
#line 133 "../src/baobab-chart.vala"
		return;
#line 2888 "baobab-chart.c"
	}
#line 135 "../src/baobab-chart.vala"
	_tmp3_ = _g_object_ref0 (value);
#line 135 "../src/baobab-chart.vala"
	_g_object_unref0 (self->priv->root_);
#line 135 "../src/baobab-chart.vala"
	self->priv->root_ = _tmp3_;
#line 137 "../src/baobab-chart.vala"
	baobab_chart_set_highlighted_item (self, NULL);
#line 139 "../src/baobab-chart.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 127 "../src/baobab-chart.vala"
	g_object_notify_by_pspec ((GObject *) self, baobab_chart_properties[BAOBAB_CHART_TREE_ROOT_PROPERTY]);
#line 2902 "baobab-chart.c"
}

BaobabChartItem*
baobab_chart_get_highlighted_item (BaobabChart* self)
{
	BaobabChartItem* result;
	BaobabChartItem* _tmp0_;
#line 171 "../src/baobab-chart.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 172 "../src/baobab-chart.vala"
	_tmp0_ = self->priv->highlighted_item_;
#line 172 "../src/baobab-chart.vala"
	result = _tmp0_;
#line 172 "../src/baobab-chart.vala"
	return result;
#line 2918 "baobab-chart.c"
}

void
baobab_chart_set_highlighted_item (BaobabChart* self,
                                   BaobabChartItem* value)
{
	BaobabChartItem* _tmp0_;
	BaobabChartItem* _tmp1_;
	BaobabChartItem* _tmp2_;
#line 157 "../src/baobab-chart.vala"
	g_return_if_fail (self != NULL);
#line 158 "../src/baobab-chart.vala"
	_tmp0_ = self->priv->highlighted_item_;
#line 158 "../src/baobab-chart.vala"
	if (_tmp0_ == value) {
#line 159 "../src/baobab-chart.vala"
		return;
#line 2936 "baobab-chart.c"
	}
#line 162 "../src/baobab-chart.vala"
	_tmp1_ = self->priv->highlighted_item_;
#line 162 "../src/baobab-chart.vala"
	if (_tmp1_ != NULL) {
#line 163 "../src/baobab-chart.vala"
		gtk_widget_queue_draw ((GtkWidget*) self);
#line 2944 "baobab-chart.c"
	}
#line 165 "../src/baobab-chart.vala"
	if (value != NULL) {
#line 166 "../src/baobab-chart.vala"
		gtk_widget_queue_draw ((GtkWidget*) self);
#line 2950 "baobab-chart.c"
	}
#line 169 "../src/baobab-chart.vala"
	_tmp2_ = _baobab_chart_item_ref0 (value);
#line 169 "../src/baobab-chart.vala"
	_baobab_chart_item_unref0 (self->priv->highlighted_item_);
#line 169 "../src/baobab-chart.vala"
	self->priv->highlighted_item_ = _tmp2_;
#line 157 "../src/baobab-chart.vala"
	g_object_notify_by_pspec ((GObject *) self, baobab_chart_properties[BAOBAB_CHART_HIGHLIGHTED_ITEM_PROPERTY]);
#line 2960 "baobab-chart.c"
}

static gboolean
_baobab_chart_scroll_cb_gtk_event_controller_scroll_scroll (GtkEventControllerScroll* _sender,
                                                            gdouble dx,
                                                            gdouble dy,
                                                            gpointer self)
{
	gboolean result;
	result = baobab_chart_scroll_cb ((BaobabChart*) self, dx, dy);
#line 206 "../src/baobab-chart.vala"
	return result;
#line 2973 "baobab-chart.c"
}

static void
_baobab_chart_motion_cb_gtk_event_controller_motion_motion (GtkEventControllerMotion* _sender,
                                                            gdouble x,
                                                            gdouble y,
                                                            gpointer self)
{
#line 210 "../src/baobab-chart.vala"
	baobab_chart_motion_cb ((BaobabChart*) self, x, y);
#line 2984 "baobab-chart.c"
}

static void
_baobab_chart_enter_cb_gtk_event_controller_motion_enter (GtkEventControllerMotion* _sender,
                                                          gdouble x,
                                                          gdouble y,
                                                          gpointer self)
{
#line 211 "../src/baobab-chart.vala"
	baobab_chart_enter_cb ((BaobabChart*) self, x, y);
#line 2995 "baobab-chart.c"
}

static void
_baobab_chart___lambda15_ (BaobabChart* self,
                           gint _,
                           gdouble x,
                           gdouble y)
{
#line 217 "../src/baobab-chart.vala"
	if (baobab_chart_highlight_item_at_point (self, x, y)) {
#line 3006 "baobab-chart.c"
		BaobabScannerResults* _tmp0_;
		BaobabScannerResults* _tmp1_;
		BaobabScannerResults* _tmp2_;
		BaobabChartItem* _tmp3_;
		BaobabChartItem* _tmp4_;
		BaobabScannerResults* _tmp5_;
		gboolean _tmp6_;
#line 218 "../src/baobab-chart.vala"
		_tmp0_ = baobab_chart_get_tree_root (self);
#line 218 "../src/baobab-chart.vala"
		_tmp1_ = _tmp0_;
#line 218 "../src/baobab-chart.vala"
		_tmp2_ = _tmp1_;
#line 218 "../src/baobab-chart.vala"
		_tmp3_ = baobab_chart_get_highlighted_item (self);
#line 218 "../src/baobab-chart.vala"
		_tmp4_ = _tmp3_;
#line 218 "../src/baobab-chart.vala"
		_tmp5_ = _tmp4_->results;
#line 218 "../src/baobab-chart.vala"
		_tmp6_ = _tmp2_ == _tmp5_;
#line 218 "../src/baobab-chart.vala"
		_g_object_unref0 (_tmp2_);
#line 218 "../src/baobab-chart.vala"
		if (_tmp6_) {
#line 219 "../src/baobab-chart.vala"
			baobab_chart_move_up_root (self);
#line 3034 "baobab-chart.c"
		} else {
			BaobabChartItem* _tmp7_;
			BaobabChartItem* _tmp8_;
			BaobabScannerResults* _tmp9_;
#line 221 "../src/baobab-chart.vala"
			_tmp7_ = baobab_chart_get_highlighted_item (self);
#line 221 "../src/baobab-chart.vala"
			_tmp8_ = _tmp7_;
#line 221 "../src/baobab-chart.vala"
			_tmp9_ = _tmp8_->results;
#line 221 "../src/baobab-chart.vala"
			g_signal_emit (self, baobab_chart_signals[BAOBAB_CHART_ITEM_ACTIVATED_SIGNAL], 0, _tmp9_);
#line 3047 "baobab-chart.c"
		}
	}
}

static void
__baobab_chart___lambda15__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                      gint n_press,
                                                      gdouble x,
                                                      gdouble y,
                                                      gpointer self)
{
#line 216 "../src/baobab-chart.vala"
	_baobab_chart___lambda15_ ((BaobabChart*) self, n_press, x, y);
#line 3061 "baobab-chart.c"
}

static void
_baobab_chart___lambda16_ (BaobabChart* self,
                           gint _,
                           gdouble x,
                           gdouble y)
{
#line 230 "../src/baobab-chart.vala"
	baobab_chart_show_popover_at (self, (gint) x, (gint) y);
#line 3072 "baobab-chart.c"
}

static void
__baobab_chart___lambda16__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                      gint n_press,
                                                      gdouble x,
                                                      gdouble y,
                                                      gpointer self)
{
#line 229 "../src/baobab-chart.vala"
	_baobab_chart___lambda16_ ((BaobabChart*) self, n_press, x, y);
#line 3084 "baobab-chart.c"
}

static void
_baobab_chart___lambda17_ (BaobabChart* self,
                           gint _,
                           gdouble x,
                           gdouble y)
{
#line 237 "../src/baobab-chart.vala"
	baobab_chart_move_up_root (self);
#line 3095 "baobab-chart.c"
}

static void
__baobab_chart___lambda17__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                      gint n_press,
                                                      gdouble x,
                                                      gdouble y,
                                                      gpointer self)
{
#line 236 "../src/baobab-chart.vala"
	_baobab_chart___lambda17_ ((BaobabChart*) self, n_press, x, y);
#line 3107 "baobab-chart.c"
}

static void
_baobab_chart_draw_func_gtk_drawing_area_draw_func (GtkDrawingArea* drawing_area,
                                                    cairo_t* cr,
                                                    gint width,
                                                    gint height,
                                                    gpointer self)
{
#line 254 "../src/baobab-chart.vala"
	baobab_chart_draw_func ((BaobabChart*) self, drawing_area, cr, width, height);
#line 3119 "baobab-chart.c"
}

static GObject *
baobab_chart_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BaobabChart * self;
	GtkEventControllerScroll* _tmp0_;
	GtkEventControllerScroll* _tmp1_;
	GtkEventControllerScroll* _tmp2_;
	GtkEventController* _tmp3_;
	GtkEventControllerMotion* _tmp4_;
	GtkEventControllerMotion* _tmp5_;
	GtkEventControllerMotion* _tmp6_;
	GtkEventControllerMotion* _tmp7_;
	GtkEventController* _tmp8_;
	GtkGestureClick* _tmp9_;
	GtkGestureClick* _tmp10_;
	GtkGestureClick* _tmp11_;
	GtkGestureClick* _tmp12_;
	GtkEventController* _tmp13_;
	GtkGestureClick* _tmp14_;
	GtkGestureClick* _tmp15_;
	GtkGestureClick* _tmp16_;
	GtkGestureClick* _tmp17_;
	GtkEventController* _tmp18_;
	GtkGestureClick* _tmp19_;
	GtkGestureClick* _tmp20_;
	GtkGestureClick* _tmp21_;
	GtkGestureClick* _tmp22_;
	GtkEventController* _tmp23_;
	GSimpleActionGroup* _tmp24_;
	GSimpleActionGroup* _tmp25_;
	GSimpleActionGroup* _tmp26_;
#line 204 "../src/baobab-chart.vala"
	parent_class = G_OBJECT_CLASS (baobab_chart_parent_class);
#line 204 "../src/baobab-chart.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 204 "../src/baobab-chart.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BAOBAB_TYPE_CHART, BaobabChart);
#line 205 "../src/baobab-chart.vala"
	_tmp0_ = (GtkEventControllerScroll*) gtk_event_controller_scroll_new (GTK_EVENT_CONTROLLER_SCROLL_BOTH_AXES);
#line 205 "../src/baobab-chart.vala"
	_g_object_unref0 (self->priv->scroll_controller);
#line 205 "../src/baobab-chart.vala"
	self->priv->scroll_controller = _tmp0_;
#line 206 "../src/baobab-chart.vala"
	_tmp1_ = self->priv->scroll_controller;
#line 206 "../src/baobab-chart.vala"
	g_signal_connect_object (_tmp1_, "scroll", (GCallback) _baobab_chart_scroll_cb_gtk_event_controller_scroll_scroll, self, 0);
#line 207 "../src/baobab-chart.vala"
	_tmp2_ = self->priv->scroll_controller;
#line 207 "../src/baobab-chart.vala"
	_tmp3_ = _g_object_ref0 ((GtkEventController*) _tmp2_);
#line 207 "../src/baobab-chart.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp3_);
#line 209 "../src/baobab-chart.vala"
	_tmp4_ = (GtkEventControllerMotion*) gtk_event_controller_motion_new ();
#line 209 "../src/baobab-chart.vala"
	_g_object_unref0 (self->priv->motion_controller);
#line 209 "../src/baobab-chart.vala"
	self->priv->motion_controller = _tmp4_;
#line 210 "../src/baobab-chart.vala"
	_tmp5_ = self->priv->motion_controller;
#line 210 "../src/baobab-chart.vala"
	g_signal_connect_object (_tmp5_, "motion", (GCallback) _baobab_chart_motion_cb_gtk_event_controller_motion_motion, self, 0);
#line 211 "../src/baobab-chart.vala"
	_tmp6_ = self->priv->motion_controller;
#line 211 "../src/baobab-chart.vala"
	g_signal_connect_object (_tmp6_, "enter", (GCallback) _baobab_chart_enter_cb_gtk_event_controller_motion_enter, self, 0);
#line 212 "../src/baobab-chart.vala"
	_tmp7_ = self->priv->motion_controller;
#line 212 "../src/baobab-chart.vala"
	_tmp8_ = _g_object_ref0 ((GtkEventController*) _tmp7_);
#line 212 "../src/baobab-chart.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp8_);
#line 214 "../src/baobab-chart.vala"
	_tmp9_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 214 "../src/baobab-chart.vala"
	_g_object_unref0 (self->priv->primary_click_gesture);
#line 214 "../src/baobab-chart.vala"
	self->priv->primary_click_gesture = _tmp9_;
#line 215 "../src/baobab-chart.vala"
	_tmp10_ = self->priv->primary_click_gesture;
#line 215 "../src/baobab-chart.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp10_, (guint) GDK_BUTTON_PRIMARY);
#line 216 "../src/baobab-chart.vala"
	_tmp11_ = self->priv->primary_click_gesture;
#line 216 "../src/baobab-chart.vala"
	g_signal_connect_object (_tmp11_, "pressed", (GCallback) __baobab_chart___lambda15__gtk_gesture_click_pressed, self, 0);
#line 225 "../src/baobab-chart.vala"
	_tmp12_ = self->priv->primary_click_gesture;
#line 225 "../src/baobab-chart.vala"
	_tmp13_ = _g_object_ref0 ((GtkEventController*) _tmp12_);
#line 225 "../src/baobab-chart.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp13_);
#line 227 "../src/baobab-chart.vala"
	_tmp14_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 227 "../src/baobab-chart.vala"
	_g_object_unref0 (self->priv->secondary_click_gesture);
#line 227 "../src/baobab-chart.vala"
	self->priv->secondary_click_gesture = _tmp14_;
#line 228 "../src/baobab-chart.vala"
	_tmp15_ = self->priv->secondary_click_gesture;
#line 228 "../src/baobab-chart.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp15_, (guint) GDK_BUTTON_SECONDARY);
#line 229 "../src/baobab-chart.vala"
	_tmp16_ = self->priv->secondary_click_gesture;
#line 229 "../src/baobab-chart.vala"
	g_signal_connect_object (_tmp16_, "pressed", (GCallback) __baobab_chart___lambda16__gtk_gesture_click_pressed, self, 0);
#line 232 "../src/baobab-chart.vala"
	_tmp17_ = self->priv->secondary_click_gesture;
#line 232 "../src/baobab-chart.vala"
	_tmp18_ = _g_object_ref0 ((GtkEventController*) _tmp17_);
#line 232 "../src/baobab-chart.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp18_);
#line 234 "../src/baobab-chart.vala"
	_tmp19_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 234 "../src/baobab-chart.vala"
	_g_object_unref0 (self->priv->middle_click_gesture);
#line 234 "../src/baobab-chart.vala"
	self->priv->middle_click_gesture = _tmp19_;
#line 235 "../src/baobab-chart.vala"
	_tmp20_ = self->priv->middle_click_gesture;
#line 235 "../src/baobab-chart.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp20_, (guint) GDK_BUTTON_MIDDLE);
#line 236 "../src/baobab-chart.vala"
	_tmp21_ = self->priv->middle_click_gesture;
#line 236 "../src/baobab-chart.vala"
	g_signal_connect_object (_tmp21_, "pressed", (GCallback) __baobab_chart___lambda17__gtk_gesture_click_pressed, self, 0);
#line 239 "../src/baobab-chart.vala"
	_tmp22_ = self->priv->middle_click_gesture;
#line 239 "../src/baobab-chart.vala"
	_tmp23_ = _g_object_ref0 ((GtkEventController*) _tmp22_);
#line 239 "../src/baobab-chart.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp23_);
#line 241 "../src/baobab-chart.vala"
	_tmp24_ = g_simple_action_group_new ();
#line 241 "../src/baobab-chart.vala"
	_g_object_unref0 (self->priv->action_group);
#line 241 "../src/baobab-chart.vala"
	self->priv->action_group = _tmp24_;
#line 242 "../src/baobab-chart.vala"
	_tmp25_ = self->priv->action_group;
#line 242 "../src/baobab-chart.vala"
	g_action_map_add_action_entries ((GActionMap*) _tmp25_, BAOBAB_CHART_action_entries, (gint) G_N_ELEMENTS (BAOBAB_CHART_action_entries), self);
#line 243 "../src/baobab-chart.vala"
	_tmp26_ = self->priv->action_group;
#line 243 "../src/baobab-chart.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, "chart", (GActionGroup*) _tmp26_);
#line 245 "../src/baobab-chart.vala"
	baobab_chart_build_context_menu (self);
#line 247 "../src/baobab-chart.vala"
	gdk_rgba_parse (&self->priv->chart_colors[0], "#e01b24");
#line 248 "../src/baobab-chart.vala"
	gdk_rgba_parse (&self->priv->chart_colors[1], "#ff7800");
#line 249 "../src/baobab-chart.vala"
	gdk_rgba_parse (&self->priv->chart_colors[2], "#f6d32d");
#line 250 "../src/baobab-chart.vala"
	gdk_rgba_parse (&self->priv->chart_colors[3], "#33d17a");
#line 251 "../src/baobab-chart.vala"
	gdk_rgba_parse (&self->priv->chart_colors[4], "#3584e4");
#line 252 "../src/baobab-chart.vala"
	gdk_rgba_parse (&self->priv->chart_colors[5], "#9141ac");
#line 254 "../src/baobab-chart.vala"
	gtk_drawing_area_set_draw_func ((GtkDrawingArea*) self, _baobab_chart_draw_func_gtk_drawing_area_draw_func, g_object_ref (self), g_object_unref);
#line 204 "../src/baobab-chart.vala"
	return obj;
#line 3291 "baobab-chart.c"
}

static void
baobab_chart_class_init (BaobabChartClass * klass,
                         gpointer klass_data)
{
#line 49 "../src/baobab-chart.vala"
	baobab_chart_parent_class = g_type_class_peek_parent (klass);
#line 49 "../src/baobab-chart.vala"
	g_type_class_adjust_private_offset (klass, &BaobabChart_private_offset);
#line 49 "../src/baobab-chart.vala"
	((BaobabChartClass *) klass)->post_draw = (void (*) (BaobabChart*, cairo_t*)) baobab_chart_real_post_draw;
#line 49 "../src/baobab-chart.vala"
	((BaobabChartClass *) klass)->draw_item = (void (*) (BaobabChart*, cairo_t*, BaobabChartItem*, gboolean)) baobab_chart_real_draw_item;
#line 49 "../src/baobab-chart.vala"
	((BaobabChartClass *) klass)->calculate_item_geometry = (void (*) (BaobabChart*, BaobabChartItem*)) baobab_chart_real_calculate_item_geometry;
#line 49 "../src/baobab-chart.vala"
	((BaobabChartClass *) klass)->is_point_over_item = (gboolean (*) (BaobabChart*, BaobabChartItem*, gdouble, gdouble)) baobab_chart_real_is_point_over_item;
#line 49 "../src/baobab-chart.vala"
	((BaobabChartClass *) klass)->get_item_rectangle = (void (*) (BaobabChart*, BaobabChartItem*)) baobab_chart_real_get_item_rectangle;
#line 49 "../src/baobab-chart.vala"
	((BaobabChartClass *) klass)->can_zoom_in = (gboolean (*) (BaobabChart*)) baobab_chart_real_can_zoom_in;
#line 49 "../src/baobab-chart.vala"
	((BaobabChartClass *) klass)->can_zoom_out = (gboolean (*) (BaobabChart*)) baobab_chart_real_can_zoom_out;
#line 49 "../src/baobab-chart.vala"
	((BaobabChartClass *) klass)->create_new_chartitem = (BaobabChartItem* (*) (BaobabChart*)) baobab_chart_real_create_new_chartitem;
#line 49 "../src/baobab-chart.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, gint, gint, gint)) baobab_chart_real_size_allocate;
#line 49 "../src/baobab-chart.vala"
	((GtkWidgetClass *) klass)->query_tooltip = (gboolean (*) (GtkWidget*, gint, gint, gboolean, GtkTooltip*)) baobab_chart_real_query_tooltip;
#line 49 "../src/baobab-chart.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_baobab_chart_get_property;
#line 49 "../src/baobab-chart.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_baobab_chart_set_property;
#line 49 "../src/baobab-chart.vala"
	G_OBJECT_CLASS (klass)->constructor = baobab_chart_constructor;
#line 49 "../src/baobab-chart.vala"
	G_OBJECT_CLASS (klass)->finalize = baobab_chart_finalize;
#line 49 "../src/baobab-chart.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_CHART_LOCATION_PROPERTY, baobab_chart_properties[BAOBAB_CHART_LOCATION_PROPERTY] = baobab_param_spec_location ("location", "location", "location", BAOBAB_TYPE_LOCATION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 49 "../src/baobab-chart.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_CHART_MAX_DEPTH_PROPERTY, baobab_chart_properties[BAOBAB_CHART_MAX_DEPTH_PROPERTY] = g_param_spec_uint ("max-depth", "max-depth", "max-depth", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 49 "../src/baobab-chart.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_CHART_MODEL_PROPERTY, baobab_chart_properties[BAOBAB_CHART_MODEL_PROPERTY] = g_param_spec_object ("model", "model", "model", gtk_tree_list_model_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 49 "../src/baobab-chart.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_CHART_TREE_ROOT_PROPERTY, baobab_chart_properties[BAOBAB_CHART_TREE_ROOT_PROPERTY] = g_param_spec_object ("tree-root", "tree-root", "tree-root", BAOBAB_SCANNER_TYPE_RESULTS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 49 "../src/baobab-chart.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_CHART_HIGHLIGHTED_ITEM_PROPERTY, baobab_chart_properties[BAOBAB_CHART_HIGHLIGHTED_ITEM_PROPERTY] = baobab_param_spec_chart_item ("highlighted-item", "highlighted-item", "highlighted-item", BAOBAB_TYPE_CHART_ITEM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 49 "../src/baobab-chart.vala"
	baobab_chart_signals[BAOBAB_CHART_ITEM_ACTIVATED_SIGNAL] = g_signal_new ("item-activated", BAOBAB_TYPE_CHART, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, BAOBAB_SCANNER_TYPE_RESULTS);
#line 3342 "baobab-chart.c"
}

static void
baobab_chart_instance_init (BaobabChart * self,
                            gpointer klass)
{
#line 49 "../src/baobab-chart.vala"
	self->priv = baobab_chart_get_instance_private (self);
#line 59 "../src/baobab-chart.vala"
	self->priv->context_menu = NULL;
#line 84 "../src/baobab-chart.vala"
	self->priv->max_depth_ = BAOBAB_CHART_MAX_DEPTH;
#line 155 "../src/baobab-chart.vala"
	self->priv->highlighted_item_ = NULL;
#line 3357 "baobab-chart.c"
}

static void
baobab_chart_finalize (GObject * obj)
{
	BaobabChart * self;
#line 49 "../src/baobab-chart.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BAOBAB_TYPE_CHART, BaobabChart);
#line 59 "../src/baobab-chart.vala"
	_g_object_unref0 (self->priv->context_menu);
#line 61 "../src/baobab-chart.vala"
	_g_object_unref0 (self->priv->scroll_controller);
#line 62 "../src/baobab-chart.vala"
	_g_object_unref0 (self->priv->motion_controller);
#line 63 "../src/baobab-chart.vala"
	_g_object_unref0 (self->priv->primary_click_gesture);
#line 64 "../src/baobab-chart.vala"
	_g_object_unref0 (self->priv->secondary_click_gesture);
#line 65 "../src/baobab-chart.vala"
	_g_object_unref0 (self->priv->middle_click_gesture);
#line 69 "../src/baobab-chart.vala"
	(self->priv->items == NULL) ? NULL : (self->priv->items = (_g_list_free__baobab_chart_item_unref0_ (self->priv->items), NULL));
#line 71 "../src/baobab-chart.vala"
	_baobab_location_unref0 (self->priv->location_);
#line 100 "../src/baobab-chart.vala"
	_g_object_unref0 (self->priv->model_);
#line 125 "../src/baobab-chart.vala"
	_g_object_unref0 (self->priv->root_);
#line 155 "../src/baobab-chart.vala"
	_baobab_chart_item_unref0 (self->priv->highlighted_item_);
#line 193 "../src/baobab-chart.vala"
	_g_object_unref0 (self->priv->action_group);
#line 49 "../src/baobab-chart.vala"
	G_OBJECT_CLASS (baobab_chart_parent_class)->finalize (obj);
#line 3392 "baobab-chart.c"
}

static GType
baobab_chart_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BaobabChartClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) baobab_chart_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BaobabChart), 0, (GInstanceInitFunc) baobab_chart_instance_init, NULL };
	GType baobab_chart_type_id;
	baobab_chart_type_id = g_type_register_static (gtk_drawing_area_get_type (), "BaobabChart", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	BaobabChart_private_offset = g_type_add_instance_private (baobab_chart_type_id, sizeof (BaobabChartPrivate));
	return baobab_chart_type_id;
}

GType
baobab_chart_get_type (void)
{
	static volatile gsize baobab_chart_type_id__once = 0;
	if (g_once_init_enter (&baobab_chart_type_id__once)) {
		GType baobab_chart_type_id;
		baobab_chart_type_id = baobab_chart_get_type_once ();
		g_once_init_leave (&baobab_chart_type_id__once, baobab_chart_type_id);
	}
	return baobab_chart_type_id__once;
}

static void
_vala_baobab_chart_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	BaobabChart * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BAOBAB_TYPE_CHART, BaobabChart);
#line 49 "../src/baobab-chart.vala"
	switch (property_id) {
#line 49 "../src/baobab-chart.vala"
		case BAOBAB_CHART_LOCATION_PROPERTY:
#line 49 "../src/baobab-chart.vala"
		baobab_value_set_location (value, baobab_chart_get_location (self));
#line 49 "../src/baobab-chart.vala"
		break;
#line 49 "../src/baobab-chart.vala"
		case BAOBAB_CHART_MAX_DEPTH_PROPERTY:
#line 49 "../src/baobab-chart.vala"
		g_value_set_uint (value, baobab_chart_get_max_depth (self));
#line 49 "../src/baobab-chart.vala"
		break;
#line 49 "../src/baobab-chart.vala"
		case BAOBAB_CHART_MODEL_PROPERTY:
#line 49 "../src/baobab-chart.vala"
		g_value_set_object (value, baobab_chart_get_model (self));
#line 49 "../src/baobab-chart.vala"
		break;
#line 49 "../src/baobab-chart.vala"
		case BAOBAB_CHART_TREE_ROOT_PROPERTY:
#line 49 "../src/baobab-chart.vala"
		g_value_take_object (value, baobab_chart_get_tree_root (self));
#line 49 "../src/baobab-chart.vala"
		break;
#line 49 "../src/baobab-chart.vala"
		case BAOBAB_CHART_HIGHLIGHTED_ITEM_PROPERTY:
#line 49 "../src/baobab-chart.vala"
		baobab_value_set_chart_item (value, baobab_chart_get_highlighted_item (self));
#line 49 "../src/baobab-chart.vala"
		break;
#line 3457 "baobab-chart.c"
		default:
#line 49 "../src/baobab-chart.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 49 "../src/baobab-chart.vala"
		break;
#line 3463 "baobab-chart.c"
	}
}

static void
_vala_baobab_chart_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	BaobabChart * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BAOBAB_TYPE_CHART, BaobabChart);
#line 49 "../src/baobab-chart.vala"
	switch (property_id) {
#line 49 "../src/baobab-chart.vala"
		case BAOBAB_CHART_LOCATION_PROPERTY:
#line 49 "../src/baobab-chart.vala"
		baobab_chart_set_location (self, baobab_value_get_location (value));
#line 49 "../src/baobab-chart.vala"
		break;
#line 49 "../src/baobab-chart.vala"
		case BAOBAB_CHART_MAX_DEPTH_PROPERTY:
#line 49 "../src/baobab-chart.vala"
		baobab_chart_set_max_depth (self, g_value_get_uint (value));
#line 49 "../src/baobab-chart.vala"
		break;
#line 49 "../src/baobab-chart.vala"
		case BAOBAB_CHART_MODEL_PROPERTY:
#line 49 "../src/baobab-chart.vala"
		baobab_chart_set_model (self, g_value_get_object (value));
#line 49 "../src/baobab-chart.vala"
		break;
#line 49 "../src/baobab-chart.vala"
		case BAOBAB_CHART_TREE_ROOT_PROPERTY:
#line 49 "../src/baobab-chart.vala"
		baobab_chart_set_tree_root (self, g_value_get_object (value));
#line 49 "../src/baobab-chart.vala"
		break;
#line 49 "../src/baobab-chart.vala"
		case BAOBAB_CHART_HIGHLIGHTED_ITEM_PROPERTY:
#line 49 "../src/baobab-chart.vala"
		baobab_chart_set_highlighted_item (self, baobab_value_get_chart_item (value));
#line 49 "../src/baobab-chart.vala"
		break;
#line 3507 "baobab-chart.c"
		default:
#line 49 "../src/baobab-chart.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 49 "../src/baobab-chart.vala"
		break;
#line 3513 "baobab-chart.c"
	}
}

