/* baobab-window.c generated by valac 0.56.18, the Vala compiler
 * generated from baobab-window.vala, do not modify */

/* -*- tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/* Baobab - disk usage analyzer
 *
 * Copyright (C) 2012  Ryan Lortie <desrt@desrt.ca>
 * Copyright (C) 2012  Paolo Borelli <pborelli@gnome.org>
 * Copyright (C) 2012  Stefano Facchini <stefano.facchini@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#include "baobab.h"
#include <gtk/gtk.h>
#include <adwaita.h>
#include <glib.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include "config.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	BAOBAB_WINDOW_0_PROPERTY,
	BAOBAB_WINDOW_NUM_PROPERTIES
};
static GParamSpec* baobab_window_properties[BAOBAB_WINDOW_NUM_PROPERTIES];
#define _baobab_location_unref0(var) ((var == NULL) ? NULL : (var = (baobab_location_unref (var), NULL)))
typedef struct _Block6Data Block6Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _Block7Data Block7Data;
typedef struct _Block8Data Block8Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block9Data Block9Data;

struct _BaobabWindowPrivate {
	GtkEventControllerFocus* focus_controller;
	GtkDropTarget* drop_target;
	BaobabPathbar* pathbar;
	AdwNavigationView* nav_view;
	GtkWidget* home_page;
	GtkWidget* result_page;
	AdwToastOverlay* toast_overlay;
	AdwBanner* banner;
	BaobabLocationList* location_list;
	BaobabFolderDisplay* folder_display;
	GtkColumnView* columnview;
	GtkSingleSelection* columnview_selection;
	GtkSortListModel* columnview_sort_model;
	GtkPopoverMenu* treeview_popover_menu;
	AdwViewStack* chart_stack;
	GtkStack* spinner_stack;
	AdwViewSwitcher* chart_stack_switcher;
	BaobabChart* rings_chart;
	BaobabChart* treemap_chart;
	AdwSpinner* spinner;
	BaobabLocation* active_location;
	gboolean is_busy;
	gulong scan_completed_handler;
	guint scanning_progress_id;
};

struct _Block6Data {
	int _ref_count_;
	BaobabWindow* self;
	GSettings* ui_settings;
};

struct _Block7Data {
	int _ref_count_;
	BaobabWindow* self;
	GtkFileChooserNative* file_chooser;
};

struct _Block8Data {
	int _ref_count_;
	BaobabWindow* self;
	BaobabLocation* location;
};

struct _Block9Data {
	int _ref_count_;
	BaobabWindow* self;
	BaobabLocation* location;
};

static gint BaobabWindow_private_offset;
static gpointer baobab_window_parent_class = NULL;
static GdkCursor* baobab_window_busy_cursor;
static GdkCursor* baobab_window_busy_cursor = NULL;

static void baobab_window_on_show_primary_menu_activate (BaobabWindow* self,
                                                  GSimpleAction* action);
static void _baobab_window_on_show_primary_menu_activate_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                    GVariant* parameter,
                                                                                    gpointer self);
static void baobab_window_on_scan_folder_activate (BaobabWindow* self);
static void _baobab_window_on_scan_folder_activate_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self);
static void baobab_window_on_reload_activate (BaobabWindow* self);
static void _baobab_window_on_reload_activate_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self);
static void baobab_window_on_clear_recent (BaobabWindow* self);
static void _baobab_window_on_clear_recent_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self);
static void baobab_window_on_show_preferences (BaobabWindow* self);
static void _baobab_window_on_show_preferences_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self);
static void baobab_window_on_help_activate (BaobabWindow* self);
static void _baobab_window_on_help_activate_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self);
static void baobab_window_on_about_activate (BaobabWindow* self);
static void _baobab_window_on_about_activate_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self);
static void baobab_window_on_show_treeview_popover (BaobabWindow* self);
static void _baobab_window_on_show_treeview_popover_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self);
static void baobab_window_on_treeview_expand_row (BaobabWindow* self);
static void _baobab_window_on_treeview_expand_row_gsimple_action_activate_callback (GSimpleAction* action,
                                                                             GVariant* parameter,
                                                                             gpointer self);
static void baobab_window_on_treeview_collapse_row (BaobabWindow* self);
static void _baobab_window_on_treeview_collapse_row_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self);
static void baobab_window_go_up_treeview (BaobabWindow* self);
static void _baobab_window_go_up_treeview_gsimple_action_activate_callback (GSimpleAction* action,
                                                                     GVariant* parameter,
                                                                     gpointer self);
static void baobab_window_on_treeview_open_folder (BaobabWindow* self);
static void _baobab_window_on_treeview_open_folder_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self);
static void baobab_window_on_treeview_copy (BaobabWindow* self);
static void _baobab_window_on_treeview_copy_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self);
static void baobab_window_on_treeview_trash (BaobabWindow* self);
static void _baobab_window_on_treeview_trash_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void baobab_window_location_activated (BaobabWindow* self,
                                       BaobabLocation* location);
static void _baobab_window_location_activated_baobab_location_list_location_activated (BaobabLocationList* _sender,
                                                                                BaobabLocation* location,
                                                                                gpointer self);
static void baobab_window_hide_columnview_header (BaobabWindow* self);
static void __lambda25_ (BaobabWindow* self);
static void ___lambda25__gtk_widget_destroy (GtkWidget* _sender,
                                      gpointer self);
static void baobab_window_on_chart_item_activated (BaobabWindow* self,
                                            BaobabChart* chart,
                                            BaobabScannerResults* item);
static void _baobab_window_on_chart_item_activated_baobab_chart_item_activated (BaobabChart* _sender,
                                                                         BaobabScannerResults* item,
                                                                         gpointer self);
static void baobab_window_on_pathbar_item_activated (BaobabWindow* self,
                                              BaobabPathbar* pathbar,
                                              BaobabScannerResults* path);
static void _baobab_window_on_pathbar_item_activated_baobab_pathbar_item_activated (BaobabPathbar* _sender,
                                                                             BaobabScannerResults* path,
                                                                             gpointer self);
static void baobab_window_on_folder_display_activated (BaobabWindow* self);
static void _baobab_window_on_folder_display_activated_baobab_folder_display_activated (BaobabFolderDisplay* _sender,
                                                                                 gpointer self);
static gboolean baobab_window_on_drop (BaobabWindow* self,
                                GtkDropTarget* target,
                                GValue* value,
                                gdouble x,
                                gdouble y);
static gboolean _baobab_window_on_drop_gtk_drop_target_drop (GtkDropTarget* _sender,
                                                      GValue* value,
                                                      gdouble x,
                                                      gdouble y,
                                                      gpointer self);
static gboolean baobab_window_on_drop_target_accept (BaobabWindow* self,
                                              GtkDropTarget* target,
                                              GdkDrop* drop);
static gboolean _baobab_window_on_drop_target_accept_gtk_drop_target_accept (GtkDropTarget* _sender,
                                                                      GdkDrop* drop,
                                                                      gpointer self);
static gboolean __lambda26_ (Block6Data* _data6_);
static gboolean ___lambda26__gtk_window_close_request (GtkWindow* _sender,
                                                gpointer self);
static void baobab_window_set_ui_state (BaobabWindow* self,
                                 GtkWidget* child,
                                 gboolean busy);
static void __lambda27_ (BaobabWindow* self);
static void ___lambda27__gtk_event_controller_focus_enter (GtkEventControllerFocus* _sender,
                                                    gpointer self);
static void baobab_window_results_hidden (BaobabWindow* self);
static void baobab_window_cancel_scan (BaobabWindow* self);
static void _baobab_window_results_hidden_adw_navigation_page_hidden (AdwNavigationPage* _sender,
                                                               gpointer self);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void __lambda18_ (Block7Data* _data7_,
                  gint response);
static void ___lambda18__gtk_native_dialog_response (GtkNativeDialog* _sender,
                                              gint response_id,
                                              gpointer self);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void baobab_window_set_busy (BaobabWindow* self,
                             gboolean busy);
static void __lambda24_ (Block8Data* _data8_,
                  GObject* location_,
                  GAsyncResult* res);
static void baobab_window_scan_location (BaobabWindow* self,
                                  BaobabLocation* location,
                                  gboolean force);
static void baobab_window_toast (BaobabWindow* self,
                          const gchar* title);
static void ___lambda24__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static gchar** _vala_array_dup2 (gchar** self,
                          gssize length);
static void baobab_window_reroot_treeview (BaobabWindow* self,
                                    BaobabScannerResults* path,
                                    gboolean select_first);
static gboolean baobab_window_show_treeview_popover (BaobabWindow* self,
                                              GtkPopoverMenu* popover,
                                              gint x,
                                              gint y);
static gboolean baobab_window_columnview_selection_find (BaobabWindow* self,
                                                  GObject* item,
                                                  gboolean passthrough,
                                                  guint* position);
static BaobabScannerResults* baobab_window_get_selected_item (BaobabWindow* self);
static void baobab_window_treeview_right_click_gesture_pressed (BaobabWindow* self,
                                                         gint n_press,
                                                         gdouble x,
                                                         gdouble y);
static void _baobab_window_treeview_right_click_gesture_pressed_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                                    gint n_press,
                                                                                    gdouble x,
                                                                                    gdouble y,
                                                                                    gpointer self);
static void baobab_window_columnview_activate (BaobabWindow* self,
                                        guint position);
static void _baobab_window_columnview_activate_gtk_column_view_activate (GtkColumnView* _sender,
                                                                  guint position,
                                                                  gpointer self);
static void baobab_window_set_chart_location (BaobabWindow* self,
                                       BaobabLocation* location);
static void baobab_window_scanner_completed (BaobabWindow* self);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void _baobab_window_scanner_completed_baobab_scanner_completed (BaobabScanner* _sender,
                                                                gpointer self);
static gboolean __lambda19_ (Block9Data* _data9_);
static gboolean ___lambda19__gsource_func (gpointer self);
static void baobab_window_folder_cell_setup (BaobabWindow* self,
                                      GObject* object);
static void _baobab_window_folder_cell_setup_gtk_signal_list_item_factory_setup (GtkSignalListItemFactory* _sender,
                                                                          GObject* object,
                                                                          gpointer self);
static void baobab_window_folder_cell_bind (BaobabWindow* self,
                                     GObject* object);
static void _baobab_window_folder_cell_bind_gtk_signal_list_item_factory_bind (GtkSignalListItemFactory* _sender,
                                                                        GObject* object,
                                                                        gpointer self);
static void baobab_window_folder_cell_unbind (BaobabWindow* self,
                                       GObject* object);
static void _baobab_window_folder_cell_unbind_gtk_signal_list_item_factory_unbind (GtkSignalListItemFactory* _sender,
                                                                            GObject* object,
                                                                            gpointer self);
static void baobab_window_folder_cell_teardown (BaobabWindow* self,
                                         GObject* object);
static void _baobab_window_folder_cell_teardown_gtk_signal_list_item_factory_teardown (GtkSignalListItemFactory* _sender,
                                                                                GObject* object,
                                                                                gpointer self);
static void baobab_window_size_cell_setup (BaobabWindow* self,
                                    GObject* object);
static void _baobab_window_size_cell_setup_gtk_signal_list_item_factory_setup (GtkSignalListItemFactory* _sender,
                                                                        GObject* object,
                                                                        gpointer self);
static void baobab_window_size_cell_bind (BaobabWindow* self,
                                   GObject* object);
static void _baobab_window_size_cell_bind_gtk_signal_list_item_factory_bind (GtkSignalListItemFactory* _sender,
                                                                      GObject* object,
                                                                      gpointer self);
static void baobab_window_size_cell_unbind (BaobabWindow* self,
                                     GObject* object);
static void _baobab_window_size_cell_unbind_gtk_signal_list_item_factory_unbind (GtkSignalListItemFactory* _sender,
                                                                          GObject* object,
                                                                          gpointer self);
static void baobab_window_size_cell_teardown (BaobabWindow* self,
                                       GObject* object);
static void _baobab_window_size_cell_teardown_gtk_signal_list_item_factory_teardown (GtkSignalListItemFactory* _sender,
                                                                              GObject* object,
                                                                              gpointer self);
static void baobab_window_contents_cell_setup (BaobabWindow* self,
                                        GObject* object);
static void _baobab_window_contents_cell_setup_gtk_signal_list_item_factory_setup (GtkSignalListItemFactory* _sender,
                                                                            GObject* object,
                                                                            gpointer self);
static void baobab_window_contents_cell_bind (BaobabWindow* self,
                                       GObject* object);
static void _baobab_window_contents_cell_bind_gtk_signal_list_item_factory_bind (GtkSignalListItemFactory* _sender,
                                                                          GObject* object,
                                                                          gpointer self);
static void baobab_window_contents_cell_unbind (BaobabWindow* self,
                                         GObject* object);
static void _baobab_window_contents_cell_unbind_gtk_signal_list_item_factory_unbind (GtkSignalListItemFactory* _sender,
                                                                              GObject* object,
                                                                              gpointer self);
static void baobab_window_contents_cell_teardown (BaobabWindow* self,
                                           GObject* object);
static void _baobab_window_contents_cell_teardown_gtk_signal_list_item_factory_teardown (GtkSignalListItemFactory* _sender,
                                                                                  GObject* object,
                                                                                  gpointer self);
static void baobab_window_time_modified_cell_setup (BaobabWindow* self,
                                             GObject* object);
static void _baobab_window_time_modified_cell_setup_gtk_signal_list_item_factory_setup (GtkSignalListItemFactory* _sender,
                                                                                 GObject* object,
                                                                                 gpointer self);
static void baobab_window_time_modified_cell_bind (BaobabWindow* self,
                                            GObject* object);
static void _baobab_window_time_modified_cell_bind_gtk_signal_list_item_factory_bind (GtkSignalListItemFactory* _sender,
                                                                               GObject* object,
                                                                               gpointer self);
static void baobab_window_time_modified_cell_unbind (BaobabWindow* self,
                                              GObject* object);
static void _baobab_window_time_modified_cell_unbind_gtk_signal_list_item_factory_unbind (GtkSignalListItemFactory* _sender,
                                                                                   GObject* object,
                                                                                   gpointer self);
static void baobab_window_time_modified_cell_teardown (BaobabWindow* self,
                                                GObject* object);
static void _baobab_window_time_modified_cell_teardown_gtk_signal_list_item_factory_teardown (GtkSignalListItemFactory* _sender,
                                                                                       GObject* object,
                                                                                       gpointer self);
static void baobab_window_finalize (GObject * obj);
static GType baobab_window_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const GActionEntry BAOBAB_WINDOW_action_entries[14] = {{"show-primary-menu", _baobab_window_on_show_primary_menu_activate_gsimple_action_activate_callback, NULL, "false", NULL}, {"scan-folder", _baobab_window_on_scan_folder_activate_gsimple_action_activate_callback}, {"reload", _baobab_window_on_reload_activate_gsimple_action_activate_callback}, {"clear-recent", _baobab_window_on_clear_recent_gsimple_action_activate_callback}, {"show-preferences", _baobab_window_on_show_preferences_gsimple_action_activate_callback}, {"help", _baobab_window_on_help_activate_gsimple_action_activate_callback}, {"about", _baobab_window_on_about_activate_gsimple_action_activate_callback}, {"show-treeview-popover", _baobab_window_on_show_treeview_popover_gsimple_action_activate_callback}, {"treeview-expand-row", _baobab_window_on_treeview_expand_row_gsimple_action_activate_callback}, {"treeview-collapse-row", _baobab_window_on_treeview_collapse_row_gsimple_action_activate_callback}, {"treeview-go-up", _baobab_window_go_up_treeview_gsimple_action_activate_callback}, {"treeview-open-folder", _baobab_window_on_treeview_open_folder_gsimple_action_activate_callback}, {"treeview-copy", _baobab_window_on_treeview_copy_gsimple_action_activate_callback}, {"treeview-trash", _baobab_window_on_treeview_trash_gsimple_action_activate_callback}};
static const BaobabWindowActionState BAOBAB_WINDOW_actions_while_scanning[1] = {{"scan-folder", FALSE}};

static inline gpointer
baobab_window_get_instance_private (BaobabWindow* self)
{
	return G_STRUCT_MEMBER_P (self, BaobabWindow_private_offset);
}

static void
_baobab_window_on_show_primary_menu_activate_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self)
{
#line 75 "../src/baobab-window.vala"
	baobab_window_on_show_primary_menu_activate ((BaobabWindow*) self, action);
#line 397 "baobab-window.c"
}

static void
_baobab_window_on_scan_folder_activate_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self)
{
#line 75 "../src/baobab-window.vala"
	baobab_window_on_scan_folder_activate ((BaobabWindow*) self);
#line 407 "baobab-window.c"
}

static void
_baobab_window_on_reload_activate_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self)
{
#line 75 "../src/baobab-window.vala"
	baobab_window_on_reload_activate ((BaobabWindow*) self);
#line 417 "baobab-window.c"
}

static void
_baobab_window_on_clear_recent_gsimple_action_activate_callback (GSimpleAction* action,
                                                                 GVariant* parameter,
                                                                 gpointer self)
{
#line 75 "../src/baobab-window.vala"
	baobab_window_on_clear_recent ((BaobabWindow*) self);
#line 427 "baobab-window.c"
}

static void
_baobab_window_on_show_preferences_gsimple_action_activate_callback (GSimpleAction* action,
                                                                     GVariant* parameter,
                                                                     gpointer self)
{
#line 75 "../src/baobab-window.vala"
	baobab_window_on_show_preferences ((BaobabWindow*) self);
#line 437 "baobab-window.c"
}

static void
_baobab_window_on_help_activate_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self)
{
#line 75 "../src/baobab-window.vala"
	baobab_window_on_help_activate ((BaobabWindow*) self);
#line 447 "baobab-window.c"
}

static void
_baobab_window_on_about_activate_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self)
{
#line 75 "../src/baobab-window.vala"
	baobab_window_on_about_activate ((BaobabWindow*) self);
#line 457 "baobab-window.c"
}

static void
_baobab_window_on_show_treeview_popover_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self)
{
#line 75 "../src/baobab-window.vala"
	baobab_window_on_show_treeview_popover ((BaobabWindow*) self);
#line 467 "baobab-window.c"
}

static void
_baobab_window_on_treeview_expand_row_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self)
{
#line 75 "../src/baobab-window.vala"
	baobab_window_on_treeview_expand_row ((BaobabWindow*) self);
#line 477 "baobab-window.c"
}

static void
_baobab_window_on_treeview_collapse_row_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self)
{
#line 75 "../src/baobab-window.vala"
	baobab_window_on_treeview_collapse_row ((BaobabWindow*) self);
#line 487 "baobab-window.c"
}

static void
_baobab_window_go_up_treeview_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self)
{
#line 75 "../src/baobab-window.vala"
	baobab_window_go_up_treeview ((BaobabWindow*) self);
#line 497 "baobab-window.c"
}

static void
_baobab_window_on_treeview_open_folder_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self)
{
#line 75 "../src/baobab-window.vala"
	baobab_window_on_treeview_open_folder ((BaobabWindow*) self);
#line 507 "baobab-window.c"
}

static void
_baobab_window_on_treeview_copy_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self)
{
#line 75 "../src/baobab-window.vala"
	baobab_window_on_treeview_copy ((BaobabWindow*) self);
#line 517 "baobab-window.c"
}

static void
_baobab_window_on_treeview_trash_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self)
{
#line 75 "../src/baobab-window.vala"
	baobab_window_on_treeview_trash ((BaobabWindow*) self);
#line 527 "baobab-window.c"
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 101 "../src/baobab-window.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 101 "../src/baobab-window.vala"
	return _data6_;
#line 537 "baobab-window.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 101 "../src/baobab-window.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 547 "baobab-window.c"
		BaobabWindow* self;
#line 101 "../src/baobab-window.vala"
		self = _data6_->self;
#line 101 "../src/baobab-window.vala"
		_g_object_unref0 (_data6_->ui_settings);
#line 101 "../src/baobab-window.vala"
		_g_object_unref0 (self);
#line 101 "../src/baobab-window.vala"
		g_slice_free (Block6Data, _data6_);
#line 557 "baobab-window.c"
	}
}

static void
_baobab_window_location_activated_baobab_location_list_location_activated (BaobabLocationList* _sender,
                                                                           BaobabLocation* location,
                                                                           gpointer self)
{
#line 115 "../src/baobab-window.vala"
	baobab_window_location_activated ((BaobabWindow*) self, location);
#line 568 "baobab-window.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 118 "../src/baobab-window.vala"
	return self ? g_object_ref (self) : NULL;
#line 576 "baobab-window.c"
}

static void
__lambda25_ (BaobabWindow* self)
{
	AdwViewStack* _tmp0_;
#line 124 "../src/baobab-window.vala"
	_tmp0_ = self->priv->chart_stack;
#line 124 "../src/baobab-window.vala"
	g_settings_unbind ((GObject*) _tmp0_, "visible-child-name");
#line 587 "baobab-window.c"
}

static void
___lambda25__gtk_widget_destroy (GtkWidget* _sender,
                                 gpointer self)
{
#line 124 "../src/baobab-window.vala"
	__lambda25_ ((BaobabWindow*) self);
#line 596 "baobab-window.c"
}

static void
_baobab_window_on_chart_item_activated_baobab_chart_item_activated (BaobabChart* _sender,
                                                                    BaobabScannerResults* item,
                                                                    gpointer self)
{
#line 126 "../src/baobab-window.vala"
	baobab_window_on_chart_item_activated ((BaobabWindow*) self, _sender, item);
#line 606 "baobab-window.c"
}

static void
_baobab_window_on_pathbar_item_activated_baobab_pathbar_item_activated (BaobabPathbar* _sender,
                                                                        BaobabScannerResults* path,
                                                                        gpointer self)
{
#line 128 "../src/baobab-window.vala"
	baobab_window_on_pathbar_item_activated ((BaobabWindow*) self, _sender, path);
#line 616 "baobab-window.c"
}

static void
_baobab_window_on_folder_display_activated_baobab_folder_display_activated (BaobabFolderDisplay* _sender,
                                                                            gpointer self)
{
#line 129 "../src/baobab-window.vala"
	baobab_window_on_folder_display_activated ((BaobabWindow*) self);
#line 625 "baobab-window.c"
}

static gboolean
_baobab_window_on_drop_gtk_drop_target_drop (GtkDropTarget* _sender,
                                             GValue* value,
                                             gdouble x,
                                             gdouble y,
                                             gpointer self)
{
	gboolean result;
	result = baobab_window_on_drop ((BaobabWindow*) self, _sender, value, x, y);
#line 133 "../src/baobab-window.vala"
	return result;
#line 639 "baobab-window.c"
}

static gboolean
_baobab_window_on_drop_target_accept_gtk_drop_target_accept (GtkDropTarget* _sender,
                                                             GdkDrop* drop,
                                                             gpointer self)
{
	gboolean result;
	result = baobab_window_on_drop_target_accept ((BaobabWindow*) self, _sender, drop);
#line 134 "../src/baobab-window.vala"
	return result;
#line 651 "baobab-window.c"
}

static gboolean
__lambda26_ (Block6Data* _data6_)
{
	BaobabWindow* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GSettings* _tmp5_;
	gboolean result;
#line 147 "../src/baobab-window.vala"
	self = _data6_->self;
#line 148 "../src/baobab-window.vala"
	g_object_get ((GtkWindow*) self, "maximized", &_tmp0_, NULL);
#line 148 "../src/baobab-window.vala"
	_tmp1_ = _tmp0_;
#line 148 "../src/baobab-window.vala"
	if (!_tmp1_) {
#line 670 "baobab-window.c"
		gint win_width = 0;
		gint win_height = 0;
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
		GSettings* _tmp4_;
#line 150 "../src/baobab-window.vala"
		gtk_window_get_default_size ((GtkWindow*) self, &_tmp2_, &_tmp3_);
#line 150 "../src/baobab-window.vala"
		win_width = _tmp2_;
#line 150 "../src/baobab-window.vala"
		win_height = _tmp3_;
#line 151 "../src/baobab-window.vala"
		_tmp4_ = _data6_->ui_settings;
#line 151 "../src/baobab-window.vala"
		g_settings_set (_tmp4_, "window-size", "(ii)", win_width, win_height);
#line 686 "baobab-window.c"
	}
#line 153 "../src/baobab-window.vala"
	_tmp5_ = _data6_->ui_settings;
#line 153 "../src/baobab-window.vala"
	g_settings_apply (_tmp5_);
#line 154 "../src/baobab-window.vala"
	result = FALSE;
#line 154 "../src/baobab-window.vala"
	return result;
#line 696 "baobab-window.c"
}

static gboolean
___lambda26__gtk_window_close_request (GtkWindow* _sender,
                                       gpointer self)
{
	gboolean result;
	result = __lambda26_ (self);
#line 147 "../src/baobab-window.vala"
	return result;
#line 707 "baobab-window.c"
}

static void
__lambda27_ (BaobabWindow* self)
{
	GtkApplication* _tmp0_;
	GtkApplication* _tmp1_;
#line 160 "../src/baobab-window.vala"
	_tmp0_ = gtk_window_get_application ((GtkWindow*) self);
#line 160 "../src/baobab-window.vala"
	_tmp1_ = _tmp0_;
#line 160 "../src/baobab-window.vala"
	g_application_withdraw_notification ((GApplication*) _tmp1_, "scan-completed");
#line 721 "baobab-window.c"
}

static void
___lambda27__gtk_event_controller_focus_enter (GtkEventControllerFocus* _sender,
                                               gpointer self)
{
#line 159 "../src/baobab-window.vala"
	__lambda27_ ((BaobabWindow*) self);
#line 730 "baobab-window.c"
}

BaobabWindow*
baobab_window_construct (GType object_type,
                         BaobabApplication* app)
{
	BaobabWindow * self = NULL;
	Block6Data* _data6_;
	GdkCursor* _tmp0_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GAction* action = NULL;
	GSettings* _tmp4_;
	GAction* _tmp5_;
	GAction* _tmp6_;
	BaobabLocationList* _tmp7_;
	GtkBuilder* builder = NULL;
	GtkBuilder* _tmp8_;
	GMenuModel* treeview_menu = NULL;
	GtkBuilder* _tmp9_;
	GObject* _tmp10_;
	GMenuModel* _tmp11_;
	GtkPopoverMenu* _tmp12_;
	GMenuModel* _tmp13_;
	GSettings* _tmp14_;
	AdwViewStack* _tmp15_;
	AdwViewStack* _tmp16_;
	BaobabChart* _tmp17_;
	BaobabChart* _tmp18_;
	BaobabPathbar* _tmp19_;
	BaobabFolderDisplay* _tmp20_;
	GtkDropTarget* _tmp21_;
	GType* _tmp22_;
	GType* _tmp23_;
	gint _tmp23__length1;
	GtkDropTarget* _tmp24_;
	GtkDropTarget* _tmp25_;
	GSettings* _tmp26_;
	gint width = 0;
	gint height = 0;
	GSettings* _tmp27_;
	gint _tmp28_ = 0;
	gint _tmp29_ = 0;
	GSettings* _tmp30_;
	GtkWidget* _tmp31_;
	GtkEventControllerFocus* _tmp32_;
#line 101 "../src/baobab-window.vala"
	g_return_val_if_fail (app != NULL, NULL);
#line 101 "../src/baobab-window.vala"
	_data6_ = g_slice_new0 (Block6Data);
#line 101 "../src/baobab-window.vala"
	_data6_->_ref_count_ = 1;
#line 102 "../src/baobab-window.vala"
	self = (BaobabWindow*) g_object_new (object_type, "application", app, NULL);
#line 102 "../src/baobab-window.vala"
	_data6_->self = g_object_ref (self);
#line 104 "../src/baobab-window.vala"
	_tmp0_ = baobab_window_busy_cursor;
#line 104 "../src/baobab-window.vala"
	if (_tmp0_ == NULL) {
#line 791 "baobab-window.c"
		GdkCursor* _tmp1_;
#line 105 "../src/baobab-window.vala"
		_tmp1_ = gdk_cursor_new_from_name ("wait", NULL);
#line 105 "../src/baobab-window.vala"
		_g_object_unref0 (baobab_window_busy_cursor);
#line 105 "../src/baobab-window.vala"
		baobab_window_busy_cursor = _tmp1_;
#line 799 "baobab-window.c"
	}
#line 108 "../src/baobab-window.vala"
	_tmp2_ = g_settings_new ("org.gnome.baobab.ui");
#line 108 "../src/baobab-window.vala"
	_data6_->ui_settings = _tmp2_;
#line 109 "../src/baobab-window.vala"
	_tmp3_ = _data6_->ui_settings;
#line 109 "../src/baobab-window.vala"
	g_settings_delay (_tmp3_);
#line 111 "../src/baobab-window.vala"
	g_action_map_add_action_entries ((GActionMap*) self, BAOBAB_WINDOW_action_entries, (gint) G_N_ELEMENTS (BAOBAB_WINDOW_action_entries), self);
#line 112 "../src/baobab-window.vala"
	_tmp4_ = _data6_->ui_settings;
#line 112 "../src/baobab-window.vala"
	_tmp5_ = g_settings_create_action (_tmp4_, "active-chart");
#line 112 "../src/baobab-window.vala"
	action = _tmp5_;
#line 113 "../src/baobab-window.vala"
	_tmp6_ = action;
#line 113 "../src/baobab-window.vala"
	g_action_map_add_action ((GActionMap*) self, _tmp6_);
#line 115 "../src/baobab-window.vala"
	_tmp7_ = self->priv->location_list;
#line 115 "../src/baobab-window.vala"
	g_signal_connect_object (_tmp7_, "location-activated", (GCallback) _baobab_window_location_activated_baobab_location_list_location_activated, self, 0);
#line 117 "../src/baobab-window.vala"
	_tmp8_ = gtk_builder_new_from_resource ("/org/gnome/baobab/ui/baobab-treeview-menu.ui");
#line 117 "../src/baobab-window.vala"
	builder = _tmp8_;
#line 118 "../src/baobab-window.vala"
	_tmp9_ = builder;
#line 118 "../src/baobab-window.vala"
	_tmp10_ = gtk_builder_get_object (_tmp9_, "treeview_menu");
#line 118 "../src/baobab-window.vala"
	_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, g_menu_model_get_type (), GMenuModel));
#line 118 "../src/baobab-window.vala"
	treeview_menu = _tmp11_;
#line 120 "../src/baobab-window.vala"
	baobab_window_hide_columnview_header (self);
#line 121 "../src/baobab-window.vala"
	_tmp12_ = self->priv->treeview_popover_menu;
#line 121 "../src/baobab-window.vala"
	_tmp13_ = treeview_menu;
#line 121 "../src/baobab-window.vala"
	gtk_popover_menu_set_menu_model (_tmp12_, _tmp13_);
#line 123 "../src/baobab-window.vala"
	_tmp14_ = _data6_->ui_settings;
#line 123 "../src/baobab-window.vala"
	_tmp15_ = self->priv->chart_stack;
#line 123 "../src/baobab-window.vala"
	g_settings_bind (_tmp14_, "active-chart", (GObject*) _tmp15_, "visible-child-name", G_SETTINGS_BIND_DEFAULT);
#line 124 "../src/baobab-window.vala"
	_tmp16_ = self->priv->chart_stack;
#line 124 "../src/baobab-window.vala"
	g_signal_connect_object ((GtkWidget*) _tmp16_, "destroy", (GCallback) ___lambda25__gtk_widget_destroy, self, 0);
#line 126 "../src/baobab-window.vala"
	_tmp17_ = self->priv->rings_chart;
#line 126 "../src/baobab-window.vala"
	g_signal_connect_object (_tmp17_, "item-activated", (GCallback) _baobab_window_on_chart_item_activated_baobab_chart_item_activated, self, 0);
#line 127 "../src/baobab-window.vala"
	_tmp18_ = self->priv->treemap_chart;
#line 127 "../src/baobab-window.vala"
	g_signal_connect_object (_tmp18_, "item-activated", (GCallback) _baobab_window_on_chart_item_activated_baobab_chart_item_activated, self, 0);
#line 128 "../src/baobab-window.vala"
	_tmp19_ = self->priv->pathbar;
#line 128 "../src/baobab-window.vala"
	g_signal_connect_object (_tmp19_, "item-activated", (GCallback) _baobab_window_on_pathbar_item_activated_baobab_pathbar_item_activated, self, 0);
#line 129 "../src/baobab-window.vala"
	_tmp20_ = self->priv->folder_display;
#line 129 "../src/baobab-window.vala"
	g_signal_connect_object (_tmp20_, "activated", (GCallback) _baobab_window_on_folder_display_activated_baobab_folder_display_activated, self, 0);
#line 132 "../src/baobab-window.vala"
	_tmp21_ = self->priv->drop_target;
#line 132 "../src/baobab-window.vala"
	_tmp22_ = g_new0 (GType, 1);
#line 132 "../src/baobab-window.vala"
	_tmp22_[0] = gdk_file_list_get_type ();
#line 132 "../src/baobab-window.vala"
	_tmp23_ = _tmp22_;
#line 132 "../src/baobab-window.vala"
	_tmp23__length1 = 1;
#line 132 "../src/baobab-window.vala"
	gtk_drop_target_set_gtypes (_tmp21_, _tmp23_, (gsize) 1);
#line 132 "../src/baobab-window.vala"
	_tmp23_ = (g_free (_tmp23_), NULL);
#line 133 "../src/baobab-window.vala"
	_tmp24_ = self->priv->drop_target;
#line 133 "../src/baobab-window.vala"
	g_signal_connect_object (_tmp24_, "drop", (GCallback) _baobab_window_on_drop_gtk_drop_target_drop, self, 0);
#line 134 "../src/baobab-window.vala"
	_tmp25_ = self->priv->drop_target;
#line 134 "../src/baobab-window.vala"
	g_signal_connect_object (_tmp25_, "accept", (GCallback) _baobab_window_on_drop_target_accept_gtk_drop_target_accept, self, 0);
#line 137 "../src/baobab-window.vala"
	_tmp26_ = _data6_->ui_settings;
#line 137 "../src/baobab-window.vala"
	if (g_settings_get_boolean (_tmp26_, "is-maximized")) {
#line 138 "../src/baobab-window.vala"
		gtk_window_maximize ((GtkWindow*) self);
#line 899 "baobab-window.c"
	}
#line 142 "../src/baobab-window.vala"
	_tmp27_ = _data6_->ui_settings;
#line 142 "../src/baobab-window.vala"
	g_settings_get (_tmp27_, "window-size", "(ii)", &_tmp28_, &_tmp29_);
#line 142 "../src/baobab-window.vala"
	width = _tmp28_;
#line 142 "../src/baobab-window.vala"
	height = _tmp29_;
#line 143 "../src/baobab-window.vala"
	gtk_window_set_default_size ((GtkWindow*) self, width, height);
#line 145 "../src/baobab-window.vala"
	_tmp30_ = _data6_->ui_settings;
#line 145 "../src/baobab-window.vala"
	g_settings_bind (_tmp30_, "is-maximized", (GObject*) self, "maximized", G_SETTINGS_BIND_SET);
#line 147 "../src/baobab-window.vala"
	g_signal_connect_data ((GtkWindow*) self, "close-request", (GCallback) ___lambda26__gtk_window_close_request, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
#line 157 "../src/baobab-window.vala"
	_tmp31_ = self->priv->home_page;
#line 157 "../src/baobab-window.vala"
	baobab_window_set_ui_state (self, _tmp31_, FALSE);
#line 159 "../src/baobab-window.vala"
	_tmp32_ = self->priv->focus_controller;
#line 159 "../src/baobab-window.vala"
	g_signal_connect_object (_tmp32_, "enter", (GCallback) ___lambda27__gtk_event_controller_focus_enter, self, 0);
#line 163 "../src/baobab-window.vala"
	gtk_window_present ((GtkWindow*) self);
#line 101 "../src/baobab-window.vala"
	_g_object_unref0 (treeview_menu);
#line 101 "../src/baobab-window.vala"
	_g_object_unref0 (builder);
#line 101 "../src/baobab-window.vala"
	_g_object_unref0 (action);
#line 101 "../src/baobab-window.vala"
	block6_data_unref (_data6_);
#line 101 "../src/baobab-window.vala"
	_data6_ = NULL;
#line 101 "../src/baobab-window.vala"
	return self;
#line 939 "baobab-window.c"
}

BaobabWindow*
baobab_window_new (BaobabApplication* app)
{
#line 101 "../src/baobab-window.vala"
	return baobab_window_construct (BAOBAB_TYPE_WINDOW, app);
#line 947 "baobab-window.c"
}

static void
baobab_window_on_show_primary_menu_activate (BaobabWindow* self,
                                             GSimpleAction* action)
{
	gboolean state = FALSE;
	GVariant* _tmp0_;
	GVariant* _tmp1_;
	gboolean _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
#line 166 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 166 "../src/baobab-window.vala"
	g_return_if_fail (action != NULL);
#line 167 "../src/baobab-window.vala"
	_tmp0_ = g_action_get_state ((GAction*) action);
#line 167 "../src/baobab-window.vala"
	_tmp1_ = _tmp0_;
#line 167 "../src/baobab-window.vala"
	_tmp2_ = g_variant_get_boolean (_tmp1_);
#line 167 "../src/baobab-window.vala"
	_g_variant_unref0 (_tmp1_);
#line 167 "../src/baobab-window.vala"
	state = _tmp2_;
#line 168 "../src/baobab-window.vala"
	_tmp3_ = g_variant_new_boolean (!state);
#line 168 "../src/baobab-window.vala"
	g_variant_ref_sink (_tmp3_);
#line 168 "../src/baobab-window.vala"
	_tmp4_ = _tmp3_;
#line 168 "../src/baobab-window.vala"
	g_simple_action_set_state (action, _tmp4_);
#line 168 "../src/baobab-window.vala"
	_g_variant_unref0 (_tmp4_);
#line 984 "baobab-window.c"
}

static void
baobab_window_results_hidden (BaobabWindow* self)
{
	AdwBanner* _tmp0_;
	GtkWidget* _tmp1_;
#line 172 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 173 "../src/baobab-window.vala"
	baobab_window_cancel_scan (self);
#line 174 "../src/baobab-window.vala"
	_tmp0_ = self->priv->banner;
#line 174 "../src/baobab-window.vala"
	adw_banner_set_revealed (_tmp0_, FALSE);
#line 175 "../src/baobab-window.vala"
	_tmp1_ = self->priv->home_page;
#line 175 "../src/baobab-window.vala"
	baobab_window_set_ui_state (self, _tmp1_, FALSE);
#line 1004 "baobab-window.c"
}

static void
_baobab_window_results_hidden_adw_navigation_page_hidden (AdwNavigationPage* _sender,
                                                          gpointer self)
{
#line 26 "../src/baobab-window.vala"
	baobab_window_results_hidden ((BaobabWindow*) self);
#line 1013 "baobab-window.c"
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 178 "../src/baobab-window.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 178 "../src/baobab-window.vala"
	return _data7_;
#line 1023 "baobab-window.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 178 "../src/baobab-window.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 1033 "baobab-window.c"
		BaobabWindow* self;
#line 178 "../src/baobab-window.vala"
		self = _data7_->self;
#line 178 "../src/baobab-window.vala"
		_g_object_unref0 (_data7_->file_chooser);
#line 178 "../src/baobab-window.vala"
		_g_object_unref0 (self);
#line 178 "../src/baobab-window.vala"
		g_slice_free (Block7Data, _data7_);
#line 1043 "baobab-window.c"
	}
}

static gboolean
bool_parse (const gchar* str)
{
	gboolean result;
#line 44 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 45 "glib-2.0.vapi"
	if (g_strcmp0 (str, "true") == 0) {
#line 46 "glib-2.0.vapi"
		result = TRUE;
#line 46 "glib-2.0.vapi"
		return result;
#line 1059 "baobab-window.c"
	} else {
#line 48 "glib-2.0.vapi"
		result = FALSE;
#line 48 "glib-2.0.vapi"
		return result;
#line 1065 "baobab-window.c"
	}
}

static void
__lambda18_ (Block7Data* _data7_,
             gint response)
{
	BaobabWindow* self;
#line 189 "../src/baobab-window.vala"
	self = _data7_->self;
#line 190 "../src/baobab-window.vala"
	if (response == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 1078 "baobab-window.c"
		gboolean recurse = FALSE;
		const gchar* _tmp0_;
		BaobabScanFlags _tmp1_ = 0U;
		BaobabScanFlags flags = 0U;
		GFile* _tmp2_;
		GFile* _tmp3_;
#line 191 "../src/baobab-window.vala"
		_tmp0_ = gtk_file_chooser_get_choice ((GtkFileChooser*) _data7_->file_chooser, "recurse");
#line 191 "../src/baobab-window.vala"
		recurse = bool_parse (_tmp0_);
#line 192 "../src/baobab-window.vala"
		if (recurse) {
#line 192 "../src/baobab-window.vala"
			_tmp1_ = BAOBAB_SCAN_FLAGS_NONE;
#line 1093 "baobab-window.c"
		} else {
#line 192 "../src/baobab-window.vala"
			_tmp1_ = BAOBAB_SCAN_FLAGS_EXCLUDE_MOUNTS;
#line 1097 "baobab-window.c"
		}
#line 192 "../src/baobab-window.vala"
		flags = _tmp1_;
#line 193 "../src/baobab-window.vala"
		_tmp2_ = gtk_file_chooser_get_file ((GtkFileChooser*) _data7_->file_chooser);
#line 193 "../src/baobab-window.vala"
		_tmp3_ = _tmp2_;
#line 193 "../src/baobab-window.vala"
		baobab_window_scan_directory (self, _tmp3_, flags);
#line 193 "../src/baobab-window.vala"
		_g_object_unref0 (_tmp3_);
#line 1109 "baobab-window.c"
	}
#line 195 "../src/baobab-window.vala"
	gtk_native_dialog_destroy ((GtkNativeDialog*) _data7_->file_chooser);
#line 1113 "baobab-window.c"
}

static void
___lambda18__gtk_native_dialog_response (GtkNativeDialog* _sender,
                                         gint response_id,
                                         gpointer self)
{
#line 189 "../src/baobab-window.vala"
	__lambda18_ (self, response_id);
#line 1123 "baobab-window.c"
}

static void
baobab_window_on_scan_folder_activate (BaobabWindow* self)
{
	Block7Data* _data7_;
	GtkFileChooserNative* _tmp0_;
#line 178 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 178 "../src/baobab-window.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 178 "../src/baobab-window.vala"
	_data7_->_ref_count_ = 1;
#line 178 "../src/baobab-window.vala"
	_data7_->self = g_object_ref (self);
#line 179 "../src/baobab-window.vala"
	_tmp0_ = gtk_file_chooser_native_new (_ ("Select Folder"), (GtkWindow*) self, GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER, NULL, NULL);
#line 179 "../src/baobab-window.vala"
	_data7_->file_chooser = _tmp0_;
#line 183 "../src/baobab-window.vala"
	gtk_native_dialog_set_modal ((GtkNativeDialog*) _data7_->file_chooser, TRUE);
#line 185 "../src/baobab-window.vala"
	gtk_file_chooser_add_choice ((GtkFileChooser*) _data7_->file_chooser, "recurse", _ ("Recursively analyze mount points"), NULL, NULL);
#line 189 "../src/baobab-window.vala"
	g_signal_connect_data ((GtkNativeDialog*) _data7_->file_chooser, "response", (GCallback) ___lambda18__gtk_native_dialog_response, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 198 "../src/baobab-window.vala"
	gtk_native_dialog_show ((GtkNativeDialog*) _data7_->file_chooser);
#line 178 "../src/baobab-window.vala"
	block7_data_unref (_data7_);
#line 178 "../src/baobab-window.vala"
	_data7_ = NULL;
#line 1155 "baobab-window.c"
}

static gpointer
_baobab_location_ref0 (gpointer self)
{
#line 201 "../src/baobab-window.vala"
	return self ? baobab_location_ref (self) : NULL;
#line 1163 "baobab-window.c"
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 201 "../src/baobab-window.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 201 "../src/baobab-window.vala"
	return _data8_;
#line 1173 "baobab-window.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 201 "../src/baobab-window.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 1183 "baobab-window.c"
		BaobabWindow* self;
#line 201 "../src/baobab-window.vala"
		self = _data8_->self;
#line 201 "../src/baobab-window.vala"
		_baobab_location_unref0 (_data8_->location);
#line 201 "../src/baobab-window.vala"
		_g_object_unref0 (self);
#line 201 "../src/baobab-window.vala"
		g_slice_free (Block8Data, _data8_);
#line 1193 "baobab-window.c"
	}
}

static void
__lambda24_ (Block8Data* _data8_,
             GObject* location_,
             GAsyncResult* res)
{
	BaobabWindow* self;
	GError* _inner_error0_ = NULL;
#line 203 "../src/baobab-window.vala"
	self = _data8_->self;
#line 203 "../src/baobab-window.vala"
	g_return_if_fail (res != NULL);
#line 1208 "baobab-window.c"
	{
#line 205 "../src/baobab-window.vala"
		baobab_location_mount_volume_finish (_data8_->location, res, &_inner_error0_);
#line 205 "../src/baobab-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1214 "baobab-window.c"
			goto __catch0_g_error;
		}
#line 206 "../src/baobab-window.vala"
		baobab_window_scan_location (self, _data8_->location, FALSE);
#line 1219 "baobab-window.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 204 "../src/baobab-window.vala"
		e = _inner_error0_;
#line 204 "../src/baobab-window.vala"
		_inner_error0_ = NULL;
#line 208 "../src/baobab-window.vala"
		baobab_window_set_busy (self, FALSE);
#line 209 "../src/baobab-window.vala"
		_tmp0_ = e;
#line 209 "../src/baobab-window.vala"
		_tmp1_ = _tmp0_->message;
#line 209 "../src/baobab-window.vala"
		g_warning ("baobab-window.vala:209: Could not analyze volume: %s\n", _tmp1_);
#line 210 "../src/baobab-window.vala"
		baobab_window_toast (self, _ ("Could not analyze volume"));
#line 204 "../src/baobab-window.vala"
		_g_error_free0 (e);
#line 1243 "baobab-window.c"
	}
	__finally0:
#line 204 "../src/baobab-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 204 "../src/baobab-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 204 "../src/baobab-window.vala"
		g_clear_error (&_inner_error0_);
#line 204 "../src/baobab-window.vala"
		return;
#line 1254 "baobab-window.c"
	}
}

static void
___lambda24__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 203 "../src/baobab-window.vala"
	__lambda24_ (self, source_object, res);
#line 203 "../src/baobab-window.vala"
	block8_data_unref (self);
#line 1267 "baobab-window.c"
}

static void
baobab_window_location_activated (BaobabWindow* self,
                                  BaobabLocation* location)
{
	Block8Data* _data8_;
	BaobabLocation* _tmp0_;
#line 201 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 201 "../src/baobab-window.vala"
	g_return_if_fail (location != NULL);
#line 201 "../src/baobab-window.vala"
	_data8_ = g_slice_new0 (Block8Data);
#line 201 "../src/baobab-window.vala"
	_data8_->_ref_count_ = 1;
#line 201 "../src/baobab-window.vala"
	_data8_->self = g_object_ref (self);
#line 201 "../src/baobab-window.vala"
	_tmp0_ = _baobab_location_ref0 (location);
#line 201 "../src/baobab-window.vala"
	_baobab_location_unref0 (_data8_->location);
#line 201 "../src/baobab-window.vala"
	_data8_->location = _tmp0_;
#line 202 "../src/baobab-window.vala"
	baobab_window_set_busy (self, TRUE);
#line 203 "../src/baobab-window.vala"
	baobab_location_mount_volume (_data8_->location, ___lambda24__gasync_ready_callback, block8_data_ref (_data8_));
#line 201 "../src/baobab-window.vala"
	block8_data_unref (_data8_);
#line 201 "../src/baobab-window.vala"
	_data8_ = NULL;
#line 1300 "baobab-window.c"
}

static void
baobab_window_on_reload_activate (BaobabWindow* self)
{
	BaobabLocation* _tmp0_;
#line 215 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 216 "../src/baobab-window.vala"
	_tmp0_ = self->priv->active_location;
#line 216 "../src/baobab-window.vala"
	baobab_window_scan_location (self, _tmp0_, TRUE);
#line 1313 "baobab-window.c"
}

static void
baobab_window_cancel_scan (BaobabWindow* self)
{
	gboolean _tmp0_ = FALSE;
	BaobabLocation* _tmp1_;
#line 219 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 220 "../src/baobab-window.vala"
	_tmp1_ = self->priv->active_location;
#line 220 "../src/baobab-window.vala"
	if (_tmp1_ != NULL) {
#line 1327 "baobab-window.c"
		BaobabLocation* _tmp2_;
		BaobabScanner* _tmp3_;
		BaobabScanner* _tmp4_;
#line 220 "../src/baobab-window.vala"
		_tmp2_ = self->priv->active_location;
#line 220 "../src/baobab-window.vala"
		_tmp3_ = baobab_location_get_scanner (_tmp2_);
#line 220 "../src/baobab-window.vala"
		_tmp4_ = _tmp3_;
#line 220 "../src/baobab-window.vala"
		_tmp0_ = _tmp4_ != NULL;
#line 1339 "baobab-window.c"
	} else {
#line 220 "../src/baobab-window.vala"
		_tmp0_ = FALSE;
#line 1343 "baobab-window.c"
	}
#line 220 "../src/baobab-window.vala"
	if (_tmp0_) {
#line 1347 "baobab-window.c"
		BaobabLocation* _tmp5_;
		BaobabScanner* _tmp6_;
		BaobabScanner* _tmp7_;
#line 221 "../src/baobab-window.vala"
		_tmp5_ = self->priv->active_location;
#line 221 "../src/baobab-window.vala"
		_tmp6_ = baobab_location_get_scanner (_tmp5_);
#line 221 "../src/baobab-window.vala"
		_tmp7_ = _tmp6_;
#line 221 "../src/baobab-window.vala"
		baobab_scanner_cancel (_tmp7_);
#line 1359 "baobab-window.c"
	}
#line 224 "../src/baobab-window.vala"
	if (self->priv->scan_completed_handler > ((gulong) 0)) {
#line 1363 "baobab-window.c"
		BaobabLocation* _tmp8_;
		BaobabScanner* _tmp9_;
		BaobabScanner* _tmp10_;
#line 225 "../src/baobab-window.vala"
		_tmp8_ = self->priv->active_location;
#line 225 "../src/baobab-window.vala"
		_tmp9_ = baobab_location_get_scanner (_tmp8_);
#line 225 "../src/baobab-window.vala"
		_tmp10_ = _tmp9_;
#line 225 "../src/baobab-window.vala"
		g_signal_handler_disconnect ((GObject*) _tmp10_, self->priv->scan_completed_handler);
#line 226 "../src/baobab-window.vala"
		self->priv->scan_completed_handler = (gulong) 0;
#line 1377 "baobab-window.c"
	}
#line 229 "../src/baobab-window.vala"
	_baobab_location_unref0 (self->priv->active_location);
#line 229 "../src/baobab-window.vala"
	self->priv->active_location = NULL;
#line 1383 "baobab-window.c"
}

static void
baobab_window_on_clear_recent (BaobabWindow* self)
{
	BaobabLocationList* _tmp0_;
#line 232 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 233 "../src/baobab-window.vala"
	_tmp0_ = self->priv->location_list;
#line 233 "../src/baobab-window.vala"
	baobab_location_list_clear_recent (_tmp0_, TRUE);
#line 1396 "baobab-window.c"
}

static void
baobab_window_on_show_preferences (BaobabWindow* self)
{
	BaobabPreferencesDialog* dialog = NULL;
	BaobabPreferencesDialog* _tmp0_;
#line 236 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 237 "../src/baobab-window.vala"
	_tmp0_ = baobab_preferences_dialog_new ();
#line 237 "../src/baobab-window.vala"
	g_object_ref_sink (_tmp0_);
#line 237 "../src/baobab-window.vala"
	dialog = _tmp0_;
#line 238 "../src/baobab-window.vala"
	adw_dialog_present ((AdwDialog*) dialog, (GtkWidget*) self);
#line 236 "../src/baobab-window.vala"
	_g_object_unref0 (dialog);
#line 1416 "baobab-window.c"
}

static void
baobab_window_on_help_activate (BaobabWindow* self)
{
#line 241 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 242 "../src/baobab-window.vala"
	gtk_show_uri ((GtkWindow*) self, "help:baobab", (guint32) GDK_CURRENT_TIME);
#line 1426 "baobab-window.c"
}

static gchar**
_vala_array_dup2 (gchar** self,
                  gssize length)
{
#line 259 "../src/baobab-window.vala"
	if (length >= 0) {
#line 1435 "baobab-window.c"
		gchar** result;
		gssize i;
#line 259 "../src/baobab-window.vala"
		result = g_new0 (gchar*, length + 1);
#line 259 "../src/baobab-window.vala"
		for (i = 0; i < length; i++) {
#line 1442 "baobab-window.c"
			gchar* _tmp0_;
#line 259 "../src/baobab-window.vala"
			_tmp0_ = g_strdup (self[i]);
#line 259 "../src/baobab-window.vala"
			result[i] = _tmp0_;
#line 1448 "baobab-window.c"
		}
#line 259 "../src/baobab-window.vala"
		return result;
#line 1452 "baobab-window.c"
	}
#line 259 "../src/baobab-window.vala"
	return NULL;
#line 1456 "baobab-window.c"
}

static void
baobab_window_on_about_activate (BaobabWindow* self)
{
#line 246 "../src/baobab-window.vala"
	static const gchar* developers[7] = {"Ryan Lortie <desrt@desrt.ca>", "Fabio Marzocca <thesaltydog@gmail.com>", "Paolo Borelli <pborelli@gnome.com>", "Stefano Facchini <stefano.facchini@gmail.com>", "Benoît Dejean <benoit@placenet.org>", "Igalia (rings-chart and treemap widget) <www.igalia.com>", NULL};
#line 256 "../src/baobab-window.vala"
	static const char copyright[] = "Copyright \xc2\xa9 2005-2011 Fabio Marzocca, Paolo Borelli, Benoît Dej" \
"ean, Igalia\n" "Copyright \xc2\xa9 2011-2012 Ryan Lortie, Paolo Borelli, Stefano Facch" \
"ini\n";
#line 1466 "baobab-window.c"
	AdwAboutDialog* about = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	gchar* _tmp8_;
	AdwAboutDialog* _tmp9_ = NULL;
#line 245 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 259 "../src/baobab-window.vala"
	_tmp0_ = g_strdup (_ ("Disk Usage Analyzer"));
#line 259 "../src/baobab-window.vala"
	_tmp1_ = g_strdup ("org.gnome.baobab");
#line 259 "../src/baobab-window.vala"
	_tmp2_ = g_strdup (_ ("The GNOME Project"));
#line 259 "../src/baobab-window.vala"
	_tmp3_ = g_strdup (VERSION);
#line 259 "../src/baobab-window.vala"
	_tmp4_ = g_strdup ("https://apps.gnome.org/Baobab/");
#line 259 "../src/baobab-window.vala"
	_tmp5_ = g_strdup ("https://gitlab.gnome.org/GNOME/baobab/-/issues/new");
#line 259 "../src/baobab-window.vala"
	_tmp6_ = g_strdup (copyright);
#line 259 "../src/baobab-window.vala"
	_tmp7_ = _vala_array_dup2 (developers, G_N_ELEMENTS (developers));
#line 259 "../src/baobab-window.vala"
	_tmp7__length1 = G_N_ELEMENTS (developers);
#line 259 "../src/baobab-window.vala"
	_tmp8_ = g_strdup (_ ("translator-credits"));
#line 259 "../src/baobab-window.vala"
	_tmp9_ = (AdwAboutDialog*) adw_about_dialog_new ();
#line 259 "../src/baobab-window.vala"
	adw_about_dialog_set_application_name (_tmp9_, _tmp0_);
#line 259 "../src/baobab-window.vala"
	_g_free0 (_tmp0_);
#line 259 "../src/baobab-window.vala"
	adw_about_dialog_set_application_icon (_tmp9_, _tmp1_);
#line 259 "../src/baobab-window.vala"
	_g_free0 (_tmp1_);
#line 259 "../src/baobab-window.vala"
	adw_about_dialog_set_developer_name (_tmp9_, _tmp2_);
#line 259 "../src/baobab-window.vala"
	_g_free0 (_tmp2_);
#line 259 "../src/baobab-window.vala"
	adw_about_dialog_set_version (_tmp9_, _tmp3_);
#line 259 "../src/baobab-window.vala"
	_g_free0 (_tmp3_);
#line 259 "../src/baobab-window.vala"
	adw_about_dialog_set_website (_tmp9_, _tmp4_);
#line 259 "../src/baobab-window.vala"
	_g_free0 (_tmp4_);
#line 259 "../src/baobab-window.vala"
	adw_about_dialog_set_issue_url (_tmp9_, _tmp5_);
#line 259 "../src/baobab-window.vala"
	_g_free0 (_tmp5_);
#line 259 "../src/baobab-window.vala"
	adw_about_dialog_set_copyright (_tmp9_, _tmp6_);
#line 259 "../src/baobab-window.vala"
	_g_free0 (_tmp6_);
#line 259 "../src/baobab-window.vala"
	adw_about_dialog_set_license_type (_tmp9_, GTK_LICENSE_GPL_2_0);
#line 259 "../src/baobab-window.vala"
	adw_about_dialog_set_developers (_tmp9_, _tmp7_);
#line 259 "../src/baobab-window.vala"
	_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
#line 259 "../src/baobab-window.vala"
	adw_about_dialog_set_translator_credits (_tmp9_, _tmp8_);
#line 259 "../src/baobab-window.vala"
	_g_free0 (_tmp8_);
#line 259 "../src/baobab-window.vala"
	g_object_ref_sink (_tmp9_);
#line 259 "../src/baobab-window.vala"
	about = _tmp9_;
#line 272 "../src/baobab-window.vala"
	adw_dialog_present ((AdwDialog*) about, (GtkWidget*) self);
#line 245 "../src/baobab-window.vala"
	_g_object_unref0 (about);
#line 1549 "baobab-window.c"
}

static void
baobab_window_on_chart_item_activated (BaobabWindow* self,
                                       BaobabChart* chart,
                                       BaobabScannerResults* item)
{
#line 275 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 275 "../src/baobab-window.vala"
	g_return_if_fail (chart != NULL);
#line 275 "../src/baobab-window.vala"
	g_return_if_fail (item != NULL);
#line 276 "../src/baobab-window.vala"
	baobab_window_reroot_treeview (self, item, FALSE);
#line 1565 "baobab-window.c"
}

static void
baobab_window_on_pathbar_item_activated (BaobabWindow* self,
                                         BaobabPathbar* pathbar,
                                         BaobabScannerResults* path)
{
#line 279 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 279 "../src/baobab-window.vala"
	g_return_if_fail (pathbar != NULL);
#line 279 "../src/baobab-window.vala"
	g_return_if_fail (path != NULL);
#line 280 "../src/baobab-window.vala"
	baobab_window_reroot_treeview (self, path, FALSE);
#line 1581 "baobab-window.c"
}

static void
baobab_window_on_folder_display_activated (BaobabWindow* self)
{
#line 283 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 284 "../src/baobab-window.vala"
	baobab_window_go_up_treeview (self);
#line 1591 "baobab-window.c"
}

static void
baobab_window_go_up_treeview (BaobabWindow* self)
{
	BaobabScannerResults* path = NULL;
	BaobabFolderDisplay* _tmp0_;
	BaobabScannerResults* _tmp1_;
	BaobabScannerResults* _tmp2_;
	BaobabScannerResults* _tmp3_;
	gboolean _tmp4_ = FALSE;
	BaobabScannerResults* _tmp5_;
#line 287 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 288 "../src/baobab-window.vala"
	_tmp0_ = self->priv->folder_display;
#line 288 "../src/baobab-window.vala"
	_tmp1_ = baobab_folder_display_get_path (_tmp0_);
#line 288 "../src/baobab-window.vala"
	_tmp2_ = _tmp1_;
#line 288 "../src/baobab-window.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 288 "../src/baobab-window.vala"
	path = _tmp3_;
#line 289 "../src/baobab-window.vala"
	_tmp5_ = path;
#line 289 "../src/baobab-window.vala"
	if (_tmp5_ != NULL) {
#line 1620 "baobab-window.c"
		BaobabScannerResults* _tmp6_;
#line 289 "../src/baobab-window.vala"
		_tmp6_ = path;
#line 289 "../src/baobab-window.vala"
		_tmp4_ = baobab_scanner_results_get_depth (_tmp6_) > 1;
#line 1626 "baobab-window.c"
	} else {
#line 289 "../src/baobab-window.vala"
		_tmp4_ = FALSE;
#line 1630 "baobab-window.c"
	}
#line 289 "../src/baobab-window.vala"
	if (_tmp4_) {
#line 1634 "baobab-window.c"
		BaobabScannerResults* _tmp7_;
		BaobabScannerResults* _tmp8_;
		BaobabScannerResults* _tmp9_;
#line 290 "../src/baobab-window.vala"
		_tmp7_ = path;
#line 290 "../src/baobab-window.vala"
		_tmp8_ = baobab_scanner_results_get_parent (_tmp7_);
#line 290 "../src/baobab-window.vala"
		_tmp9_ = _tmp8_;
#line 290 "../src/baobab-window.vala"
		baobab_window_reroot_treeview (self, _tmp9_, FALSE);
#line 1646 "baobab-window.c"
	}
#line 287 "../src/baobab-window.vala"
	_g_object_unref0 (path);
#line 1650 "baobab-window.c"
}

static gboolean
baobab_window_on_drop_target_accept (BaobabWindow* self,
                                     GtkDropTarget* target,
                                     GdkDrop* drop)
{
	gboolean result;
#line 294 "../src/baobab-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 294 "../src/baobab-window.vala"
	g_return_val_if_fail (target != NULL, FALSE);
#line 294 "../src/baobab-window.vala"
	g_return_val_if_fail (drop != NULL, FALSE);
#line 295 "../src/baobab-window.vala"
	result = !self->priv->is_busy;
#line 295 "../src/baobab-window.vala"
	return result;
#line 1669 "baobab-window.c"
}

static gboolean
baobab_window_on_drop (BaobabWindow* self,
                       GtkDropTarget* target,
                       GValue* value,
                       gdouble x,
                       gdouble y)
{
	gboolean result;
#line 298 "../src/baobab-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 298 "../src/baobab-window.vala"
	g_return_val_if_fail (target != NULL, FALSE);
#line 298 "../src/baobab-window.vala"
	g_return_val_if_fail (value != NULL, FALSE);
#line 299 "../src/baobab-window.vala"
	if (G_VALUE_TYPE (value) == gdk_file_list_get_type ()) {
#line 1688 "baobab-window.c"
		GSList* files = NULL;
		void* _tmp0_;
		GFile* dir = NULL;
		gboolean _tmp1_ = FALSE;
		GSList* _tmp2_;
		GFile* _tmp8_;
#line 300 "../src/baobab-window.vala"
		_tmp0_ = g_value_get_boxed (value);
#line 300 "../src/baobab-window.vala"
		files = (GSList*) _tmp0_;
#line 301 "../src/baobab-window.vala"
		dir = NULL;
#line 302 "../src/baobab-window.vala"
		_tmp2_ = files;
#line 302 "../src/baobab-window.vala"
		if (_tmp2_ != NULL) {
#line 1705 "baobab-window.c"
			GSList* _tmp3_;
#line 302 "../src/baobab-window.vala"
			_tmp3_ = files;
#line 302 "../src/baobab-window.vala"
			_tmp1_ = g_slist_length (_tmp3_) == ((guint) 1);
#line 1711 "baobab-window.c"
		} else {
#line 302 "../src/baobab-window.vala"
			_tmp1_ = FALSE;
#line 1715 "baobab-window.c"
		}
#line 302 "../src/baobab-window.vala"
		if (_tmp1_) {
#line 1719 "baobab-window.c"
			GSList* _tmp4_;
			GSList* _tmp5_;
			gconstpointer _tmp6_;
			GFile* _tmp7_;
#line 303 "../src/baobab-window.vala"
			_tmp4_ = files;
#line 303 "../src/baobab-window.vala"
			_tmp5_ = g_slist_nth (_tmp4_, (guint) 0);
#line 303 "../src/baobab-window.vala"
			_tmp6_ = _tmp5_->data;
#line 303 "../src/baobab-window.vala"
			_tmp7_ = _g_object_ref0 ((GFile*) _tmp6_);
#line 303 "../src/baobab-window.vala"
			_g_object_unref0 (dir);
#line 303 "../src/baobab-window.vala"
			dir = _tmp7_;
#line 1736 "baobab-window.c"
		}
#line 306 "../src/baobab-window.vala"
		_tmp8_ = dir;
#line 306 "../src/baobab-window.vala"
		if (_tmp8_ != NULL) {
#line 1742 "baobab-window.c"
			GFile* _tmp9_;
#line 307 "../src/baobab-window.vala"
			_tmp9_ = dir;
#line 307 "../src/baobab-window.vala"
			baobab_window_scan_directory (self, _tmp9_, BAOBAB_SCAN_FLAGS_NONE);
#line 1748 "baobab-window.c"
		}
#line 310 "../src/baobab-window.vala"
		result = TRUE;
#line 310 "../src/baobab-window.vala"
		_g_object_unref0 (dir);
#line 310 "../src/baobab-window.vala"
		return result;
#line 1756 "baobab-window.c"
	}
#line 313 "../src/baobab-window.vala"
	result = FALSE;
#line 313 "../src/baobab-window.vala"
	return result;
#line 1762 "baobab-window.c"
}

static gboolean
baobab_window_show_treeview_popover (BaobabWindow* self,
                                     GtkPopoverMenu* popover,
                                     gint x,
                                     gint y)
{
	GdkRectangle rect = {0};
	GdkRectangle _tmp0_ = {0};
	GdkRectangle _tmp1_;
	gboolean result;
#line 316 "../src/baobab-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 316 "../src/baobab-window.vala"
	g_return_val_if_fail (popover != NULL, FALSE);
#line 317 "../src/baobab-window.vala"
	_tmp0_.x = x;
#line 317 "../src/baobab-window.vala"
	_tmp0_.y = y;
#line 317 "../src/baobab-window.vala"
	_tmp0_.width = 0;
#line 317 "../src/baobab-window.vala"
	_tmp0_.height = 0;
#line 317 "../src/baobab-window.vala"
	rect = _tmp0_;
#line 318 "../src/baobab-window.vala"
	_tmp1_ = rect;
#line 318 "../src/baobab-window.vala"
	gtk_popover_set_pointing_to ((GtkPopover*) popover, &_tmp1_);
#line 319 "../src/baobab-window.vala"
	gtk_popover_popup ((GtkPopover*) popover);
#line 320 "../src/baobab-window.vala"
	result = GDK_EVENT_STOP;
#line 320 "../src/baobab-window.vala"
	return result;
#line 1799 "baobab-window.c"
}

void
baobab_window_open_item (BaobabWindow* self,
                         BaobabScannerResults* results)
{
	GFile* file = NULL;
	BaobabLocation* _tmp0_;
	BaobabScanner* _tmp1_;
	BaobabScanner* _tmp2_;
	GFile* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 323 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 323 "../src/baobab-window.vala"
	g_return_if_fail (results != NULL);
#line 324 "../src/baobab-window.vala"
	_tmp0_ = self->priv->active_location;
#line 324 "../src/baobab-window.vala"
	_tmp1_ = baobab_location_get_scanner (_tmp0_);
#line 324 "../src/baobab-window.vala"
	_tmp2_ = _tmp1_;
#line 324 "../src/baobab-window.vala"
	_tmp3_ = baobab_scanner_get_file (_tmp2_, results);
#line 324 "../src/baobab-window.vala"
	file = _tmp3_;
#line 1826 "baobab-window.c"
	{
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 326 "../src/baobab-window.vala"
		_tmp4_ = g_file_get_uri (file);
#line 326 "../src/baobab-window.vala"
		_tmp5_ = _tmp4_;
#line 326 "../src/baobab-window.vala"
		g_app_info_launch_default_for_uri (_tmp5_, NULL, &_inner_error0_);
#line 326 "../src/baobab-window.vala"
		_g_free0 (_tmp5_);
#line 326 "../src/baobab-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1840 "baobab-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 325 "../src/baobab-window.vala"
		e = _inner_error0_;
#line 325 "../src/baobab-window.vala"
		_inner_error0_ = NULL;
#line 328 "../src/baobab-window.vala"
		_tmp6_ = e;
#line 328 "../src/baobab-window.vala"
		_tmp7_ = _tmp6_->message;
#line 328 "../src/baobab-window.vala"
		g_warning ("baobab-window.vala:328: Failed to open file: %s\n", _tmp7_);
#line 329 "../src/baobab-window.vala"
		baobab_window_toast (self, _ ("Failed to open file"));
#line 325 "../src/baobab-window.vala"
		_g_error_free0 (e);
#line 1864 "baobab-window.c"
	}
	__finally0:
#line 325 "../src/baobab-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 325 "../src/baobab-window.vala"
		_g_object_unref0 (file);
#line 325 "../src/baobab-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 325 "../src/baobab-window.vala"
		g_clear_error (&_inner_error0_);
#line 325 "../src/baobab-window.vala"
		return;
#line 1877 "baobab-window.c"
	}
#line 323 "../src/baobab-window.vala"
	_g_object_unref0 (file);
#line 1881 "baobab-window.c"
}

void
baobab_window_copy_path (BaobabWindow* self,
                         BaobabScannerResults* results)
{
	gchar* parse_name = NULL;
	BaobabLocation* _tmp0_;
	BaobabScanner* _tmp1_;
	BaobabScanner* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GdkClipboard* clipboard = NULL;
	GdkClipboard* _tmp7_;
	GdkClipboard* _tmp8_;
#line 333 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 333 "../src/baobab-window.vala"
	g_return_if_fail (results != NULL);
#line 334 "../src/baobab-window.vala"
	_tmp0_ = self->priv->active_location;
#line 334 "../src/baobab-window.vala"
	_tmp1_ = baobab_location_get_scanner (_tmp0_);
#line 334 "../src/baobab-window.vala"
	_tmp2_ = _tmp1_;
#line 334 "../src/baobab-window.vala"
	_tmp3_ = baobab_scanner_get_file (_tmp2_, results);
#line 334 "../src/baobab-window.vala"
	_tmp4_ = _tmp3_;
#line 334 "../src/baobab-window.vala"
	_tmp5_ = g_file_get_parse_name (_tmp4_);
#line 334 "../src/baobab-window.vala"
	_tmp6_ = _tmp5_;
#line 334 "../src/baobab-window.vala"
	_g_object_unref0 (_tmp4_);
#line 334 "../src/baobab-window.vala"
	parse_name = _tmp6_;
#line 335 "../src/baobab-window.vala"
	_tmp7_ = gtk_widget_get_clipboard ((GtkWidget*) self);
#line 335 "../src/baobab-window.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 335 "../src/baobab-window.vala"
	clipboard = _tmp8_;
#line 336 "../src/baobab-window.vala"
	gdk_clipboard_set_text (clipboard, parse_name);
#line 333 "../src/baobab-window.vala"
	_g_object_unref0 (clipboard);
#line 333 "../src/baobab-window.vala"
	_g_free0 (parse_name);
#line 1933 "baobab-window.c"
}

void
baobab_window_trash_file (BaobabWindow* self,
                          BaobabScannerResults* results)
{
	GFile* file = NULL;
	BaobabLocation* _tmp0_;
	BaobabScanner* _tmp1_;
	BaobabScanner* _tmp2_;
	GFile* _tmp3_;
	BaobabScannerResults* parent = NULL;
	BaobabScannerResults* _tmp7_;
	BaobabScannerResults* _tmp8_;
	BaobabScannerResults* _tmp9_;
	guint position = 0U;
	BaobabScannerResults* _tmp10_;
	BaobabScannerResults* _tmp11_;
	GListStore* _tmp12_;
	GListStore* _tmp13_;
	guint _tmp14_ = 0U;
	gboolean _tmp15_;
	GError* _inner_error0_ = NULL;
#line 339 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 339 "../src/baobab-window.vala"
	g_return_if_fail (results != NULL);
#line 340 "../src/baobab-window.vala"
	_tmp0_ = self->priv->active_location;
#line 340 "../src/baobab-window.vala"
	_tmp1_ = baobab_location_get_scanner (_tmp0_);
#line 340 "../src/baobab-window.vala"
	_tmp2_ = _tmp1_;
#line 340 "../src/baobab-window.vala"
	_tmp3_ = baobab_scanner_get_file (_tmp2_, results);
#line 340 "../src/baobab-window.vala"
	file = _tmp3_;
#line 1971 "baobab-window.c"
	{
#line 342 "../src/baobab-window.vala"
		g_file_trash (file, NULL, &_inner_error0_);
#line 342 "../src/baobab-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1977 "baobab-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
#line 341 "../src/baobab-window.vala"
		e = _inner_error0_;
#line 341 "../src/baobab-window.vala"
		_inner_error0_ = NULL;
#line 344 "../src/baobab-window.vala"
		_tmp4_ = e;
#line 344 "../src/baobab-window.vala"
		if (!g_error_matches (_tmp4_, g_io_error_quark (), G_IO_ERROR_NOT_FOUND)) {
#line 1994 "baobab-window.c"
			GError* _tmp5_;
			const gchar* _tmp6_;
#line 345 "../src/baobab-window.vala"
			_tmp5_ = e;
#line 345 "../src/baobab-window.vala"
			_tmp6_ = _tmp5_->message;
#line 345 "../src/baobab-window.vala"
			g_warning ("baobab-window.vala:345: Failed to move to file to the trash: %s", _tmp6_);
#line 346 "../src/baobab-window.vala"
			baobab_window_toast (self, _ ("Failed to trash file"));
#line 347 "../src/baobab-window.vala"
			_g_error_free0 (e);
#line 347 "../src/baobab-window.vala"
			_g_object_unref0 (file);
#line 347 "../src/baobab-window.vala"
			return;
#line 2011 "baobab-window.c"
		}
#line 341 "../src/baobab-window.vala"
		_g_error_free0 (e);
#line 2015 "baobab-window.c"
	}
	__finally0:
#line 341 "../src/baobab-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 341 "../src/baobab-window.vala"
		_g_object_unref0 (file);
#line 341 "../src/baobab-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 341 "../src/baobab-window.vala"
		g_clear_error (&_inner_error0_);
#line 341 "../src/baobab-window.vala"
		return;
#line 2028 "baobab-window.c"
	}
#line 351 "../src/baobab-window.vala"
	_tmp7_ = baobab_scanner_results_get_parent (results);
#line 351 "../src/baobab-window.vala"
	_tmp8_ = _tmp7_;
#line 351 "../src/baobab-window.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 351 "../src/baobab-window.vala"
	parent = _tmp9_;
#line 352 "../src/baobab-window.vala"
	position = (guint) 0;
#line 353 "../src/baobab-window.vala"
	_tmp10_ = baobab_scanner_results_get_parent (results);
#line 353 "../src/baobab-window.vala"
	_tmp11_ = _tmp10_;
#line 353 "../src/baobab-window.vala"
	_tmp12_ = baobab_scanner_results_get_children_list_store (_tmp11_);
#line 353 "../src/baobab-window.vala"
	_tmp13_ = _tmp12_;
#line 353 "../src/baobab-window.vala"
	_tmp15_ = g_list_store_find (_tmp13_, (GObject*) results, &_tmp14_);
#line 353 "../src/baobab-window.vala"
	position = _tmp14_;
#line 353 "../src/baobab-window.vala"
	if (_tmp15_) {
#line 2054 "baobab-window.c"
		BaobabScannerResults* _tmp16_;
		BaobabScannerResults* _tmp17_;
		GListStore* _tmp18_;
		GListStore* _tmp19_;
#line 354 "../src/baobab-window.vala"
		_tmp16_ = baobab_scanner_results_get_parent (results);
#line 354 "../src/baobab-window.vala"
		_tmp17_ = _tmp16_;
#line 354 "../src/baobab-window.vala"
		_tmp18_ = baobab_scanner_results_get_children_list_store (_tmp17_);
#line 354 "../src/baobab-window.vala"
		_tmp19_ = _tmp18_;
#line 354 "../src/baobab-window.vala"
		g_list_store_remove (_tmp19_, position);
#line 2069 "baobab-window.c"
	}
#line 339 "../src/baobab-window.vala"
	_g_object_unref0 (parent);
#line 339 "../src/baobab-window.vala"
	_g_object_unref0 (file);
#line 2075 "baobab-window.c"
}

static gboolean
baobab_window_columnview_selection_find (BaobabWindow* self,
                                         GObject* item,
                                         gboolean passthrough,
                                         guint* position)
{
	guint _vala_position = 0U;
	gboolean result;
#line 358 "../src/baobab-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 376 "../src/baobab-window.vala"
	if (item == NULL) {
#line 377 "../src/baobab-window.vala"
		result = FALSE;
#line 377 "../src/baobab-window.vala"
		if (position) {
#line 377 "../src/baobab-window.vala"
			*position = _vala_position;
#line 2096 "baobab-window.c"
		}
#line 377 "../src/baobab-window.vala"
		return result;
#line 2100 "baobab-window.c"
	}
	{
		guint i = 0U;
#line 380 "../src/baobab-window.vala"
		i = (guint) 0;
#line 2106 "baobab-window.c"
		{
			gboolean _tmp0_ = FALSE;
#line 380 "../src/baobab-window.vala"
			_tmp0_ = TRUE;
#line 380 "../src/baobab-window.vala"
			while (TRUE) {
#line 2113 "baobab-window.c"
				gboolean _tmp2_ = FALSE;
				GtkSingleSelection* _tmp3_;
				guint _tmp4_;
				guint _tmp5_;
#line 380 "../src/baobab-window.vala"
				if (!_tmp0_) {
#line 2120 "baobab-window.c"
					guint _tmp1_;
#line 380 "../src/baobab-window.vala"
					_tmp1_ = i;
#line 380 "../src/baobab-window.vala"
					i = _tmp1_ + 1;
#line 2126 "baobab-window.c"
				}
#line 380 "../src/baobab-window.vala"
				_tmp0_ = FALSE;
#line 380 "../src/baobab-window.vala"
				_tmp3_ = self->priv->columnview_selection;
#line 380 "../src/baobab-window.vala"
				g_object_get (_tmp3_, "n-items", &_tmp4_, NULL);
#line 380 "../src/baobab-window.vala"
				_tmp5_ = _tmp4_;
#line 380 "../src/baobab-window.vala"
				if (i < _tmp5_) {
#line 380 "../src/baobab-window.vala"
					_tmp2_ = i < G_MAXUINT;
#line 2140 "baobab-window.c"
				} else {
#line 380 "../src/baobab-window.vala"
					_tmp2_ = FALSE;
#line 2144 "baobab-window.c"
				}
#line 380 "../src/baobab-window.vala"
				if (!_tmp2_) {
#line 380 "../src/baobab-window.vala"
					break;
#line 2150 "baobab-window.c"
				}
#line 381 "../src/baobab-window.vala"
				if (passthrough) {
#line 2154 "baobab-window.c"
					GtkTreeListRow* row = NULL;
					GtkSingleSelection* _tmp6_;
					GObject* _tmp7_;
					GtkTreeListRow* _tmp8_;
					GtkTreeListRow* _tmp9_;
					GObject* _tmp10_;
					GObject* _tmp11_;
					GObject* _tmp12_;
					gboolean _tmp13_;
#line 383 "../src/baobab-window.vala"
					_tmp6_ = self->priv->columnview_selection;
#line 383 "../src/baobab-window.vala"
					_tmp7_ = g_list_model_get_item ((GListModel*) _tmp6_, i);
#line 383 "../src/baobab-window.vala"
					_tmp8_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, gtk_tree_list_row_get_type ()) ? ((GtkTreeListRow*) _tmp7_) : NULL;
#line 383 "../src/baobab-window.vala"
					if (_tmp8_ == NULL) {
#line 383 "../src/baobab-window.vala"
						_g_object_unref0 (_tmp7_);
#line 2174 "baobab-window.c"
					}
#line 383 "../src/baobab-window.vala"
					row = _tmp8_;
#line 384 "../src/baobab-window.vala"
					_tmp9_ = row;
#line 384 "../src/baobab-window.vala"
					_tmp10_ = gtk_tree_list_row_get_item (_tmp9_);
#line 384 "../src/baobab-window.vala"
					_tmp11_ = _tmp10_;
#line 384 "../src/baobab-window.vala"
					_tmp12_ = _tmp11_;
#line 384 "../src/baobab-window.vala"
					_tmp13_ = _tmp12_ == item;
#line 384 "../src/baobab-window.vala"
					_g_object_unref0 (_tmp12_);
#line 384 "../src/baobab-window.vala"
					if (_tmp13_) {
#line 385 "../src/baobab-window.vala"
						_vala_position = i;
#line 386 "../src/baobab-window.vala"
						result = TRUE;
#line 386 "../src/baobab-window.vala"
						_g_object_unref0 (row);
#line 386 "../src/baobab-window.vala"
						if (position) {
#line 386 "../src/baobab-window.vala"
							*position = _vala_position;
#line 2202 "baobab-window.c"
						}
#line 386 "../src/baobab-window.vala"
						return result;
#line 2206 "baobab-window.c"
					}
#line 381 "../src/baobab-window.vala"
					_g_object_unref0 (row);
#line 2210 "baobab-window.c"
				} else {
					GtkSingleSelection* _tmp14_;
					GObject* _tmp15_;
					GObject* _tmp16_;
					gboolean _tmp17_;
#line 390 "../src/baobab-window.vala"
					_tmp14_ = self->priv->columnview_selection;
#line 390 "../src/baobab-window.vala"
					_tmp15_ = g_list_model_get_item ((GListModel*) _tmp14_, i);
#line 390 "../src/baobab-window.vala"
					_tmp16_ = _tmp15_;
#line 390 "../src/baobab-window.vala"
					_tmp17_ = _tmp16_ == item;
#line 390 "../src/baobab-window.vala"
					_g_object_unref0 (_tmp16_);
#line 390 "../src/baobab-window.vala"
					if (_tmp17_) {
#line 391 "../src/baobab-window.vala"
						_vala_position = i;
#line 392 "../src/baobab-window.vala"
						result = TRUE;
#line 392 "../src/baobab-window.vala"
						if (position) {
#line 392 "../src/baobab-window.vala"
							*position = _vala_position;
#line 2236 "baobab-window.c"
						}
#line 392 "../src/baobab-window.vala"
						return result;
#line 2240 "baobab-window.c"
					}
				}
			}
		}
	}
#line 397 "../src/baobab-window.vala"
	result = FALSE;
#line 397 "../src/baobab-window.vala"
	if (position) {
#line 397 "../src/baobab-window.vala"
		*position = _vala_position;
#line 2252 "baobab-window.c"
	}
#line 397 "../src/baobab-window.vala"
	return result;
#line 2256 "baobab-window.c"
}

static BaobabScannerResults*
baobab_window_get_selected_item (BaobabWindow* self)
{
	GtkSingleSelection* _tmp0_;
	GObject* _tmp1_;
	GObject* _tmp2_;
	GtkTreeListRow* row = NULL;
	GtkSingleSelection* _tmp3_;
	GObject* _tmp4_;
	GObject* _tmp5_;
	GtkTreeListRow* _tmp6_;
	GtkTreeListRow* _tmp7_;
	GObject* _tmp8_;
	GObject* _tmp9_;
	BaobabScannerResults* _tmp10_;
	BaobabScannerResults* result;
#line 400 "../src/baobab-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 401 "../src/baobab-window.vala"
	_tmp0_ = self->priv->columnview_selection;
#line 401 "../src/baobab-window.vala"
	_tmp1_ = gtk_single_selection_get_selected_item (_tmp0_);
#line 401 "../src/baobab-window.vala"
	_tmp2_ = _tmp1_;
#line 401 "../src/baobab-window.vala"
	if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gtk_tree_list_row_get_type ())) {
#line 402 "../src/baobab-window.vala"
		result = NULL;
#line 402 "../src/baobab-window.vala"
		return result;
#line 2289 "baobab-window.c"
	}
#line 405 "../src/baobab-window.vala"
	_tmp3_ = self->priv->columnview_selection;
#line 405 "../src/baobab-window.vala"
	_tmp4_ = gtk_single_selection_get_selected_item (_tmp3_);
#line 405 "../src/baobab-window.vala"
	_tmp5_ = _tmp4_;
#line 405 "../src/baobab-window.vala"
	_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, gtk_tree_list_row_get_type ()) ? ((GtkTreeListRow*) _tmp5_) : NULL);
#line 405 "../src/baobab-window.vala"
	row = _tmp6_;
#line 406 "../src/baobab-window.vala"
	_tmp7_ = row;
#line 406 "../src/baobab-window.vala"
	_tmp8_ = gtk_tree_list_row_get_item (_tmp7_);
#line 406 "../src/baobab-window.vala"
	_tmp9_ = _tmp8_;
#line 406 "../src/baobab-window.vala"
	_tmp10_ = BAOBAB_SCANNER_IS_RESULTS (_tmp9_) ? ((BaobabScannerResults*) _tmp9_) : NULL;
#line 406 "../src/baobab-window.vala"
	if (_tmp10_ == NULL) {
#line 406 "../src/baobab-window.vala"
		_g_object_unref0 (_tmp9_);
#line 2313 "baobab-window.c"
	}
#line 406 "../src/baobab-window.vala"
	result = _tmp10_;
#line 406 "../src/baobab-window.vala"
	_g_object_unref0 (row);
#line 406 "../src/baobab-window.vala"
	return result;
#line 2321 "baobab-window.c"
}

static void
baobab_window_on_show_treeview_popover (BaobabWindow* self)
{
	GtkPopoverMenu* _tmp0_;
	GtkColumnView* _tmp1_;
	GtkColumnView* _tmp2_;
#line 409 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 410 "../src/baobab-window.vala"
	_tmp0_ = self->priv->treeview_popover_menu;
#line 410 "../src/baobab-window.vala"
	_tmp1_ = self->priv->columnview;
#line 410 "../src/baobab-window.vala"
	_tmp2_ = self->priv->columnview;
#line 410 "../src/baobab-window.vala"
	baobab_window_show_treeview_popover (self, _tmp0_, gtk_widget_get_allocated_width ((GtkWidget*) _tmp1_) / 2, gtk_widget_get_allocated_height ((GtkWidget*) _tmp2_) / 2);
#line 2340 "baobab-window.c"
}

static void
baobab_window_on_treeview_expand_row (BaobabWindow* self)
{
	GObject* selected_item = NULL;
	GtkSingleSelection* _tmp0_;
	GObject* _tmp1_;
	GObject* _tmp2_;
	GObject* _tmp3_;
	GObject* _tmp4_;
	GtkTreeListRow* selected_row = NULL;
	GObject* _tmp5_;
	GtkTreeListRow* _tmp6_;
	GtkTreeListRow* _tmp7_;
#line 415 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 416 "../src/baobab-window.vala"
	_tmp0_ = self->priv->columnview_selection;
#line 416 "../src/baobab-window.vala"
	_tmp1_ = gtk_single_selection_get_selected_item (_tmp0_);
#line 416 "../src/baobab-window.vala"
	_tmp2_ = _tmp1_;
#line 416 "../src/baobab-window.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 416 "../src/baobab-window.vala"
	selected_item = _tmp3_;
#line 417 "../src/baobab-window.vala"
	_tmp4_ = selected_item;
#line 417 "../src/baobab-window.vala"
	if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, gtk_tree_list_row_get_type ())) {
#line 418 "../src/baobab-window.vala"
		_g_object_unref0 (selected_item);
#line 418 "../src/baobab-window.vala"
		return;
#line 2376 "baobab-window.c"
	}
#line 421 "../src/baobab-window.vala"
	_tmp5_ = selected_item;
#line 421 "../src/baobab-window.vala"
	_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, gtk_tree_list_row_get_type ()) ? ((GtkTreeListRow*) _tmp5_) : NULL);
#line 421 "../src/baobab-window.vala"
	selected_row = _tmp6_;
#line 422 "../src/baobab-window.vala"
	_tmp7_ = selected_row;
#line 422 "../src/baobab-window.vala"
	gtk_tree_list_row_set_expanded (_tmp7_, TRUE);
#line 415 "../src/baobab-window.vala"
	_g_object_unref0 (selected_row);
#line 415 "../src/baobab-window.vala"
	_g_object_unref0 (selected_item);
#line 2392 "baobab-window.c"
}

static void
baobab_window_on_treeview_collapse_row (BaobabWindow* self)
{
	GObject* selected_item = NULL;
	GtkSingleSelection* _tmp0_;
	GObject* _tmp1_;
	GObject* _tmp2_;
	GObject* _tmp3_;
	GObject* _tmp4_;
	GtkTreeListRow* selected_row = NULL;
	GObject* _tmp5_;
	GtkTreeListRow* _tmp6_;
	GtkTreeListRow* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
#line 425 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 426 "../src/baobab-window.vala"
	_tmp0_ = self->priv->columnview_selection;
#line 426 "../src/baobab-window.vala"
	_tmp1_ = gtk_single_selection_get_selected_item (_tmp0_);
#line 426 "../src/baobab-window.vala"
	_tmp2_ = _tmp1_;
#line 426 "../src/baobab-window.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 426 "../src/baobab-window.vala"
	selected_item = _tmp3_;
#line 427 "../src/baobab-window.vala"
	_tmp4_ = selected_item;
#line 427 "../src/baobab-window.vala"
	if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, gtk_tree_list_row_get_type ())) {
#line 428 "../src/baobab-window.vala"
		_g_object_unref0 (selected_item);
#line 428 "../src/baobab-window.vala"
		return;
#line 2430 "baobab-window.c"
	}
#line 431 "../src/baobab-window.vala"
	_tmp5_ = selected_item;
#line 431 "../src/baobab-window.vala"
	_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, gtk_tree_list_row_get_type ()) ? ((GtkTreeListRow*) _tmp5_) : NULL);
#line 431 "../src/baobab-window.vala"
	selected_row = _tmp6_;
#line 432 "../src/baobab-window.vala"
	_tmp7_ = selected_row;
#line 432 "../src/baobab-window.vala"
	_tmp8_ = gtk_tree_list_row_get_expanded (_tmp7_);
#line 432 "../src/baobab-window.vala"
	_tmp9_ = _tmp8_;
#line 432 "../src/baobab-window.vala"
	if (_tmp9_) {
#line 2446 "baobab-window.c"
		GtkTreeListRow* _tmp10_;
#line 433 "../src/baobab-window.vala"
		_tmp10_ = selected_row;
#line 433 "../src/baobab-window.vala"
		gtk_tree_list_row_set_expanded (_tmp10_, FALSE);
#line 2452 "baobab-window.c"
	} else {
		GtkTreeListRow* _tmp11_;
		guint _tmp12_;
		guint _tmp13_;
#line 434 "../src/baobab-window.vala"
		_tmp11_ = selected_row;
#line 434 "../src/baobab-window.vala"
		_tmp12_ = gtk_tree_list_row_get_depth (_tmp11_);
#line 434 "../src/baobab-window.vala"
		_tmp13_ = _tmp12_;
#line 434 "../src/baobab-window.vala"
		if (_tmp13_ > ((guint) 0)) {
#line 2465 "baobab-window.c"
			guint position = 0U;
			GtkTreeListRow* _tmp14_;
			GtkTreeListRow* _tmp15_;
			GtkTreeListRow* _tmp16_;
			guint _tmp17_ = 0U;
			gboolean _tmp18_;
			gboolean _tmp19_;
#line 435 "../src/baobab-window.vala"
			position = (guint) 0;
#line 436 "../src/baobab-window.vala"
			_tmp14_ = selected_row;
#line 436 "../src/baobab-window.vala"
			_tmp15_ = gtk_tree_list_row_get_parent (_tmp14_);
#line 436 "../src/baobab-window.vala"
			_tmp16_ = _tmp15_;
#line 436 "../src/baobab-window.vala"
			_tmp18_ = baobab_window_columnview_selection_find (self, (GObject*) _tmp16_, FALSE, &_tmp17_);
#line 436 "../src/baobab-window.vala"
			position = _tmp17_;
#line 436 "../src/baobab-window.vala"
			_tmp19_ = _tmp18_;
#line 436 "../src/baobab-window.vala"
			_g_object_unref0 (_tmp16_);
#line 436 "../src/baobab-window.vala"
			if (_tmp19_) {
#line 2491 "baobab-window.c"
				GtkColumnView* _tmp20_;
#line 437 "../src/baobab-window.vala"
				_tmp20_ = self->priv->columnview;
#line 437 "../src/baobab-window.vala"
				gtk_column_view_scroll_to (_tmp20_, position, NULL, GTK_LIST_SCROLL_FOCUS | GTK_LIST_SCROLL_SELECT, NULL);
#line 2497 "baobab-window.c"
			}
		}
	}
#line 425 "../src/baobab-window.vala"
	_g_object_unref0 (selected_row);
#line 425 "../src/baobab-window.vala"
	_g_object_unref0 (selected_item);
#line 2505 "baobab-window.c"
}

static void
baobab_window_on_treeview_open_folder (BaobabWindow* self)
{
	BaobabScannerResults* item = NULL;
	BaobabScannerResults* _tmp0_;
	BaobabScannerResults* _tmp1_;
#line 445 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 446 "../src/baobab-window.vala"
	_tmp0_ = baobab_window_get_selected_item (self);
#line 446 "../src/baobab-window.vala"
	item = _tmp0_;
#line 447 "../src/baobab-window.vala"
	_tmp1_ = item;
#line 447 "../src/baobab-window.vala"
	if (_tmp1_ != NULL) {
#line 2524 "baobab-window.c"
		BaobabScannerResults* _tmp2_;
#line 448 "../src/baobab-window.vala"
		_tmp2_ = item;
#line 448 "../src/baobab-window.vala"
		baobab_window_open_item (self, _tmp2_);
#line 2530 "baobab-window.c"
	}
#line 445 "../src/baobab-window.vala"
	_g_object_unref0 (item);
#line 2534 "baobab-window.c"
}

static void
baobab_window_on_treeview_copy (BaobabWindow* self)
{
	BaobabScannerResults* item = NULL;
	BaobabScannerResults* _tmp0_;
	BaobabScannerResults* _tmp1_;
#line 451 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 452 "../src/baobab-window.vala"
	_tmp0_ = baobab_window_get_selected_item (self);
#line 452 "../src/baobab-window.vala"
	item = _tmp0_;
#line 453 "../src/baobab-window.vala"
	_tmp1_ = item;
#line 453 "../src/baobab-window.vala"
	if (_tmp1_ != NULL) {
#line 2553 "baobab-window.c"
		BaobabScannerResults* _tmp2_;
#line 454 "../src/baobab-window.vala"
		_tmp2_ = item;
#line 454 "../src/baobab-window.vala"
		baobab_window_copy_path (self, _tmp2_);
#line 2559 "baobab-window.c"
	}
#line 451 "../src/baobab-window.vala"
	_g_object_unref0 (item);
#line 2563 "baobab-window.c"
}

static void
baobab_window_on_treeview_trash (BaobabWindow* self)
{
	BaobabScannerResults* item = NULL;
	BaobabScannerResults* _tmp0_;
	BaobabScannerResults* _tmp1_;
#line 457 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 458 "../src/baobab-window.vala"
	_tmp0_ = baobab_window_get_selected_item (self);
#line 458 "../src/baobab-window.vala"
	item = _tmp0_;
#line 459 "../src/baobab-window.vala"
	_tmp1_ = item;
#line 459 "../src/baobab-window.vala"
	if (_tmp1_ != NULL) {
#line 2582 "baobab-window.c"
		BaobabScannerResults* _tmp2_;
#line 460 "../src/baobab-window.vala"
		_tmp2_ = item;
#line 460 "../src/baobab-window.vala"
		baobab_window_trash_file (self, _tmp2_);
#line 2588 "baobab-window.c"
	}
#line 457 "../src/baobab-window.vala"
	_g_object_unref0 (item);
#line 2592 "baobab-window.c"
}

static void
baobab_window_hide_columnview_header (BaobabWindow* self)
{
	GType row_type = 0UL;
#line 463 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 471 "../src/baobab-window.vala"
	row_type = g_type_from_name ("GtkColumnViewRowWidget");
#line 2603 "baobab-window.c"
	{
		GtkWidget* child = NULL;
		GtkColumnView* _tmp0_;
		GtkWidget* _tmp1_;
		GtkWidget* _tmp2_;
#line 472 "../src/baobab-window.vala"
		_tmp0_ = self->priv->columnview;
#line 472 "../src/baobab-window.vala"
		_tmp1_ = gtk_widget_get_first_child ((GtkWidget*) _tmp0_);
#line 472 "../src/baobab-window.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 472 "../src/baobab-window.vala"
		child = _tmp2_;
#line 2617 "baobab-window.c"
		{
			gboolean _tmp3_ = FALSE;
#line 472 "../src/baobab-window.vala"
			_tmp3_ = TRUE;
#line 472 "../src/baobab-window.vala"
			while (TRUE) {
#line 2624 "baobab-window.c"
				GtkWidget* _tmp7_;
				GtkWidget* _tmp8_;
				GtkWidget* _tmp9_;
#line 472 "../src/baobab-window.vala"
				if (!_tmp3_) {
#line 2630 "baobab-window.c"
					GtkWidget* _tmp4_;
					GtkWidget* _tmp5_;
					GtkWidget* _tmp6_;
#line 472 "../src/baobab-window.vala"
					_tmp4_ = child;
#line 472 "../src/baobab-window.vala"
					_tmp5_ = gtk_widget_get_next_sibling (_tmp4_);
#line 472 "../src/baobab-window.vala"
					_tmp6_ = _g_object_ref0 (_tmp5_);
#line 472 "../src/baobab-window.vala"
					_g_object_unref0 (child);
#line 472 "../src/baobab-window.vala"
					child = _tmp6_;
#line 2644 "baobab-window.c"
				}
#line 472 "../src/baobab-window.vala"
				_tmp3_ = FALSE;
#line 472 "../src/baobab-window.vala"
				_tmp7_ = child;
#line 472 "../src/baobab-window.vala"
				if (!(_tmp7_ != NULL)) {
#line 472 "../src/baobab-window.vala"
					break;
#line 2654 "baobab-window.c"
				}
#line 473 "../src/baobab-window.vala"
				_tmp8_ = child;
#line 473 "../src/baobab-window.vala"
				if (G_TYPE_FROM_INSTANCE ((GObject*) _tmp8_) != row_type) {
#line 474 "../src/baobab-window.vala"
					continue;
#line 2662 "baobab-window.c"
				}
#line 477 "../src/baobab-window.vala"
				_tmp9_ = child;
#line 477 "../src/baobab-window.vala"
				gtk_widget_set_visible (_tmp9_, FALSE);
#line 2668 "baobab-window.c"
			}
		}
#line 472 "../src/baobab-window.vala"
		_g_object_unref0 (child);
#line 2673 "baobab-window.c"
	}
}

static void
baobab_window_treeview_right_click_gesture_pressed (BaobabWindow* self,
                                                    gint n_press,
                                                    gdouble x,
                                                    gdouble y)
{
	GtkWidget* child = NULL;
	GtkColumnView* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* row = NULL;
	GtkWidget* _tmp3_;
	GtkWidget* _tmp4_;
	GtkWidget* _tmp5_;
	GtkWidget* _tmp6_;
	GtkPopoverMenu* _tmp29_;
#line 482 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 483 "../src/baobab-window.vala"
	_tmp0_ = self->priv->columnview;
#line 483 "../src/baobab-window.vala"
	_tmp1_ = gtk_widget_pick ((GtkWidget*) _tmp0_, x, y, GTK_PICK_INSENSITIVE | GTK_PICK_NON_TARGETABLE);
#line 483 "../src/baobab-window.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 483 "../src/baobab-window.vala"
	child = _tmp2_;
#line 484 "../src/baobab-window.vala"
	_tmp3_ = child;
#line 484 "../src/baobab-window.vala"
	_tmp4_ = gtk_widget_get_ancestor (_tmp3_, g_type_from_name ("GtkColumnViewRowWidget"));
#line 484 "../src/baobab-window.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 484 "../src/baobab-window.vala"
	row = _tmp5_;
#line 486 "../src/baobab-window.vala"
	_tmp6_ = row;
#line 486 "../src/baobab-window.vala"
	if (_tmp6_ == NULL) {
#line 487 "../src/baobab-window.vala"
		_g_object_unref0 (row);
#line 487 "../src/baobab-window.vala"
		_g_object_unref0 (child);
#line 487 "../src/baobab-window.vala"
		return;
#line 2721 "baobab-window.c"
	}
	{
		GtkWidget* cell = NULL;
		GtkWidget* _tmp7_;
		GtkWidget* _tmp8_;
		GtkWidget* _tmp9_;
#line 490 "../src/baobab-window.vala"
		_tmp7_ = row;
#line 490 "../src/baobab-window.vala"
		_tmp8_ = gtk_widget_get_first_child (_tmp7_);
#line 490 "../src/baobab-window.vala"
		_tmp9_ = _g_object_ref0 (_tmp8_);
#line 490 "../src/baobab-window.vala"
		cell = _tmp9_;
#line 2736 "baobab-window.c"
		{
			gboolean _tmp10_ = FALSE;
#line 490 "../src/baobab-window.vala"
			_tmp10_ = TRUE;
#line 490 "../src/baobab-window.vala"
			while (TRUE) {
#line 2743 "baobab-window.c"
				GtkWidget* _tmp14_;
				GtkWidget* cell_content = NULL;
				GtkWidget* _tmp15_;
				GtkWidget* _tmp16_;
				GtkWidget* _tmp17_;
				gboolean _tmp18_ = FALSE;
				GtkWidget* _tmp19_;
				BaobabFileCell* file_cell = NULL;
				GtkWidget* _tmp21_;
				BaobabFileCell* _tmp22_;
				guint position = 0U;
				BaobabFileCell* _tmp23_;
				BaobabScannerResults* _tmp24_;
				BaobabScannerResults* _tmp25_;
				guint _tmp26_ = 0U;
				gboolean _tmp27_;
#line 490 "../src/baobab-window.vala"
				if (!_tmp10_) {
#line 2762 "baobab-window.c"
					GtkWidget* _tmp11_;
					GtkWidget* _tmp12_;
					GtkWidget* _tmp13_;
#line 490 "../src/baobab-window.vala"
					_tmp11_ = cell;
#line 490 "../src/baobab-window.vala"
					_tmp12_ = gtk_widget_get_next_sibling (_tmp11_);
#line 490 "../src/baobab-window.vala"
					_tmp13_ = _g_object_ref0 (_tmp12_);
#line 490 "../src/baobab-window.vala"
					_g_object_unref0 (cell);
#line 490 "../src/baobab-window.vala"
					cell = _tmp13_;
#line 2776 "baobab-window.c"
				}
#line 490 "../src/baobab-window.vala"
				_tmp10_ = FALSE;
#line 490 "../src/baobab-window.vala"
				_tmp14_ = cell;
#line 490 "../src/baobab-window.vala"
				if (!(_tmp14_ != NULL)) {
#line 490 "../src/baobab-window.vala"
					break;
#line 2786 "baobab-window.c"
				}
#line 491 "../src/baobab-window.vala"
				_tmp15_ = cell;
#line 491 "../src/baobab-window.vala"
				_tmp16_ = gtk_widget_get_first_child (_tmp15_);
#line 491 "../src/baobab-window.vala"
				_tmp17_ = _g_object_ref0 (_tmp16_);
#line 491 "../src/baobab-window.vala"
				cell_content = _tmp17_;
#line 493 "../src/baobab-window.vala"
				_tmp19_ = cell_content;
#line 493 "../src/baobab-window.vala"
				if (_tmp19_ == NULL) {
#line 493 "../src/baobab-window.vala"
					_tmp18_ = TRUE;
#line 2802 "baobab-window.c"
				} else {
					GtkWidget* _tmp20_;
#line 494 "../src/baobab-window.vala"
					_tmp20_ = cell_content;
#line 494 "../src/baobab-window.vala"
					_tmp18_ = G_TYPE_FROM_INSTANCE ((GObject*) _tmp20_) != BAOBAB_TYPE_FILE_CELL;
#line 2809 "baobab-window.c"
				}
#line 493 "../src/baobab-window.vala"
				if (_tmp18_) {
#line 495 "../src/baobab-window.vala"
					_g_object_unref0 (cell_content);
#line 495 "../src/baobab-window.vala"
					continue;
#line 2817 "baobab-window.c"
				}
#line 498 "../src/baobab-window.vala"
				_tmp21_ = cell_content;
#line 498 "../src/baobab-window.vala"
				_tmp22_ = _g_object_ref0 (BAOBAB_IS_FILE_CELL (_tmp21_) ? ((BaobabFileCell*) _tmp21_) : NULL);
#line 498 "../src/baobab-window.vala"
				file_cell = _tmp22_;
#line 499 "../src/baobab-window.vala"
				position = (guint) 0;
#line 501 "../src/baobab-window.vala"
				_tmp23_ = file_cell;
#line 501 "../src/baobab-window.vala"
				_tmp24_ = baobab_file_cell_get_item (_tmp23_);
#line 501 "../src/baobab-window.vala"
				_tmp25_ = _tmp24_;
#line 501 "../src/baobab-window.vala"
				_tmp27_ = baobab_window_columnview_selection_find (self, (GObject*) _tmp25_, TRUE, &_tmp26_);
#line 501 "../src/baobab-window.vala"
				position = _tmp26_;
#line 501 "../src/baobab-window.vala"
				if (_tmp27_) {
#line 2839 "baobab-window.c"
					GtkColumnView* _tmp28_;
#line 502 "../src/baobab-window.vala"
					_tmp28_ = self->priv->columnview;
#line 502 "../src/baobab-window.vala"
					gtk_column_view_scroll_to (_tmp28_, position, NULL, GTK_LIST_SCROLL_FOCUS | GTK_LIST_SCROLL_SELECT, NULL);
#line 2845 "baobab-window.c"
				}
#line 507 "../src/baobab-window.vala"
				_g_object_unref0 (file_cell);
#line 507 "../src/baobab-window.vala"
				_g_object_unref0 (cell_content);
#line 507 "../src/baobab-window.vala"
				break;
#line 2853 "baobab-window.c"
			}
		}
#line 490 "../src/baobab-window.vala"
		_g_object_unref0 (cell);
#line 2858 "baobab-window.c"
	}
#line 510 "../src/baobab-window.vala"
	_tmp29_ = self->priv->treeview_popover_menu;
#line 510 "../src/baobab-window.vala"
	baobab_window_show_treeview_popover (self, _tmp29_, (gint) x, (gint) y);
#line 482 "../src/baobab-window.vala"
	_g_object_unref0 (row);
#line 482 "../src/baobab-window.vala"
	_g_object_unref0 (child);
#line 2868 "baobab-window.c"
}

static void
_baobab_window_treeview_right_click_gesture_pressed_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                               gint n_press,
                                                                               gdouble x,
                                                                               gdouble y,
                                                                               gpointer self)
{
#line 26 "../src/baobab-window.vala"
	baobab_window_treeview_right_click_gesture_pressed ((BaobabWindow*) self, n_press, x, y);
#line 2880 "baobab-window.c"
}

static void
baobab_window_columnview_activate (BaobabWindow* self,
                                   guint position)
{
	GtkTreeListRow* row = NULL;
	GtkColumnView* _tmp0_;
	GtkSelectionModel* _tmp1_;
	GtkSelectionModel* _tmp2_;
	GObject* _tmp3_;
	GtkTreeListRow* _tmp4_;
	BaobabScannerResults* path = NULL;
	GObject* _tmp5_;
	GObject* _tmp6_;
	BaobabScannerResults* _tmp7_;
#line 514 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 515 "../src/baobab-window.vala"
	_tmp0_ = self->priv->columnview;
#line 515 "../src/baobab-window.vala"
	_tmp1_ = gtk_column_view_get_model (_tmp0_);
#line 515 "../src/baobab-window.vala"
	_tmp2_ = _tmp1_;
#line 515 "../src/baobab-window.vala"
	_tmp3_ = g_list_model_get_object ((GListModel*) _tmp2_, position);
#line 515 "../src/baobab-window.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, gtk_tree_list_row_get_type ()) ? ((GtkTreeListRow*) _tmp3_) : NULL;
#line 515 "../src/baobab-window.vala"
	if (_tmp4_ == NULL) {
#line 515 "../src/baobab-window.vala"
		_g_object_unref0 (_tmp3_);
#line 2913 "baobab-window.c"
	}
#line 515 "../src/baobab-window.vala"
	row = _tmp4_;
#line 516 "../src/baobab-window.vala"
	_tmp5_ = gtk_tree_list_row_get_item (row);
#line 516 "../src/baobab-window.vala"
	_tmp6_ = _tmp5_;
#line 516 "../src/baobab-window.vala"
	_tmp7_ = BAOBAB_SCANNER_IS_RESULTS (_tmp6_) ? ((BaobabScannerResults*) _tmp6_) : NULL;
#line 516 "../src/baobab-window.vala"
	if (_tmp7_ == NULL) {
#line 516 "../src/baobab-window.vala"
		_g_object_unref0 (_tmp6_);
#line 2927 "baobab-window.c"
	}
#line 516 "../src/baobab-window.vala"
	path = _tmp7_;
#line 517 "../src/baobab-window.vala"
	baobab_window_reroot_treeview (self, path, TRUE);
#line 514 "../src/baobab-window.vala"
	_g_object_unref0 (path);
#line 514 "../src/baobab-window.vala"
	_g_object_unref0 (row);
#line 2937 "baobab-window.c"
}

static void
_baobab_window_columnview_activate_gtk_column_view_activate (GtkColumnView* _sender,
                                                             guint position,
                                                             gpointer self)
{
#line 26 "../src/baobab-window.vala"
	baobab_window_columnview_activate ((BaobabWindow*) self, position);
#line 2947 "baobab-window.c"
}

static void
baobab_window_reroot_treeview (BaobabWindow* self,
                               BaobabScannerResults* path,
                               gboolean select_first)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	BaobabFolderDisplay* _tmp2_;
	BaobabChart* _tmp3_;
	BaobabChart* _tmp4_;
	BaobabPathbar* _tmp5_;
	GtkSortListModel* _tmp6_;
	GtkTreeListModel* _tmp7_;
	GtkTreeListModel* _tmp8_;
#line 520 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 520 "../src/baobab-window.vala"
	g_return_if_fail (path != NULL);
#line 521 "../src/baobab-window.vala"
	_tmp0_ = baobab_scanner_results_get_is_empty (path);
#line 521 "../src/baobab-window.vala"
	_tmp1_ = _tmp0_;
#line 521 "../src/baobab-window.vala"
	if (_tmp1_) {
#line 522 "../src/baobab-window.vala"
		return;
#line 2976 "baobab-window.c"
	}
#line 525 "../src/baobab-window.vala"
	_tmp2_ = self->priv->folder_display;
#line 525 "../src/baobab-window.vala"
	baobab_folder_display_set_path (_tmp2_, path);
#line 526 "../src/baobab-window.vala"
	_tmp3_ = self->priv->rings_chart;
#line 526 "../src/baobab-window.vala"
	baobab_chart_set_tree_root (_tmp3_, path);
#line 527 "../src/baobab-window.vala"
	_tmp4_ = self->priv->treemap_chart;
#line 527 "../src/baobab-window.vala"
	baobab_chart_set_tree_root (_tmp4_, path);
#line 528 "../src/baobab-window.vala"
	_tmp5_ = self->priv->pathbar;
#line 528 "../src/baobab-window.vala"
	baobab_pathbar_set_path (_tmp5_, path);
#line 530 "../src/baobab-window.vala"
	_tmp6_ = self->priv->columnview_sort_model;
#line 530 "../src/baobab-window.vala"
	_tmp7_ = baobab_scanner_results_create_tree_model (path);
#line 530 "../src/baobab-window.vala"
	_tmp8_ = _tmp7_;
#line 530 "../src/baobab-window.vala"
	gtk_sort_list_model_set_model (_tmp6_, (GListModel*) _tmp8_);
#line 530 "../src/baobab-window.vala"
	_g_object_unref0 (_tmp8_);
#line 532 "../src/baobab-window.vala"
	if (select_first) {
#line 3006 "baobab-window.c"
		GtkSingleSelection* _tmp9_;
#line 533 "../src/baobab-window.vala"
		_tmp9_ = self->priv->columnview_selection;
#line 533 "../src/baobab-window.vala"
		gtk_single_selection_set_selected (_tmp9_, (guint) 0);
#line 3012 "baobab-window.c"
	}
}

static void
baobab_window_toast (BaobabWindow* self,
                     const gchar* title)
{
	AdwToast* toast = NULL;
	AdwToast* _tmp0_;
	AdwToastOverlay* _tmp1_;
	AdwToast* _tmp2_;
#line 537 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 537 "../src/baobab-window.vala"
	g_return_if_fail (title != NULL);
#line 538 "../src/baobab-window.vala"
	_tmp0_ = adw_toast_new (title);
#line 538 "../src/baobab-window.vala"
	toast = _tmp0_;
#line 539 "../src/baobab-window.vala"
	_tmp1_ = self->priv->toast_overlay;
#line 539 "../src/baobab-window.vala"
	_tmp2_ = _g_object_ref0 (toast);
#line 539 "../src/baobab-window.vala"
	adw_toast_overlay_add_toast (_tmp1_, _tmp2_);
#line 537 "../src/baobab-window.vala"
	_g_object_unref0 (toast);
#line 3040 "baobab-window.c"
}

static void
baobab_window_set_busy (BaobabWindow* self,
                        gboolean busy)
{
	GdkCursor* new_cursor = NULL;
	GdkCursor* _tmp10_;
#line 542 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 543 "../src/baobab-window.vala"
	new_cursor = NULL;
#line 544 "../src/baobab-window.vala"
	self->priv->is_busy = busy;
#line 546 "../src/baobab-window.vala"
	if (busy) {
#line 3057 "baobab-window.c"
		GdkCursor* _tmp0_;
		GdkCursor* _tmp1_;
		AdwViewSwitcher* _tmp2_;
		GtkStack* _tmp3_;
		AdwSpinner* _tmp4_;
		BaobabPathbar* _tmp5_;
#line 547 "../src/baobab-window.vala"
		_tmp0_ = baobab_window_busy_cursor;
#line 547 "../src/baobab-window.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 547 "../src/baobab-window.vala"
		_g_object_unref0 (new_cursor);
#line 547 "../src/baobab-window.vala"
		new_cursor = _tmp1_;
#line 548 "../src/baobab-window.vala"
		_tmp2_ = self->priv->chart_stack_switcher;
#line 548 "../src/baobab-window.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, FALSE);
#line 549 "../src/baobab-window.vala"
		_tmp3_ = self->priv->spinner_stack;
#line 549 "../src/baobab-window.vala"
		_tmp4_ = self->priv->spinner;
#line 549 "../src/baobab-window.vala"
		gtk_stack_set_visible_child (_tmp3_, (GtkWidget*) _tmp4_);
#line 550 "../src/baobab-window.vala"
		_tmp5_ = self->priv->pathbar;
#line 550 "../src/baobab-window.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, FALSE);
#line 3086 "baobab-window.c"
	} else {
		GtkStack* _tmp6_;
		AdwViewStack* _tmp7_;
		AdwViewSwitcher* _tmp8_;
		BaobabPathbar* _tmp9_;
#line 552 "../src/baobab-window.vala"
		_tmp6_ = self->priv->spinner_stack;
#line 552 "../src/baobab-window.vala"
		_tmp7_ = self->priv->chart_stack;
#line 552 "../src/baobab-window.vala"
		gtk_stack_set_visible_child (_tmp6_, (GtkWidget*) _tmp7_);
#line 553 "../src/baobab-window.vala"
		_tmp8_ = self->priv->chart_stack_switcher;
#line 553 "../src/baobab-window.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, TRUE);
#line 554 "../src/baobab-window.vala"
		_tmp9_ = self->priv->pathbar;
#line 554 "../src/baobab-window.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp9_, TRUE);
#line 3106 "baobab-window.c"
	}
#line 557 "../src/baobab-window.vala"
	_tmp10_ = new_cursor;
#line 557 "../src/baobab-window.vala"
	gtk_widget_set_cursor ((GtkWidget*) self, _tmp10_);
#line 3112 "baobab-window.c"
	{
		BaobabWindowActionState* action_state_collection = NULL;
		gint action_state_collection_length1 = 0;
		gint _action_state_collection_size_ = 0;
		gint action_state_it = 0;
#line 559 "../src/baobab-window.vala"
		action_state_collection = BAOBAB_WINDOW_actions_while_scanning;
#line 559 "../src/baobab-window.vala"
		action_state_collection_length1 = G_N_ELEMENTS (BAOBAB_WINDOW_actions_while_scanning);
#line 559 "../src/baobab-window.vala"
		for (action_state_it = 0; action_state_it < action_state_collection_length1; action_state_it = action_state_it + 1) {
#line 3124 "baobab-window.c"
			BaobabWindowActionState _tmp11_;
			BaobabWindowActionState _tmp12_ = {0};
			BaobabWindowActionState action_state = {0};
#line 559 "../src/baobab-window.vala"
			_tmp11_ = action_state_collection[action_state_it];
#line 559 "../src/baobab-window.vala"
			baobab_window_action_state_copy (&_tmp11_, &_tmp12_);
#line 559 "../src/baobab-window.vala"
			action_state = _tmp12_;
#line 3134 "baobab-window.c"
			{
				GSimpleAction* action = NULL;
				BaobabWindowActionState _tmp13_;
				const gchar* _tmp14_;
				GAction* _tmp15_;
				GSimpleAction* _tmp16_;
				GSimpleAction* _tmp17_;
				BaobabWindowActionState _tmp18_;
#line 560 "../src/baobab-window.vala"
				_tmp13_ = action_state;
#line 560 "../src/baobab-window.vala"
				_tmp14_ = _tmp13_.name;
#line 560 "../src/baobab-window.vala"
				_tmp15_ = g_action_map_lookup_action ((GActionMap*) self, _tmp14_);
#line 560 "../src/baobab-window.vala"
				_tmp16_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp15_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp15_) : NULL);
#line 560 "../src/baobab-window.vala"
				action = _tmp16_;
#line 561 "../src/baobab-window.vala"
				_tmp17_ = action;
#line 561 "../src/baobab-window.vala"
				_tmp18_ = action_state;
#line 561 "../src/baobab-window.vala"
				g_simple_action_set_enabled (_tmp17_, busy == _tmp18_.enable);
#line 559 "../src/baobab-window.vala"
				_g_object_unref0 (action);
#line 559 "../src/baobab-window.vala"
				baobab_window_action_state_destroy (&action_state);
#line 3163 "baobab-window.c"
			}
		}
	}
#line 542 "../src/baobab-window.vala"
	_g_object_unref0 (new_cursor);
#line 3169 "baobab-window.c"
}

static void
baobab_window_set_ui_state (BaobabWindow* self,
                            GtkWidget* child,
                            gboolean busy)
{
	GtkWidget* _tmp0_;
#line 565 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 565 "../src/baobab-window.vala"
	g_return_if_fail (child != NULL);
#line 566 "../src/baobab-window.vala"
	baobab_window_set_busy (self, busy);
#line 568 "../src/baobab-window.vala"
	_tmp0_ = self->priv->home_page;
#line 568 "../src/baobab-window.vala"
	if (child == _tmp0_) {
#line 3188 "baobab-window.c"
		GSimpleAction* action = NULL;
		GAction* _tmp1_;
		GSimpleAction* _tmp2_;
		GSimpleAction* _tmp3_;
		AdwNavigationView* _tmp4_;
#line 569 "../src/baobab-window.vala"
		_tmp1_ = g_action_map_lookup_action ((GActionMap*) self, "reload");
#line 569 "../src/baobab-window.vala"
		_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp1_) : NULL);
#line 569 "../src/baobab-window.vala"
		action = _tmp2_;
#line 570 "../src/baobab-window.vala"
		_tmp3_ = action;
#line 570 "../src/baobab-window.vala"
		g_simple_action_set_enabled (_tmp3_, FALSE);
#line 571 "../src/baobab-window.vala"
		gtk_window_set_title ((GtkWindow*) self, _ ("Devices & Locations"));
#line 572 "../src/baobab-window.vala"
		_tmp4_ = self->priv->nav_view;
#line 572 "../src/baobab-window.vala"
		adw_navigation_view_pop (_tmp4_);
#line 568 "../src/baobab-window.vala"
		_g_object_unref0 (action);
#line 3212 "baobab-window.c"
	} else {
		GSimpleAction* action = NULL;
		GAction* _tmp5_;
		GSimpleAction* _tmp6_;
		GSimpleAction* _tmp7_;
		BaobabLocation* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		AdwNavigationView* _tmp11_;
		AdwNavigationPage* _tmp12_;
		AdwNavigationPage* _tmp13_;
		GtkWidget* _tmp14_;
#line 574 "../src/baobab-window.vala"
		_tmp5_ = g_action_map_lookup_action ((GActionMap*) self, "reload");
#line 574 "../src/baobab-window.vala"
		_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp5_) : NULL);
#line 574 "../src/baobab-window.vala"
		action = _tmp6_;
#line 575 "../src/baobab-window.vala"
		_tmp7_ = action;
#line 575 "../src/baobab-window.vala"
		g_simple_action_set_enabled (_tmp7_, TRUE);
#line 576 "../src/baobab-window.vala"
		_tmp8_ = self->priv->active_location;
#line 576 "../src/baobab-window.vala"
		_tmp9_ = baobab_location_get_name (_tmp8_);
#line 576 "../src/baobab-window.vala"
		_tmp10_ = _tmp9_;
#line 576 "../src/baobab-window.vala"
		gtk_window_set_title ((GtkWindow*) self, _tmp10_);
#line 577 "../src/baobab-window.vala"
		_tmp11_ = self->priv->nav_view;
#line 577 "../src/baobab-window.vala"
		_tmp12_ = adw_navigation_view_get_visible_page (_tmp11_);
#line 577 "../src/baobab-window.vala"
		_tmp13_ = _tmp12_;
#line 577 "../src/baobab-window.vala"
		_tmp14_ = self->priv->result_page;
#line 577 "../src/baobab-window.vala"
		if (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, gtk_widget_get_type (), GtkWidget) != _tmp14_) {
#line 3253 "baobab-window.c"
			AdwNavigationView* _tmp15_;
#line 578 "../src/baobab-window.vala"
			_tmp15_ = self->priv->nav_view;
#line 578 "../src/baobab-window.vala"
			adw_navigation_view_push_by_tag (_tmp15_, "results");
#line 3259 "baobab-window.c"
		}
#line 568 "../src/baobab-window.vala"
		_g_object_unref0 (action);
#line 3263 "baobab-window.c"
	}
}

static void
baobab_window_set_chart_location (BaobabWindow* self,
                                  BaobabLocation* location)
{
	BaobabChart* _tmp0_;
	BaobabChart* _tmp1_;
#line 598 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 598 "../src/baobab-window.vala"
	g_return_if_fail (location != NULL);
#line 599 "../src/baobab-window.vala"
	_tmp0_ = self->priv->rings_chart;
#line 599 "../src/baobab-window.vala"
	baobab_chart_set_location (_tmp0_, location);
#line 600 "../src/baobab-window.vala"
	_tmp1_ = self->priv->treemap_chart;
#line 600 "../src/baobab-window.vala"
	baobab_chart_set_location (_tmp1_, location);
#line 3285 "baobab-window.c"
}

static void
baobab_window_scanner_completed (BaobabWindow* self)
{
	BaobabScanner* scanner = NULL;
	BaobabLocation* _tmp0_;
	BaobabScanner* _tmp1_;
	BaobabScanner* _tmp2_;
	BaobabScanner* _tmp3_;
	BaobabScanner* _tmp14_;
	BaobabScannerResults* _tmp15_;
	BaobabScannerResults* _tmp16_;
	BaobabLocation* _tmp17_;
	GtkWidget* _tmp18_;
	BaobabFolderDisplay* _tmp19_;
	BaobabScanner* _tmp20_;
	BaobabScannerResults* _tmp21_;
	BaobabScannerResults* _tmp22_;
	AdwBanner* _tmp23_;
	BaobabScanner* _tmp24_;
	gboolean _tmp25_;
	gboolean _tmp26_;
	gboolean _tmp27_;
	gboolean _tmp28_;
	GError* _inner_error0_ = NULL;
#line 603 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 604 "../src/baobab-window.vala"
	_tmp0_ = self->priv->active_location;
#line 604 "../src/baobab-window.vala"
	_tmp1_ = baobab_location_get_scanner (_tmp0_);
#line 604 "../src/baobab-window.vala"
	_tmp2_ = _tmp1_;
#line 604 "../src/baobab-window.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 604 "../src/baobab-window.vala"
	scanner = _tmp3_;
#line 606 "../src/baobab-window.vala"
	if (self->priv->scan_completed_handler > ((gulong) 0)) {
#line 3326 "baobab-window.c"
		BaobabScanner* _tmp4_;
#line 607 "../src/baobab-window.vala"
		_tmp4_ = scanner;
#line 607 "../src/baobab-window.vala"
		g_signal_handler_disconnect ((GObject*) _tmp4_, self->priv->scan_completed_handler);
#line 608 "../src/baobab-window.vala"
		self->priv->scan_completed_handler = (gulong) 0;
#line 3334 "baobab-window.c"
	}
#line 611 "../src/baobab-window.vala"
	if (self->priv->scanning_progress_id > ((guint) 0)) {
#line 612 "../src/baobab-window.vala"
		g_source_remove (self->priv->scanning_progress_id);
#line 613 "../src/baobab-window.vala"
		self->priv->scanning_progress_id = (guint) 0;
#line 3342 "baobab-window.c"
	}
	{
		BaobabScanner* _tmp5_;
#line 617 "../src/baobab-window.vala"
		_tmp5_ = scanner;
#line 617 "../src/baobab-window.vala"
		baobab_scanner_finish (_tmp5_, &_inner_error0_);
#line 617 "../src/baobab-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 617 "../src/baobab-window.vala"
			if (g_error_matches (_inner_error0_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 3354 "baobab-window.c"
				goto __catch0_g_io_error_cancelled;
			}
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_io_error_cancelled:
	{
#line 616 "../src/baobab-window.vala"
		g_clear_error (&_inner_error0_);
#line 620 "../src/baobab-window.vala"
		_g_object_unref0 (scanner);
#line 620 "../src/baobab-window.vala"
		return;
#line 3369 "baobab-window.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		BaobabScanner* _tmp6_;
		GFile* _tmp7_;
		GFile* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		GError* _tmp11_;
		const gchar* _tmp12_;
		GtkWidget* _tmp13_;
#line 616 "../src/baobab-window.vala"
		e = _inner_error0_;
#line 616 "../src/baobab-window.vala"
		_inner_error0_ = NULL;
#line 622 "../src/baobab-window.vala"
		_tmp6_ = scanner;
#line 622 "../src/baobab-window.vala"
		_tmp7_ = baobab_scanner_get_directory (_tmp6_);
#line 622 "../src/baobab-window.vala"
		_tmp8_ = _tmp7_;
#line 622 "../src/baobab-window.vala"
		_tmp9_ = g_file_get_parse_name (_tmp8_);
#line 622 "../src/baobab-window.vala"
		_tmp10_ = _tmp9_;
#line 622 "../src/baobab-window.vala"
		_tmp11_ = e;
#line 622 "../src/baobab-window.vala"
		_tmp12_ = _tmp11_->message;
#line 622 "../src/baobab-window.vala"
		g_warning ("baobab-window.vala:622: Could not scan folder %s: %s", _tmp10_, _tmp12_);
#line 622 "../src/baobab-window.vala"
		_g_free0 (_tmp10_);
#line 623 "../src/baobab-window.vala"
		baobab_window_toast (self, _ ("Could not scan folder"));
#line 624 "../src/baobab-window.vala"
		_tmp13_ = self->priv->home_page;
#line 624 "../src/baobab-window.vala"
		baobab_window_set_ui_state (self, _tmp13_, FALSE);
#line 625 "../src/baobab-window.vala"
		_g_error_free0 (e);
#line 625 "../src/baobab-window.vala"
		_g_object_unref0 (scanner);
#line 625 "../src/baobab-window.vala"
		return;
#line 3417 "baobab-window.c"
	}
	__finally0:
#line 616 "../src/baobab-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 616 "../src/baobab-window.vala"
		_g_object_unref0 (scanner);
#line 616 "../src/baobab-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 616 "../src/baobab-window.vala"
		g_clear_error (&_inner_error0_);
#line 616 "../src/baobab-window.vala"
		return;
#line 3430 "baobab-window.c"
	}
#line 628 "../src/baobab-window.vala"
	_tmp14_ = scanner;
#line 628 "../src/baobab-window.vala"
	_tmp15_ = baobab_scanner_get_root (_tmp14_);
#line 628 "../src/baobab-window.vala"
	_tmp16_ = _tmp15_;
#line 628 "../src/baobab-window.vala"
	baobab_window_reroot_treeview (self, _tmp16_, FALSE);
#line 629 "../src/baobab-window.vala"
	_tmp17_ = self->priv->active_location;
#line 629 "../src/baobab-window.vala"
	baobab_window_set_chart_location (self, _tmp17_);
#line 630 "../src/baobab-window.vala"
	_tmp18_ = self->priv->result_page;
#line 630 "../src/baobab-window.vala"
	baobab_window_set_ui_state (self, _tmp18_, FALSE);
#line 633 "../src/baobab-window.vala"
	_tmp19_ = self->priv->folder_display;
#line 633 "../src/baobab-window.vala"
	_tmp20_ = scanner;
#line 633 "../src/baobab-window.vala"
	_tmp21_ = baobab_scanner_get_root (_tmp20_);
#line 633 "../src/baobab-window.vala"
	_tmp22_ = _tmp21_;
#line 633 "../src/baobab-window.vala"
	baobab_folder_display_set_path (_tmp19_, _tmp22_);
#line 635 "../src/baobab-window.vala"
	_tmp23_ = self->priv->banner;
#line 635 "../src/baobab-window.vala"
	_tmp24_ = scanner;
#line 635 "../src/baobab-window.vala"
	_tmp25_ = baobab_scanner_get_show_allocated_size (_tmp24_);
#line 635 "../src/baobab-window.vala"
	_tmp26_ = _tmp25_;
#line 635 "../src/baobab-window.vala"
	adw_banner_set_revealed (_tmp23_, !_tmp26_);
#line 637 "../src/baobab-window.vala"
	g_object_get ((GtkWindow*) self, "is-active", &_tmp27_, NULL);
#line 637 "../src/baobab-window.vala"
	_tmp28_ = _tmp27_;
#line 637 "../src/baobab-window.vala"
	if (!_tmp28_) {
#line 3474 "baobab-window.c"
		GNotification* notification = NULL;
		GNotification* _tmp29_;
		GNotification* _tmp30_;
		BaobabScanner* _tmp31_;
		GFile* _tmp32_;
		GFile* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		GtkApplication* _tmp38_;
		GNotification* _tmp39_;
#line 638 "../src/baobab-window.vala"
		_tmp29_ = g_notification_new (_ ("Scan completed"));
#line 638 "../src/baobab-window.vala"
		notification = _tmp29_;
#line 639 "../src/baobab-window.vala"
		_tmp30_ = notification;
#line 639 "../src/baobab-window.vala"
		_tmp31_ = scanner;
#line 639 "../src/baobab-window.vala"
		_tmp32_ = baobab_scanner_get_directory (_tmp31_);
#line 639 "../src/baobab-window.vala"
		_tmp33_ = _tmp32_;
#line 639 "../src/baobab-window.vala"
		_tmp34_ = g_file_get_parse_name (_tmp33_);
#line 639 "../src/baobab-window.vala"
		_tmp35_ = _tmp34_;
#line 639 "../src/baobab-window.vala"
		_tmp36_ = g_strdup_printf (_ ("Completed scan of “%s”"), _tmp35_);
#line 639 "../src/baobab-window.vala"
		_tmp37_ = _tmp36_;
#line 639 "../src/baobab-window.vala"
		g_notification_set_body (_tmp30_, _tmp37_);
#line 639 "../src/baobab-window.vala"
		_g_free0 (_tmp37_);
#line 639 "../src/baobab-window.vala"
		_g_free0 (_tmp35_);
#line 640 "../src/baobab-window.vala"
		_tmp38_ = gtk_window_get_application ((GtkWindow*) self);
#line 640 "../src/baobab-window.vala"
		_tmp39_ = notification;
#line 640 "../src/baobab-window.vala"
		g_application_send_notification ((GApplication*) _tmp38_, "scan-completed", _tmp39_);
#line 637 "../src/baobab-window.vala"
		_g_object_unref0 (notification);
#line 3521 "baobab-window.c"
	}
#line 603 "../src/baobab-window.vala"
	_g_object_unref0 (scanner);
#line 3525 "baobab-window.c"
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 644 "../src/baobab-window.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 644 "../src/baobab-window.vala"
	return _data9_;
#line 3535 "baobab-window.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 644 "../src/baobab-window.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 3545 "baobab-window.c"
		BaobabWindow* self;
#line 644 "../src/baobab-window.vala"
		self = _data9_->self;
#line 644 "../src/baobab-window.vala"
		_baobab_location_unref0 (_data9_->location);
#line 644 "../src/baobab-window.vala"
		_g_object_unref0 (self);
#line 644 "../src/baobab-window.vala"
		g_slice_free (Block9Data, _data9_);
#line 3555 "baobab-window.c"
	}
}

static void
_baobab_window_scanner_completed_baobab_scanner_completed (BaobabScanner* _sender,
                                                           gpointer self)
{
#line 658 "../src/baobab-window.vala"
	baobab_window_scanner_completed ((BaobabWindow*) self);
#line 3565 "baobab-window.c"
}

static gboolean
__lambda19_ (Block9Data* _data9_)
{
	BaobabWindow* self;
	gboolean result;
#line 662 "../src/baobab-window.vala"
	self = _data9_->self;
#line 663 "../src/baobab-window.vala"
	g_signal_emit_by_name (_data9_->location, "progress");
#line 664 "../src/baobab-window.vala"
	result = G_SOURCE_CONTINUE;
#line 664 "../src/baobab-window.vala"
	return result;
#line 3581 "baobab-window.c"
}

static gboolean
___lambda19__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda19_ (self);
#line 662 "../src/baobab-window.vala"
	return result;
#line 3591 "baobab-window.c"
}

static void
baobab_window_scan_location (BaobabWindow* self,
                             BaobabLocation* location,
                             gboolean force)
{
	Block9Data* _data9_;
	BaobabLocation* _tmp0_;
	BaobabLocation* _tmp1_;
	BaobabPathbar* _tmp2_;
	BaobabFolderDisplay* _tmp3_;
	BaobabLocationList* _tmp4_;
	GtkSortListModel* _tmp5_;
	BaobabScanner* scanner = NULL;
	BaobabScanner* _tmp6_;
	BaobabScanner* _tmp7_;
	BaobabScanner* _tmp8_;
	gulong _tmp9_;
	AdwBanner* _tmp10_;
	GtkWidget* _tmp11_;
#line 644 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 644 "../src/baobab-window.vala"
	g_return_if_fail (location != NULL);
#line 644 "../src/baobab-window.vala"
	_data9_ = g_slice_new0 (Block9Data);
#line 644 "../src/baobab-window.vala"
	_data9_->_ref_count_ = 1;
#line 644 "../src/baobab-window.vala"
	_data9_->self = g_object_ref (self);
#line 644 "../src/baobab-window.vala"
	_tmp0_ = _baobab_location_ref0 (location);
#line 644 "../src/baobab-window.vala"
	_baobab_location_unref0 (_data9_->location);
#line 644 "../src/baobab-window.vala"
	_data9_->location = _tmp0_;
#line 645 "../src/baobab-window.vala"
	baobab_window_cancel_scan (self);
#line 647 "../src/baobab-window.vala"
	_tmp1_ = _baobab_location_ref0 (_data9_->location);
#line 647 "../src/baobab-window.vala"
	_baobab_location_unref0 (self->priv->active_location);
#line 647 "../src/baobab-window.vala"
	self->priv->active_location = _tmp1_;
#line 649 "../src/baobab-window.vala"
	_tmp2_ = self->priv->pathbar;
#line 649 "../src/baobab-window.vala"
	baobab_pathbar_set_location (_tmp2_, _data9_->location);
#line 650 "../src/baobab-window.vala"
	_tmp3_ = self->priv->folder_display;
#line 650 "../src/baobab-window.vala"
	baobab_folder_display_set_location (_tmp3_, _data9_->location);
#line 653 "../src/baobab-window.vala"
	_tmp4_ = self->priv->location_list;
#line 653 "../src/baobab-window.vala"
	baobab_location_list_add_location (_tmp4_, _data9_->location);
#line 655 "../src/baobab-window.vala"
	_tmp5_ = self->priv->columnview_sort_model;
#line 655 "../src/baobab-window.vala"
	gtk_sort_list_model_set_model (_tmp5_, NULL);
#line 657 "../src/baobab-window.vala"
	_tmp6_ = baobab_location_get_scanner (_data9_->location);
#line 657 "../src/baobab-window.vala"
	_tmp7_ = _tmp6_;
#line 657 "../src/baobab-window.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 657 "../src/baobab-window.vala"
	scanner = _tmp8_;
#line 658 "../src/baobab-window.vala"
	_tmp9_ = g_signal_connect_object (scanner, "completed", (GCallback) _baobab_window_scanner_completed_baobab_scanner_completed, self, 0);
#line 658 "../src/baobab-window.vala"
	self->priv->scan_completed_handler = _tmp9_;
#line 660 "../src/baobab-window.vala"
	_tmp10_ = self->priv->banner;
#line 660 "../src/baobab-window.vala"
	adw_banner_set_revealed (_tmp10_, FALSE);
#line 662 "../src/baobab-window.vala"
	self->priv->scanning_progress_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, ___lambda19__gsource_func, block9_data_ref (_data9_), block9_data_unref);
#line 667 "../src/baobab-window.vala"
	_tmp11_ = self->priv->result_page;
#line 667 "../src/baobab-window.vala"
	baobab_window_set_ui_state (self, _tmp11_, TRUE);
#line 668 "../src/baobab-window.vala"
	baobab_scanner_scan (scanner, force);
#line 644 "../src/baobab-window.vala"
	_g_object_unref0 (scanner);
#line 644 "../src/baobab-window.vala"
	block9_data_unref (_data9_);
#line 644 "../src/baobab-window.vala"
	_data9_ = NULL;
#line 3683 "baobab-window.c"
}

void
baobab_window_scan_directory (BaobabWindow* self,
                              GFile* directory,
                              BaobabScanFlags flags)
{
	GFileInfo* info = NULL;
	gboolean _tmp3_ = FALSE;
	GFileInfo* _tmp4_;
	BaobabLocation* location = NULL;
	BaobabLocation* _tmp10_;
	BaobabLocation* _tmp11_;
	GError* _inner_error0_ = NULL;
#line 671 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 671 "../src/baobab-window.vala"
	g_return_if_fail (directory != NULL);
#line 672 "../src/baobab-window.vala"
	info = NULL;
#line 3704 "baobab-window.c"
	{
		GFileInfo* _tmp0_ = NULL;
		GFileInfo* _tmp1_;
		GFileInfo* _tmp2_;
#line 674 "../src/baobab-window.vala"
		_tmp1_ = g_file_query_info (directory, G_FILE_ATTRIBUTE_STANDARD_TYPE, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 674 "../src/baobab-window.vala"
		_tmp0_ = _tmp1_;
#line 674 "../src/baobab-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3715 "baobab-window.c"
			goto __catch0_g_error;
		}
#line 674 "../src/baobab-window.vala"
		_tmp2_ = _tmp0_;
#line 674 "../src/baobab-window.vala"
		_tmp0_ = NULL;
#line 674 "../src/baobab-window.vala"
		_g_object_unref0 (info);
#line 674 "../src/baobab-window.vala"
		info = _tmp2_;
#line 673 "../src/baobab-window.vala"
		_g_object_unref0 (_tmp0_);
#line 3728 "baobab-window.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 673 "../src/baobab-window.vala"
		g_clear_error (&_inner_error0_);
#line 3735 "baobab-window.c"
	}
	__finally0:
#line 673 "../src/baobab-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 673 "../src/baobab-window.vala"
		_g_object_unref0 (info);
#line 673 "../src/baobab-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 673 "../src/baobab-window.vala"
		g_clear_error (&_inner_error0_);
#line 673 "../src/baobab-window.vala"
		return;
#line 3748 "baobab-window.c"
	}
#line 678 "../src/baobab-window.vala"
	_tmp4_ = info;
#line 678 "../src/baobab-window.vala"
	if (_tmp4_ == NULL) {
#line 678 "../src/baobab-window.vala"
		_tmp3_ = TRUE;
#line 3756 "baobab-window.c"
	} else {
		GFileInfo* _tmp5_;
#line 678 "../src/baobab-window.vala"
		_tmp5_ = info;
#line 678 "../src/baobab-window.vala"
		_tmp3_ = g_file_info_get_file_type (_tmp5_) != G_FILE_TYPE_DIRECTORY;
#line 3763 "baobab-window.c"
	}
#line 678 "../src/baobab-window.vala"
	if (_tmp3_) {
#line 3767 "baobab-window.c"
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 679 "../src/baobab-window.vala"
		_tmp6_ = g_file_get_parse_name (directory);
#line 679 "../src/baobab-window.vala"
		_tmp7_ = _tmp6_;
#line 679 "../src/baobab-window.vala"
		_tmp8_ = g_strdup_printf (_ ("“%s” is not a valid folder"), _tmp7_);
#line 679 "../src/baobab-window.vala"
		_tmp9_ = _tmp8_;
#line 679 "../src/baobab-window.vala"
		baobab_window_toast (self, _tmp9_);
#line 679 "../src/baobab-window.vala"
		_g_free0 (_tmp9_);
#line 679 "../src/baobab-window.vala"
		_g_free0 (_tmp7_);
#line 680 "../src/baobab-window.vala"
		_g_object_unref0 (info);
#line 680 "../src/baobab-window.vala"
		return;
#line 3790 "baobab-window.c"
	}
#line 683 "../src/baobab-window.vala"
	_tmp10_ = baobab_location_new_for_file (directory, flags);
#line 683 "../src/baobab-window.vala"
	location = _tmp10_;
#line 684 "../src/baobab-window.vala"
	_tmp11_ = location;
#line 684 "../src/baobab-window.vala"
	baobab_window_scan_location (self, _tmp11_, FALSE);
#line 671 "../src/baobab-window.vala"
	_baobab_location_unref0 (location);
#line 671 "../src/baobab-window.vala"
	_g_object_unref0 (info);
#line 3804 "baobab-window.c"
}

static void
baobab_window_folder_cell_setup (BaobabWindow* self,
                                 GObject* object)
{
	GtkColumnViewCell* item = NULL;
	GtkColumnViewCell* _tmp0_;
	BaobabFileCell* child = NULL;
	BaobabFileCell* _tmp1_;
	BaobabFolderDisplay* _tmp2_;
	GtkSizeGroup* _tmp3_;
	GtkSizeGroup* _tmp4_;
	GtkWidget* _tmp5_;
	GtkWidget* _tmp6_;
#line 688 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 688 "../src/baobab-window.vala"
	g_return_if_fail (object != NULL);
#line 689 "../src/baobab-window.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (object, gtk_column_view_cell_get_type ()) ? ((GtkColumnViewCell*) object) : NULL);
#line 689 "../src/baobab-window.vala"
	item = _tmp0_;
#line 690 "../src/baobab-window.vala"
	_tmp1_ = baobab_file_cell_new ();
#line 690 "../src/baobab-window.vala"
	g_object_ref_sink (_tmp1_);
#line 690 "../src/baobab-window.vala"
	child = _tmp1_;
#line 691 "../src/baobab-window.vala"
	gtk_column_view_cell_set_child (item, (GtkWidget*) child);
#line 692 "../src/baobab-window.vala"
	_tmp2_ = self->priv->folder_display;
#line 692 "../src/baobab-window.vala"
	_tmp3_ = baobab_folder_display_get_folder_size_group (_tmp2_);
#line 692 "../src/baobab-window.vala"
	_tmp4_ = _tmp3_;
#line 692 "../src/baobab-window.vala"
	_tmp5_ = gtk_column_view_cell_get_child (item);
#line 692 "../src/baobab-window.vala"
	_tmp6_ = _tmp5_;
#line 692 "../src/baobab-window.vala"
	gtk_size_group_add_widget (_tmp4_, _tmp6_);
#line 688 "../src/baobab-window.vala"
	_g_object_unref0 (child);
#line 688 "../src/baobab-window.vala"
	_g_object_unref0 (item);
#line 3852 "baobab-window.c"
}

static void
_baobab_window_folder_cell_setup_gtk_signal_list_item_factory_setup (GtkSignalListItemFactory* _sender,
                                                                     GObject* object,
                                                                     gpointer self)
{
#line 26 "../src/baobab-window.vala"
	baobab_window_folder_cell_setup ((BaobabWindow*) self, object);
#line 3862 "baobab-window.c"
}

static void
baobab_window_folder_cell_bind (BaobabWindow* self,
                                GObject* object)
{
	GtkColumnViewCell* item = NULL;
	GtkColumnViewCell* _tmp0_;
	GtkTreeListRow* row = NULL;
	GObject* _tmp1_;
	GObject* _tmp2_;
	GtkTreeListRow* _tmp3_;
	BaobabScannerResults* results = NULL;
	GObject* _tmp4_;
	GObject* _tmp5_;
	BaobabScannerResults* _tmp6_;
	BaobabFileCell* child = NULL;
	GtkWidget* _tmp7_;
	GtkWidget* _tmp8_;
	BaobabFileCell* _tmp9_;
#line 696 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 696 "../src/baobab-window.vala"
	g_return_if_fail (object != NULL);
#line 697 "../src/baobab-window.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (object, gtk_column_view_cell_get_type ()) ? ((GtkColumnViewCell*) object) : NULL);
#line 697 "../src/baobab-window.vala"
	item = _tmp0_;
#line 698 "../src/baobab-window.vala"
	_tmp1_ = gtk_column_view_cell_get_item (item);
#line 698 "../src/baobab-window.vala"
	_tmp2_ = _tmp1_;
#line 698 "../src/baobab-window.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gtk_tree_list_row_get_type ()) ? ((GtkTreeListRow*) _tmp2_) : NULL);
#line 698 "../src/baobab-window.vala"
	row = _tmp3_;
#line 699 "../src/baobab-window.vala"
	_tmp4_ = gtk_tree_list_row_get_item (row);
#line 699 "../src/baobab-window.vala"
	_tmp5_ = _tmp4_;
#line 699 "../src/baobab-window.vala"
	_tmp6_ = BAOBAB_SCANNER_IS_RESULTS (_tmp5_) ? ((BaobabScannerResults*) _tmp5_) : NULL;
#line 699 "../src/baobab-window.vala"
	if (_tmp6_ == NULL) {
#line 699 "../src/baobab-window.vala"
		_g_object_unref0 (_tmp5_);
#line 3909 "baobab-window.c"
	}
#line 699 "../src/baobab-window.vala"
	results = _tmp6_;
#line 700 "../src/baobab-window.vala"
	_tmp7_ = gtk_column_view_cell_get_child (item);
#line 700 "../src/baobab-window.vala"
	_tmp8_ = _tmp7_;
#line 700 "../src/baobab-window.vala"
	_tmp9_ = _g_object_ref0 (BAOBAB_IS_FILE_CELL (_tmp8_) ? ((BaobabFileCell*) _tmp8_) : NULL);
#line 700 "../src/baobab-window.vala"
	child = _tmp9_;
#line 701 "../src/baobab-window.vala"
	baobab_file_cell_set_item (child, results);
#line 702 "../src/baobab-window.vala"
	baobab_file_cell_set_list_row (child, row);
#line 696 "../src/baobab-window.vala"
	_g_object_unref0 (child);
#line 696 "../src/baobab-window.vala"
	_g_object_unref0 (results);
#line 696 "../src/baobab-window.vala"
	_g_object_unref0 (row);
#line 696 "../src/baobab-window.vala"
	_g_object_unref0 (item);
#line 3933 "baobab-window.c"
}

static void
_baobab_window_folder_cell_bind_gtk_signal_list_item_factory_bind (GtkSignalListItemFactory* _sender,
                                                                   GObject* object,
                                                                   gpointer self)
{
#line 26 "../src/baobab-window.vala"
	baobab_window_folder_cell_bind ((BaobabWindow*) self, object);
#line 3943 "baobab-window.c"
}

static void
baobab_window_folder_cell_unbind (BaobabWindow* self,
                                  GObject* object)
{
	GtkColumnViewCell* item = NULL;
	GtkColumnViewCell* _tmp0_;
	BaobabFileCell* child = NULL;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	BaobabFileCell* _tmp3_;
#line 706 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 706 "../src/baobab-window.vala"
	g_return_if_fail (object != NULL);
#line 707 "../src/baobab-window.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (object, gtk_column_view_cell_get_type ()) ? ((GtkColumnViewCell*) object) : NULL);
#line 707 "../src/baobab-window.vala"
	item = _tmp0_;
#line 708 "../src/baobab-window.vala"
	_tmp1_ = gtk_column_view_cell_get_child (item);
#line 708 "../src/baobab-window.vala"
	_tmp2_ = _tmp1_;
#line 708 "../src/baobab-window.vala"
	_tmp3_ = _g_object_ref0 (BAOBAB_IS_FILE_CELL (_tmp2_) ? ((BaobabFileCell*) _tmp2_) : NULL);
#line 708 "../src/baobab-window.vala"
	child = _tmp3_;
#line 709 "../src/baobab-window.vala"
	baobab_file_cell_set_item (child, NULL);
#line 706 "../src/baobab-window.vala"
	_g_object_unref0 (child);
#line 706 "../src/baobab-window.vala"
	_g_object_unref0 (item);
#line 3978 "baobab-window.c"
}

static void
_baobab_window_folder_cell_unbind_gtk_signal_list_item_factory_unbind (GtkSignalListItemFactory* _sender,
                                                                       GObject* object,
                                                                       gpointer self)
{
#line 26 "../src/baobab-window.vala"
	baobab_window_folder_cell_unbind ((BaobabWindow*) self, object);
#line 3988 "baobab-window.c"
}

static void
baobab_window_folder_cell_teardown (BaobabWindow* self,
                                    GObject* object)
{
	GtkColumnViewCell* item = NULL;
	GtkColumnViewCell* _tmp0_;
	BaobabFolderDisplay* _tmp1_;
	GtkSizeGroup* _tmp2_;
	GtkSizeGroup* _tmp3_;
	GtkWidget* _tmp4_;
	GtkWidget* _tmp5_;
#line 713 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 713 "../src/baobab-window.vala"
	g_return_if_fail (object != NULL);
#line 714 "../src/baobab-window.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (object, gtk_column_view_cell_get_type ()) ? ((GtkColumnViewCell*) object) : NULL);
#line 714 "../src/baobab-window.vala"
	item = _tmp0_;
#line 715 "../src/baobab-window.vala"
	_tmp1_ = self->priv->folder_display;
#line 715 "../src/baobab-window.vala"
	_tmp2_ = baobab_folder_display_get_folder_size_group (_tmp1_);
#line 715 "../src/baobab-window.vala"
	_tmp3_ = _tmp2_;
#line 715 "../src/baobab-window.vala"
	_tmp4_ = gtk_column_view_cell_get_child (item);
#line 715 "../src/baobab-window.vala"
	_tmp5_ = _tmp4_;
#line 715 "../src/baobab-window.vala"
	gtk_size_group_remove_widget (_tmp3_, _tmp5_);
#line 713 "../src/baobab-window.vala"
	_g_object_unref0 (item);
#line 4024 "baobab-window.c"
}

static void
_baobab_window_folder_cell_teardown_gtk_signal_list_item_factory_teardown (GtkSignalListItemFactory* _sender,
                                                                           GObject* object,
                                                                           gpointer self)
{
#line 26 "../src/baobab-window.vala"
	baobab_window_folder_cell_teardown ((BaobabWindow*) self, object);
#line 4034 "baobab-window.c"
}

static void
baobab_window_size_cell_setup (BaobabWindow* self,
                               GObject* object)
{
	GtkColumnViewCell* item = NULL;
	GtkColumnViewCell* _tmp0_;
	BaobabSizeCell* child = NULL;
	BaobabSizeCell* _tmp1_;
	BaobabFolderDisplay* _tmp2_;
	GtkSizeGroup* _tmp3_;
	GtkSizeGroup* _tmp4_;
	GtkWidget* _tmp5_;
	GtkWidget* _tmp6_;
#line 719 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 719 "../src/baobab-window.vala"
	g_return_if_fail (object != NULL);
#line 720 "../src/baobab-window.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (object, gtk_column_view_cell_get_type ()) ? ((GtkColumnViewCell*) object) : NULL);
#line 720 "../src/baobab-window.vala"
	item = _tmp0_;
#line 721 "../src/baobab-window.vala"
	_tmp1_ = baobab_size_cell_new ();
#line 721 "../src/baobab-window.vala"
	g_object_ref_sink (_tmp1_);
#line 721 "../src/baobab-window.vala"
	child = _tmp1_;
#line 722 "../src/baobab-window.vala"
	gtk_column_view_cell_set_child (item, (GtkWidget*) child);
#line 723 "../src/baobab-window.vala"
	_tmp2_ = self->priv->folder_display;
#line 723 "../src/baobab-window.vala"
	_tmp3_ = baobab_folder_display_get_size_size_group (_tmp2_);
#line 723 "../src/baobab-window.vala"
	_tmp4_ = _tmp3_;
#line 723 "../src/baobab-window.vala"
	_tmp5_ = gtk_column_view_cell_get_child (item);
#line 723 "../src/baobab-window.vala"
	_tmp6_ = _tmp5_;
#line 723 "../src/baobab-window.vala"
	gtk_size_group_add_widget (_tmp4_, _tmp6_);
#line 719 "../src/baobab-window.vala"
	_g_object_unref0 (child);
#line 719 "../src/baobab-window.vala"
	_g_object_unref0 (item);
#line 4082 "baobab-window.c"
}

static void
_baobab_window_size_cell_setup_gtk_signal_list_item_factory_setup (GtkSignalListItemFactory* _sender,
                                                                   GObject* object,
                                                                   gpointer self)
{
#line 26 "../src/baobab-window.vala"
	baobab_window_size_cell_setup ((BaobabWindow*) self, object);
#line 4092 "baobab-window.c"
}

static void
baobab_window_size_cell_bind (BaobabWindow* self,
                              GObject* object)
{
	GtkColumnViewCell* item = NULL;
	GtkColumnViewCell* _tmp0_;
	GtkTreeListRow* row = NULL;
	GObject* _tmp1_;
	GObject* _tmp2_;
	GtkTreeListRow* _tmp3_;
	BaobabScannerResults* results = NULL;
	GObject* _tmp4_;
	GObject* _tmp5_;
	BaobabScannerResults* _tmp6_;
	BaobabSizeCell* child = NULL;
	GtkWidget* _tmp7_;
	GtkWidget* _tmp8_;
	BaobabSizeCell* _tmp9_;
#line 727 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 727 "../src/baobab-window.vala"
	g_return_if_fail (object != NULL);
#line 728 "../src/baobab-window.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (object, gtk_column_view_cell_get_type ()) ? ((GtkColumnViewCell*) object) : NULL);
#line 728 "../src/baobab-window.vala"
	item = _tmp0_;
#line 729 "../src/baobab-window.vala"
	_tmp1_ = gtk_column_view_cell_get_item (item);
#line 729 "../src/baobab-window.vala"
	_tmp2_ = _tmp1_;
#line 729 "../src/baobab-window.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gtk_tree_list_row_get_type ()) ? ((GtkTreeListRow*) _tmp2_) : NULL);
#line 729 "../src/baobab-window.vala"
	row = _tmp3_;
#line 730 "../src/baobab-window.vala"
	_tmp4_ = gtk_tree_list_row_get_item (row);
#line 730 "../src/baobab-window.vala"
	_tmp5_ = _tmp4_;
#line 730 "../src/baobab-window.vala"
	_tmp6_ = BAOBAB_SCANNER_IS_RESULTS (_tmp5_) ? ((BaobabScannerResults*) _tmp5_) : NULL;
#line 730 "../src/baobab-window.vala"
	if (_tmp6_ == NULL) {
#line 730 "../src/baobab-window.vala"
		_g_object_unref0 (_tmp5_);
#line 4139 "baobab-window.c"
	}
#line 730 "../src/baobab-window.vala"
	results = _tmp6_;
#line 731 "../src/baobab-window.vala"
	_tmp7_ = gtk_column_view_cell_get_child (item);
#line 731 "../src/baobab-window.vala"
	_tmp8_ = _tmp7_;
#line 731 "../src/baobab-window.vala"
	_tmp9_ = _g_object_ref0 (BAOBAB_IS_SIZE_CELL (_tmp8_) ? ((BaobabSizeCell*) _tmp8_) : NULL);
#line 731 "../src/baobab-window.vala"
	child = _tmp9_;
#line 732 "../src/baobab-window.vala"
	baobab_size_cell_set_item (child, results);
#line 727 "../src/baobab-window.vala"
	_g_object_unref0 (child);
#line 727 "../src/baobab-window.vala"
	_g_object_unref0 (results);
#line 727 "../src/baobab-window.vala"
	_g_object_unref0 (row);
#line 727 "../src/baobab-window.vala"
	_g_object_unref0 (item);
#line 4161 "baobab-window.c"
}

static void
_baobab_window_size_cell_bind_gtk_signal_list_item_factory_bind (GtkSignalListItemFactory* _sender,
                                                                 GObject* object,
                                                                 gpointer self)
{
#line 26 "../src/baobab-window.vala"
	baobab_window_size_cell_bind ((BaobabWindow*) self, object);
#line 4171 "baobab-window.c"
}

static void
baobab_window_size_cell_unbind (BaobabWindow* self,
                                GObject* object)
{
	GtkColumnViewCell* item = NULL;
	GtkColumnViewCell* _tmp0_;
	BaobabSizeCell* child = NULL;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	BaobabSizeCell* _tmp3_;
#line 736 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 736 "../src/baobab-window.vala"
	g_return_if_fail (object != NULL);
#line 737 "../src/baobab-window.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (object, gtk_column_view_cell_get_type ()) ? ((GtkColumnViewCell*) object) : NULL);
#line 737 "../src/baobab-window.vala"
	item = _tmp0_;
#line 738 "../src/baobab-window.vala"
	_tmp1_ = gtk_column_view_cell_get_child (item);
#line 738 "../src/baobab-window.vala"
	_tmp2_ = _tmp1_;
#line 738 "../src/baobab-window.vala"
	_tmp3_ = _g_object_ref0 (BAOBAB_IS_SIZE_CELL (_tmp2_) ? ((BaobabSizeCell*) _tmp2_) : NULL);
#line 738 "../src/baobab-window.vala"
	child = _tmp3_;
#line 739 "../src/baobab-window.vala"
	baobab_size_cell_set_item (child, NULL);
#line 736 "../src/baobab-window.vala"
	_g_object_unref0 (child);
#line 736 "../src/baobab-window.vala"
	_g_object_unref0 (item);
#line 4206 "baobab-window.c"
}

static void
_baobab_window_size_cell_unbind_gtk_signal_list_item_factory_unbind (GtkSignalListItemFactory* _sender,
                                                                     GObject* object,
                                                                     gpointer self)
{
#line 26 "../src/baobab-window.vala"
	baobab_window_size_cell_unbind ((BaobabWindow*) self, object);
#line 4216 "baobab-window.c"
}

static void
baobab_window_size_cell_teardown (BaobabWindow* self,
                                  GObject* object)
{
	GtkColumnViewCell* item = NULL;
	GtkColumnViewCell* _tmp0_;
	BaobabFolderDisplay* _tmp1_;
	GtkSizeGroup* _tmp2_;
	GtkSizeGroup* _tmp3_;
	GtkWidget* _tmp4_;
	GtkWidget* _tmp5_;
#line 743 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 743 "../src/baobab-window.vala"
	g_return_if_fail (object != NULL);
#line 744 "../src/baobab-window.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (object, gtk_column_view_cell_get_type ()) ? ((GtkColumnViewCell*) object) : NULL);
#line 744 "../src/baobab-window.vala"
	item = _tmp0_;
#line 745 "../src/baobab-window.vala"
	_tmp1_ = self->priv->folder_display;
#line 745 "../src/baobab-window.vala"
	_tmp2_ = baobab_folder_display_get_size_size_group (_tmp1_);
#line 745 "../src/baobab-window.vala"
	_tmp3_ = _tmp2_;
#line 745 "../src/baobab-window.vala"
	_tmp4_ = gtk_column_view_cell_get_child (item);
#line 745 "../src/baobab-window.vala"
	_tmp5_ = _tmp4_;
#line 745 "../src/baobab-window.vala"
	gtk_size_group_remove_widget (_tmp3_, _tmp5_);
#line 743 "../src/baobab-window.vala"
	_g_object_unref0 (item);
#line 4252 "baobab-window.c"
}

static void
_baobab_window_size_cell_teardown_gtk_signal_list_item_factory_teardown (GtkSignalListItemFactory* _sender,
                                                                         GObject* object,
                                                                         gpointer self)
{
#line 26 "../src/baobab-window.vala"
	baobab_window_size_cell_teardown ((BaobabWindow*) self, object);
#line 4262 "baobab-window.c"
}

static void
baobab_window_contents_cell_setup (BaobabWindow* self,
                                   GObject* object)
{
	GtkColumnViewCell* item = NULL;
	GtkColumnViewCell* _tmp0_;
	BaobabContentsCell* child = NULL;
	BaobabContentsCell* _tmp1_;
	BaobabFolderDisplay* _tmp2_;
	GtkSizeGroup* _tmp3_;
	GtkSizeGroup* _tmp4_;
	GtkWidget* _tmp5_;
	GtkWidget* _tmp6_;
#line 749 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 749 "../src/baobab-window.vala"
	g_return_if_fail (object != NULL);
#line 750 "../src/baobab-window.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (object, gtk_column_view_cell_get_type ()) ? ((GtkColumnViewCell*) object) : NULL);
#line 750 "../src/baobab-window.vala"
	item = _tmp0_;
#line 751 "../src/baobab-window.vala"
	_tmp1_ = baobab_contents_cell_new ();
#line 751 "../src/baobab-window.vala"
	g_object_ref_sink (_tmp1_);
#line 751 "../src/baobab-window.vala"
	child = _tmp1_;
#line 752 "../src/baobab-window.vala"
	gtk_column_view_cell_set_child (item, (GtkWidget*) child);
#line 753 "../src/baobab-window.vala"
	_tmp2_ = self->priv->folder_display;
#line 753 "../src/baobab-window.vala"
	_tmp3_ = baobab_folder_display_get_contents_size_group (_tmp2_);
#line 753 "../src/baobab-window.vala"
	_tmp4_ = _tmp3_;
#line 753 "../src/baobab-window.vala"
	_tmp5_ = gtk_column_view_cell_get_child (item);
#line 753 "../src/baobab-window.vala"
	_tmp6_ = _tmp5_;
#line 753 "../src/baobab-window.vala"
	gtk_size_group_add_widget (_tmp4_, _tmp6_);
#line 749 "../src/baobab-window.vala"
	_g_object_unref0 (child);
#line 749 "../src/baobab-window.vala"
	_g_object_unref0 (item);
#line 4310 "baobab-window.c"
}

static void
_baobab_window_contents_cell_setup_gtk_signal_list_item_factory_setup (GtkSignalListItemFactory* _sender,
                                                                       GObject* object,
                                                                       gpointer self)
{
#line 26 "../src/baobab-window.vala"
	baobab_window_contents_cell_setup ((BaobabWindow*) self, object);
#line 4320 "baobab-window.c"
}

static void
baobab_window_contents_cell_bind (BaobabWindow* self,
                                  GObject* object)
{
	GtkColumnViewCell* item = NULL;
	GtkColumnViewCell* _tmp0_;
	GtkTreeListRow* row = NULL;
	GObject* _tmp1_;
	GObject* _tmp2_;
	GtkTreeListRow* _tmp3_;
	BaobabScannerResults* results = NULL;
	GObject* _tmp4_;
	GObject* _tmp5_;
	BaobabScannerResults* _tmp6_;
	BaobabContentsCell* child = NULL;
	GtkWidget* _tmp7_;
	GtkWidget* _tmp8_;
	BaobabContentsCell* _tmp9_;
#line 757 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 757 "../src/baobab-window.vala"
	g_return_if_fail (object != NULL);
#line 758 "../src/baobab-window.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (object, gtk_column_view_cell_get_type ()) ? ((GtkColumnViewCell*) object) : NULL);
#line 758 "../src/baobab-window.vala"
	item = _tmp0_;
#line 759 "../src/baobab-window.vala"
	_tmp1_ = gtk_column_view_cell_get_item (item);
#line 759 "../src/baobab-window.vala"
	_tmp2_ = _tmp1_;
#line 759 "../src/baobab-window.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gtk_tree_list_row_get_type ()) ? ((GtkTreeListRow*) _tmp2_) : NULL);
#line 759 "../src/baobab-window.vala"
	row = _tmp3_;
#line 760 "../src/baobab-window.vala"
	_tmp4_ = gtk_tree_list_row_get_item (row);
#line 760 "../src/baobab-window.vala"
	_tmp5_ = _tmp4_;
#line 760 "../src/baobab-window.vala"
	_tmp6_ = BAOBAB_SCANNER_IS_RESULTS (_tmp5_) ? ((BaobabScannerResults*) _tmp5_) : NULL;
#line 760 "../src/baobab-window.vala"
	if (_tmp6_ == NULL) {
#line 760 "../src/baobab-window.vala"
		_g_object_unref0 (_tmp5_);
#line 4367 "baobab-window.c"
	}
#line 760 "../src/baobab-window.vala"
	results = _tmp6_;
#line 761 "../src/baobab-window.vala"
	_tmp7_ = gtk_column_view_cell_get_child (item);
#line 761 "../src/baobab-window.vala"
	_tmp8_ = _tmp7_;
#line 761 "../src/baobab-window.vala"
	_tmp9_ = _g_object_ref0 (BAOBAB_IS_CONTENTS_CELL (_tmp8_) ? ((BaobabContentsCell*) _tmp8_) : NULL);
#line 761 "../src/baobab-window.vala"
	child = _tmp9_;
#line 762 "../src/baobab-window.vala"
	baobab_contents_cell_set_item (child, results);
#line 757 "../src/baobab-window.vala"
	_g_object_unref0 (child);
#line 757 "../src/baobab-window.vala"
	_g_object_unref0 (results);
#line 757 "../src/baobab-window.vala"
	_g_object_unref0 (row);
#line 757 "../src/baobab-window.vala"
	_g_object_unref0 (item);
#line 4389 "baobab-window.c"
}

static void
_baobab_window_contents_cell_bind_gtk_signal_list_item_factory_bind (GtkSignalListItemFactory* _sender,
                                                                     GObject* object,
                                                                     gpointer self)
{
#line 26 "../src/baobab-window.vala"
	baobab_window_contents_cell_bind ((BaobabWindow*) self, object);
#line 4399 "baobab-window.c"
}

static void
baobab_window_contents_cell_unbind (BaobabWindow* self,
                                    GObject* object)
{
	GtkColumnViewCell* item = NULL;
	GtkColumnViewCell* _tmp0_;
	BaobabContentsCell* child = NULL;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	BaobabContentsCell* _tmp3_;
#line 766 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 766 "../src/baobab-window.vala"
	g_return_if_fail (object != NULL);
#line 767 "../src/baobab-window.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (object, gtk_column_view_cell_get_type ()) ? ((GtkColumnViewCell*) object) : NULL);
#line 767 "../src/baobab-window.vala"
	item = _tmp0_;
#line 768 "../src/baobab-window.vala"
	_tmp1_ = gtk_column_view_cell_get_child (item);
#line 768 "../src/baobab-window.vala"
	_tmp2_ = _tmp1_;
#line 768 "../src/baobab-window.vala"
	_tmp3_ = _g_object_ref0 (BAOBAB_IS_CONTENTS_CELL (_tmp2_) ? ((BaobabContentsCell*) _tmp2_) : NULL);
#line 768 "../src/baobab-window.vala"
	child = _tmp3_;
#line 769 "../src/baobab-window.vala"
	baobab_contents_cell_set_item (child, NULL);
#line 766 "../src/baobab-window.vala"
	_g_object_unref0 (child);
#line 766 "../src/baobab-window.vala"
	_g_object_unref0 (item);
#line 4434 "baobab-window.c"
}

static void
_baobab_window_contents_cell_unbind_gtk_signal_list_item_factory_unbind (GtkSignalListItemFactory* _sender,
                                                                         GObject* object,
                                                                         gpointer self)
{
#line 26 "../src/baobab-window.vala"
	baobab_window_contents_cell_unbind ((BaobabWindow*) self, object);
#line 4444 "baobab-window.c"
}

static void
baobab_window_contents_cell_teardown (BaobabWindow* self,
                                      GObject* object)
{
	GtkColumnViewCell* item = NULL;
	GtkColumnViewCell* _tmp0_;
	BaobabFolderDisplay* _tmp1_;
	GtkSizeGroup* _tmp2_;
	GtkSizeGroup* _tmp3_;
	GtkWidget* _tmp4_;
	GtkWidget* _tmp5_;
#line 773 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 773 "../src/baobab-window.vala"
	g_return_if_fail (object != NULL);
#line 774 "../src/baobab-window.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (object, gtk_column_view_cell_get_type ()) ? ((GtkColumnViewCell*) object) : NULL);
#line 774 "../src/baobab-window.vala"
	item = _tmp0_;
#line 775 "../src/baobab-window.vala"
	_tmp1_ = self->priv->folder_display;
#line 775 "../src/baobab-window.vala"
	_tmp2_ = baobab_folder_display_get_contents_size_group (_tmp1_);
#line 775 "../src/baobab-window.vala"
	_tmp3_ = _tmp2_;
#line 775 "../src/baobab-window.vala"
	_tmp4_ = gtk_column_view_cell_get_child (item);
#line 775 "../src/baobab-window.vala"
	_tmp5_ = _tmp4_;
#line 775 "../src/baobab-window.vala"
	gtk_size_group_remove_widget (_tmp3_, _tmp5_);
#line 773 "../src/baobab-window.vala"
	_g_object_unref0 (item);
#line 4480 "baobab-window.c"
}

static void
_baobab_window_contents_cell_teardown_gtk_signal_list_item_factory_teardown (GtkSignalListItemFactory* _sender,
                                                                             GObject* object,
                                                                             gpointer self)
{
#line 26 "../src/baobab-window.vala"
	baobab_window_contents_cell_teardown ((BaobabWindow*) self, object);
#line 4490 "baobab-window.c"
}

static void
baobab_window_time_modified_cell_setup (BaobabWindow* self,
                                        GObject* object)
{
	GtkColumnViewCell* item = NULL;
	GtkColumnViewCell* _tmp0_;
	BaobabTimeModifiedCell* child = NULL;
	BaobabTimeModifiedCell* _tmp1_;
	BaobabFolderDisplay* _tmp2_;
	GtkSizeGroup* _tmp3_;
	GtkSizeGroup* _tmp4_;
	GtkWidget* _tmp5_;
	GtkWidget* _tmp6_;
#line 779 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 779 "../src/baobab-window.vala"
	g_return_if_fail (object != NULL);
#line 780 "../src/baobab-window.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (object, gtk_column_view_cell_get_type ()) ? ((GtkColumnViewCell*) object) : NULL);
#line 780 "../src/baobab-window.vala"
	item = _tmp0_;
#line 781 "../src/baobab-window.vala"
	_tmp1_ = baobab_time_modified_cell_new ();
#line 781 "../src/baobab-window.vala"
	g_object_ref_sink (_tmp1_);
#line 781 "../src/baobab-window.vala"
	child = _tmp1_;
#line 782 "../src/baobab-window.vala"
	gtk_column_view_cell_set_child (item, (GtkWidget*) child);
#line 783 "../src/baobab-window.vala"
	_tmp2_ = self->priv->folder_display;
#line 783 "../src/baobab-window.vala"
	_tmp3_ = baobab_folder_display_get_time_modified_size_group (_tmp2_);
#line 783 "../src/baobab-window.vala"
	_tmp4_ = _tmp3_;
#line 783 "../src/baobab-window.vala"
	_tmp5_ = gtk_column_view_cell_get_child (item);
#line 783 "../src/baobab-window.vala"
	_tmp6_ = _tmp5_;
#line 783 "../src/baobab-window.vala"
	gtk_size_group_add_widget (_tmp4_, _tmp6_);
#line 779 "../src/baobab-window.vala"
	_g_object_unref0 (child);
#line 779 "../src/baobab-window.vala"
	_g_object_unref0 (item);
#line 4538 "baobab-window.c"
}

static void
_baobab_window_time_modified_cell_setup_gtk_signal_list_item_factory_setup (GtkSignalListItemFactory* _sender,
                                                                            GObject* object,
                                                                            gpointer self)
{
#line 26 "../src/baobab-window.vala"
	baobab_window_time_modified_cell_setup ((BaobabWindow*) self, object);
#line 4548 "baobab-window.c"
}

static void
baobab_window_time_modified_cell_bind (BaobabWindow* self,
                                       GObject* object)
{
	GtkColumnViewCell* item = NULL;
	GtkColumnViewCell* _tmp0_;
	GtkTreeListRow* row = NULL;
	GObject* _tmp1_;
	GObject* _tmp2_;
	GtkTreeListRow* _tmp3_;
	BaobabScannerResults* results = NULL;
	GObject* _tmp4_;
	GObject* _tmp5_;
	BaobabScannerResults* _tmp6_;
	BaobabTimeModifiedCell* child = NULL;
	GtkWidget* _tmp7_;
	GtkWidget* _tmp8_;
	BaobabTimeModifiedCell* _tmp9_;
#line 787 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 787 "../src/baobab-window.vala"
	g_return_if_fail (object != NULL);
#line 788 "../src/baobab-window.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (object, gtk_column_view_cell_get_type ()) ? ((GtkColumnViewCell*) object) : NULL);
#line 788 "../src/baobab-window.vala"
	item = _tmp0_;
#line 789 "../src/baobab-window.vala"
	_tmp1_ = gtk_column_view_cell_get_item (item);
#line 789 "../src/baobab-window.vala"
	_tmp2_ = _tmp1_;
#line 789 "../src/baobab-window.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gtk_tree_list_row_get_type ()) ? ((GtkTreeListRow*) _tmp2_) : NULL);
#line 789 "../src/baobab-window.vala"
	row = _tmp3_;
#line 790 "../src/baobab-window.vala"
	_tmp4_ = gtk_tree_list_row_get_item (row);
#line 790 "../src/baobab-window.vala"
	_tmp5_ = _tmp4_;
#line 790 "../src/baobab-window.vala"
	_tmp6_ = BAOBAB_SCANNER_IS_RESULTS (_tmp5_) ? ((BaobabScannerResults*) _tmp5_) : NULL;
#line 790 "../src/baobab-window.vala"
	if (_tmp6_ == NULL) {
#line 790 "../src/baobab-window.vala"
		_g_object_unref0 (_tmp5_);
#line 4595 "baobab-window.c"
	}
#line 790 "../src/baobab-window.vala"
	results = _tmp6_;
#line 791 "../src/baobab-window.vala"
	_tmp7_ = gtk_column_view_cell_get_child (item);
#line 791 "../src/baobab-window.vala"
	_tmp8_ = _tmp7_;
#line 791 "../src/baobab-window.vala"
	_tmp9_ = _g_object_ref0 (BAOBAB_IS_TIME_MODIFIED_CELL (_tmp8_) ? ((BaobabTimeModifiedCell*) _tmp8_) : NULL);
#line 791 "../src/baobab-window.vala"
	child = _tmp9_;
#line 792 "../src/baobab-window.vala"
	baobab_time_modified_cell_set_item (child, results);
#line 787 "../src/baobab-window.vala"
	_g_object_unref0 (child);
#line 787 "../src/baobab-window.vala"
	_g_object_unref0 (results);
#line 787 "../src/baobab-window.vala"
	_g_object_unref0 (row);
#line 787 "../src/baobab-window.vala"
	_g_object_unref0 (item);
#line 4617 "baobab-window.c"
}

static void
_baobab_window_time_modified_cell_bind_gtk_signal_list_item_factory_bind (GtkSignalListItemFactory* _sender,
                                                                          GObject* object,
                                                                          gpointer self)
{
#line 26 "../src/baobab-window.vala"
	baobab_window_time_modified_cell_bind ((BaobabWindow*) self, object);
#line 4627 "baobab-window.c"
}

static void
baobab_window_time_modified_cell_unbind (BaobabWindow* self,
                                         GObject* object)
{
	GtkColumnViewCell* item = NULL;
	GtkColumnViewCell* _tmp0_;
	BaobabTimeModifiedCell* child = NULL;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	BaobabTimeModifiedCell* _tmp3_;
#line 796 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 796 "../src/baobab-window.vala"
	g_return_if_fail (object != NULL);
#line 797 "../src/baobab-window.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (object, gtk_column_view_cell_get_type ()) ? ((GtkColumnViewCell*) object) : NULL);
#line 797 "../src/baobab-window.vala"
	item = _tmp0_;
#line 798 "../src/baobab-window.vala"
	_tmp1_ = gtk_column_view_cell_get_child (item);
#line 798 "../src/baobab-window.vala"
	_tmp2_ = _tmp1_;
#line 798 "../src/baobab-window.vala"
	_tmp3_ = _g_object_ref0 (BAOBAB_IS_TIME_MODIFIED_CELL (_tmp2_) ? ((BaobabTimeModifiedCell*) _tmp2_) : NULL);
#line 798 "../src/baobab-window.vala"
	child = _tmp3_;
#line 799 "../src/baobab-window.vala"
	baobab_time_modified_cell_set_item (child, NULL);
#line 796 "../src/baobab-window.vala"
	_g_object_unref0 (child);
#line 796 "../src/baobab-window.vala"
	_g_object_unref0 (item);
#line 4662 "baobab-window.c"
}

static void
_baobab_window_time_modified_cell_unbind_gtk_signal_list_item_factory_unbind (GtkSignalListItemFactory* _sender,
                                                                              GObject* object,
                                                                              gpointer self)
{
#line 26 "../src/baobab-window.vala"
	baobab_window_time_modified_cell_unbind ((BaobabWindow*) self, object);
#line 4672 "baobab-window.c"
}

static void
baobab_window_time_modified_cell_teardown (BaobabWindow* self,
                                           GObject* object)
{
	GtkColumnViewCell* item = NULL;
	GtkColumnViewCell* _tmp0_;
	BaobabFolderDisplay* _tmp1_;
	GtkSizeGroup* _tmp2_;
	GtkSizeGroup* _tmp3_;
	GtkWidget* _tmp4_;
	GtkWidget* _tmp5_;
#line 803 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 803 "../src/baobab-window.vala"
	g_return_if_fail (object != NULL);
#line 804 "../src/baobab-window.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (object, gtk_column_view_cell_get_type ()) ? ((GtkColumnViewCell*) object) : NULL);
#line 804 "../src/baobab-window.vala"
	item = _tmp0_;
#line 805 "../src/baobab-window.vala"
	_tmp1_ = self->priv->folder_display;
#line 805 "../src/baobab-window.vala"
	_tmp2_ = baobab_folder_display_get_time_modified_size_group (_tmp1_);
#line 805 "../src/baobab-window.vala"
	_tmp3_ = _tmp2_;
#line 805 "../src/baobab-window.vala"
	_tmp4_ = gtk_column_view_cell_get_child (item);
#line 805 "../src/baobab-window.vala"
	_tmp5_ = _tmp4_;
#line 805 "../src/baobab-window.vala"
	gtk_size_group_remove_widget (_tmp3_, _tmp5_);
#line 803 "../src/baobab-window.vala"
	_g_object_unref0 (item);
#line 4708 "baobab-window.c"
}

static void
_baobab_window_time_modified_cell_teardown_gtk_signal_list_item_factory_teardown (GtkSignalListItemFactory* _sender,
                                                                                  GObject* object,
                                                                                  gpointer self)
{
#line 26 "../src/baobab-window.vala"
	baobab_window_time_modified_cell_teardown ((BaobabWindow*) self, object);
#line 4718 "baobab-window.c"
}

void
baobab_window_action_state_copy (const BaobabWindowActionState* self,
                                 BaobabWindowActionState* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 92 "../src/baobab-window.vala"
	_tmp0_ = (*self).name;
#line 92 "../src/baobab-window.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 92 "../src/baobab-window.vala"
	_g_free0 ((*dest).name);
#line 92 "../src/baobab-window.vala"
	(*dest).name = _tmp1_;
#line 92 "../src/baobab-window.vala"
	(*dest).enable = (*self).enable;
#line 4737 "baobab-window.c"
}

void
baobab_window_action_state_destroy (BaobabWindowActionState* self)
{
#line 93 "../src/baobab-window.vala"
	_g_free0 ((*self).name);
#line 4745 "baobab-window.c"
}

BaobabWindowActionState*
baobab_window_action_state_dup (const BaobabWindowActionState* self)
{
	BaobabWindowActionState* dup;
#line 92 "../src/baobab-window.vala"
	dup = g_new0 (BaobabWindowActionState, 1);
#line 92 "../src/baobab-window.vala"
	baobab_window_action_state_copy (self, dup);
#line 92 "../src/baobab-window.vala"
	return dup;
#line 4758 "baobab-window.c"
}

void
baobab_window_action_state_free (BaobabWindowActionState* self)
{
#line 92 "../src/baobab-window.vala"
	baobab_window_action_state_destroy (self);
#line 92 "../src/baobab-window.vala"
	g_free (self);
#line 4768 "baobab-window.c"
}

static GType
baobab_window_action_state_get_type_once (void)
{
	GType baobab_window_action_state_type_id;
	baobab_window_action_state_type_id = g_boxed_type_register_static ("BaobabWindowActionState", (GBoxedCopyFunc) baobab_window_action_state_dup, (GBoxedFreeFunc) baobab_window_action_state_free);
	return baobab_window_action_state_type_id;
}

GType
baobab_window_action_state_get_type (void)
{
	static volatile gsize baobab_window_action_state_type_id__once = 0;
	if (g_once_init_enter (&baobab_window_action_state_type_id__once)) {
		GType baobab_window_action_state_type_id;
		baobab_window_action_state_type_id = baobab_window_action_state_get_type_once ();
		g_once_init_leave (&baobab_window_action_state_type_id__once, baobab_window_action_state_type_id);
	}
	return baobab_window_action_state_type_id__once;
}

static void
baobab_window_class_init (BaobabWindowClass * klass,
                          gpointer klass_data)
{
#line 26 "../src/baobab-window.vala"
	baobab_window_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/baobab-window.vala"
	g_type_class_adjust_private_offset (klass, &BaobabWindow_private_offset);
#line 26 "../src/baobab-window.vala"
	G_OBJECT_CLASS (klass)->finalize = baobab_window_finalize;
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/baobab/ui/baobab-main-window.ui");
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "focus_controller", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, focus_controller));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "drop_target", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, drop_target));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "pathbar", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, pathbar));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "nav_view", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, nav_view));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "home_page", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, home_page));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "result_page", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, result_page));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "toast_overlay", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, toast_overlay));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "banner", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, banner));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "location_list", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, location_list));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "folder_display", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, folder_display));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "columnview", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, columnview));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "columnview_selection", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, columnview_selection));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "columnview_sort_model", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, columnview_sort_model));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "treeview_popover_menu", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, treeview_popover_menu));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "chart_stack", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, chart_stack));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "spinner_stack", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, spinner_stack));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "chart_stack_switcher", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, chart_stack_switcher));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "rings_chart", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, rings_chart));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "treemap_chart", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, treemap_chart));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "spinner", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, spinner));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "results_hidden", G_CALLBACK(_baobab_window_results_hidden_adw_navigation_page_hidden));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "treeview_right_click_gesture_pressed", G_CALLBACK(_baobab_window_treeview_right_click_gesture_pressed_gtk_gesture_click_pressed));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "columnview_activate", G_CALLBACK(_baobab_window_columnview_activate_gtk_column_view_activate));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "folder_cell_setup", G_CALLBACK(_baobab_window_folder_cell_setup_gtk_signal_list_item_factory_setup));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "folder_cell_bind", G_CALLBACK(_baobab_window_folder_cell_bind_gtk_signal_list_item_factory_bind));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "folder_cell_unbind", G_CALLBACK(_baobab_window_folder_cell_unbind_gtk_signal_list_item_factory_unbind));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "folder_cell_teardown", G_CALLBACK(_baobab_window_folder_cell_teardown_gtk_signal_list_item_factory_teardown));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "size_cell_setup", G_CALLBACK(_baobab_window_size_cell_setup_gtk_signal_list_item_factory_setup));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "size_cell_bind", G_CALLBACK(_baobab_window_size_cell_bind_gtk_signal_list_item_factory_bind));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "size_cell_unbind", G_CALLBACK(_baobab_window_size_cell_unbind_gtk_signal_list_item_factory_unbind));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "size_cell_teardown", G_CALLBACK(_baobab_window_size_cell_teardown_gtk_signal_list_item_factory_teardown));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "contents_cell_setup", G_CALLBACK(_baobab_window_contents_cell_setup_gtk_signal_list_item_factory_setup));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "contents_cell_bind", G_CALLBACK(_baobab_window_contents_cell_bind_gtk_signal_list_item_factory_bind));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "contents_cell_unbind", G_CALLBACK(_baobab_window_contents_cell_unbind_gtk_signal_list_item_factory_unbind));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "contents_cell_teardown", G_CALLBACK(_baobab_window_contents_cell_teardown_gtk_signal_list_item_factory_teardown));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "time_modified_cell_setup", G_CALLBACK(_baobab_window_time_modified_cell_setup_gtk_signal_list_item_factory_setup));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "time_modified_cell_bind", G_CALLBACK(_baobab_window_time_modified_cell_bind_gtk_signal_list_item_factory_bind));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "time_modified_cell_unbind", G_CALLBACK(_baobab_window_time_modified_cell_unbind_gtk_signal_list_item_factory_unbind));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "time_modified_cell_teardown", G_CALLBACK(_baobab_window_time_modified_cell_teardown_gtk_signal_list_item_factory_teardown));
#line 4881 "baobab-window.c"
}

static void
baobab_window_instance_init (BaobabWindow * self,
                             gpointer klass)
{
#line 26 "../src/baobab-window.vala"
	self->priv = baobab_window_get_instance_private (self);
#line 68 "../src/baobab-window.vala"
	self->priv->active_location = NULL;
#line 69 "../src/baobab-window.vala"
	self->priv->is_busy = FALSE;
#line 70 "../src/baobab-window.vala"
	self->priv->scan_completed_handler = (gulong) 0;
#line 71 "../src/baobab-window.vala"
	self->priv->scanning_progress_id = (guint) 0;
#line 26 "../src/baobab-window.vala"
	g_type_ensure (BAOBAB_TYPE_PATHBAR);
#line 26 "../src/baobab-window.vala"
	g_type_ensure (BAOBAB_TYPE_LOCATION_LIST);
#line 26 "../src/baobab-window.vala"
	g_type_ensure (BAOBAB_TYPE_FOLDER_DISPLAY);
#line 26 "../src/baobab-window.vala"
	g_type_ensure (BAOBAB_TYPE_CHART);
#line 26 "../src/baobab-window.vala"
	g_type_ensure (BAOBAB_TYPE_CHART);
#line 26 "../src/baobab-window.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 4910 "baobab-window.c"
}

static void
baobab_window_finalize (GObject * obj)
{
	BaobabWindow * self;
#line 26 "../src/baobab-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BAOBAB_TYPE_WINDOW, BaobabWindow);
#line 68 "../src/baobab-window.vala"
	_baobab_location_unref0 (self->priv->active_location);
#line 26 "../src/baobab-window.vala"
	G_OBJECT_CLASS (baobab_window_parent_class)->finalize (obj);
#line 4923 "baobab-window.c"
}

static GType
baobab_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BaobabWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) baobab_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BaobabWindow), 0, (GInstanceInitFunc) baobab_window_instance_init, NULL };
	GType baobab_window_type_id;
	baobab_window_type_id = g_type_register_static (adw_application_window_get_type (), "BaobabWindow", &g_define_type_info, 0);
	BaobabWindow_private_offset = g_type_add_instance_private (baobab_window_type_id, sizeof (BaobabWindowPrivate));
	return baobab_window_type_id;
}

GType
baobab_window_get_type (void)
{
	static volatile gsize baobab_window_type_id__once = 0;
	if (g_once_init_enter (&baobab_window_type_id__once)) {
		GType baobab_window_type_id;
		baobab_window_type_id = baobab_window_get_type_once ();
		g_once_init_leave (&baobab_window_type_id__once, baobab_window_type_id);
	}
	return baobab_window_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 64 "../src/baobab-progress-cell.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 4955 "baobab-window.c"
		gssize i;
#line 64 "../src/baobab-progress-cell.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 64 "../src/baobab-progress-cell.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 64 "../src/baobab-progress-cell.vala"
				destroy_func (((gpointer*) array)[i]);
#line 4963 "baobab-window.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 64 "../src/baobab-progress-cell.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 64 "../src/baobab-progress-cell.vala"
	g_free (array);
#line 4978 "baobab-window.c"
}

